VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "AnchorObject"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Anchors
' Class: AnchorObject
' By neophile (n_e_o_p_h_i_l_e@yahoo.com)
' 5/28/2002
' -----------------------------------------------
' MODIFIED JANUARY 2006 TO ALLOW FOR DIFFERENT ANCHOR TYPES
' JEFF JENNESS (jeffj@jennessent.com)
'

Option Explicit

Private mCtl As Control    ' Control reference
Private mX As Anchor       ' X anchor
Private mY As Anchor       ' Y anchor
Private mX2 As Anchor      ' X2 anchor
Private mY2 As Anchor      ' Y2 anchor
Private mWidth As Anchor   ' Width anchor
Private mHeight As Anchor  ' Height anchor

Public Property Let Control(vData As Control)
21:    Set mCtl = vData  ' Set reference
End Property
Public Property Get Control() As Control
24:    Set Control = mCtl  ' Return reference
End Property

Public Property Get X() As Anchor
28:    Set X = mX  ' Return X anchor
End Property

Public Property Get Y() As Anchor
32:    Set Y = mY  ' Return Y anchor
End Property

Public Property Get X2() As Anchor
36:    Set X2 = mX2  ' Return X anchor
End Property

Public Property Get Y2() As Anchor
40:    Set Y2 = mY2  ' Return Y anchor
End Property

Public Sub SetAnchors(Optional ByVal XType As AnchorTypes, Optional ByVal YType As AnchorTypes)

45:    X.AnchorType = XType  ' Set X anchor type
   
   Select Case XType  ' X anchor
   
      Case enumNone        ' Avenue Fastener ( - , - , - )
50:         mX.Value = mCtl.Left / mCtl.Container.Width
51:         mWidth.Value = mCtl.Width / mCtl.Container.Width
      Case enumStart       ' Avenue Fastener (Left, - , - )   DON'T ADJUST X AT ALL!
      
54:         mX.Value = mCtl.Left
55:         mWidth.Value = (mCtl.Width / mCtl.Container.Width)
56:         Debug.Print mCtl.Width
57:         Debug.Print mCtl.Container.Width
58:         Debug.Print (mCtl.Width / mCtl.Container.Width)
59:         Debug.Print mWidth.Value
        
      Case enumStartSize   ' Avenue Fastener (Left, Width/, - )
62:         mX.Value = mCtl.Left
63:         mWidth.Value = mCtl.Width
        
      Case enumStartEnd    ' Avenue Fastener (Left, - , Right )
66:         mX.Value = mCtl.Left
67:         mWidth.Value = mCtl.Container.Width - mCtl.Width
        
      Case enumSize        ' Avenue Fastener ( - , Width, - )
70:         mX.Value = ((mCtl.Left + (mCtl.Width / 2)) / mCtl.Container.Width)
71:         mX2.Value = mCtl.Width / 2
72:         mWidth.Value = mCtl.Width
        
      Case enumSizeEnd     ' Avenue Fastener ( - , Width, Right)
75:         mX.Value = mCtl.Container.Width - mCtl.Left
76:         mWidth.Value = mCtl.Width
        
      Case enumEnd         ' Avenue Fastener ( - , - , Right)
79:         mX.Value = mCtl.Width / mCtl.Container.Width
80:         mX2.Value = mCtl.Container.Width - mCtl.Width - mCtl.Left
81:         mWidth.Value = mCtl.Width / mCtl.Container.Width
        
83:    End Select
   
85:    Y.AnchorType = YType  ' Set Y anchor type
   
   Select Case YType  ' Y anchor
   
      Case enumNone        ' Avenue Fastener ( - , - , - )
90:         mY.Value = mCtl.Top / mCtl.Container.Height
91:         mHeight.Value = mCtl.Height / mCtl.Container.Height
        
      Case enumStart       ' Avenue Fastener (Top, - , - )   DON'T ADJUST Y AT ALL!
94:         mY.Value = mCtl.Top
95:         mHeight.Value = mCtl.Height / mCtl.Container.Height
        
      Case enumStartSize   ' Avenue Fastener (Top, Height, - )
98:         mY.Value = mCtl.Top
        
      Case enumStartEnd    ' Avenue Fastener (Top, - , Bottom )
101:         mY.Value = mCtl.Top
102:         mHeight.Value = mCtl.Container.Height - mCtl.Height
        
      Case enumSize        ' Avenue Fastener ( - , Height, - )
105:         mY.Value = ((mCtl.Top + (mCtl.Height / 2)) / mCtl.Container.Height)
106:         mY2.Value = mCtl.Height / 2
        
      Case enumSizeEnd     ' Avenue Fastener ( - , Height, Bottom)
109:         mY.Value = mCtl.Container.Height - mCtl.Top
        
      Case enumEnd         ' Avenue Fastener ( - , - , Bottom)
112:         mY.Value = mCtl.Height / mCtl.Container.Height
113:         mY2.Value = mCtl.Container.Height - mCtl.Height - mCtl.Top
114:         mHeight.Value = mCtl.Height / mCtl.Container.Height
        
116:    End Select

End Sub

Public Sub DoAnchors()

   On Error Resume Next  ' Ignore errors
   
   Select Case mX.AnchorType  ' X anchor
   
      Case enumNone        ' Avenue Fastener ( - , - , - )
127:         mCtl.Left = mCtl.Container.Width * mX.Value
128:         mCtl.Width = mCtl.Container.Width * mWidth.Value
'         If mCtl.Left < mX.MinValue Then mCtl.Left = mX.MinValue  ' Lower limit
'         If mCtl.Left > mX.MaxValue Then mCtl.Left = mX.MaxValue  ' Upper limit

      Case enumStart       ' Avenue Fastener (Left, - , - )   DON'T ADJUST Y AT ALL!
'        mCtl.Left = mX.Value
134:         mCtl.Width = mCtl.Container.Width * mWidth.Value
'         If mCtl.Left < mX.MinValue Then mCtl.Left = mX.MinValue  ' Lower limit
'         If mCtl.Left > mX.MaxValue Then mCtl.Left = mX.MaxValue  ' Upper limit

      Case enumStartSize   ' Avenue Fastener (Left, Width, - )
'        mCtl.Left = mX.Value
'         If mCtl.Left < mX.MinValue Then mCtl.Left = mX.MinValue  ' Lower limit
'         If mCtl.Left > mX.MaxValue Then mCtl.Left = mX.MaxValue  ' Upper limit

      Case enumStartEnd    ' Avenue Fastener (Left, - , Right )
'        mCtl.Left = mX.Value

146:         mCtl.Width = mCtl.Container.Width - mWidth.Value
'         If mCtl.Left < mX.MinValue Then mCtl.Left = mX.MinValue  ' Lower limit
'         If mCtl.Left > mX.MaxValue Then mCtl.Left = mX.MaxValue  ' Upper limit

      Case enumSize        ' Avenue Fastener ( - , Width, - )
151:         mCtl.Left = (mCtl.Container.Width * mX.Value) - mX2.Value
'         If mCtl.Left < mX.MinValue Then mCtl.Left = mX.MinValue  ' Lower limit
'         If mCtl.Left > mX.MaxValue Then mCtl.Left = mX.MaxValue  ' Upper limit

      Case enumSizeEnd     ' Avenue Fastener ( - , Width, Right)
156:         mCtl.Left = mCtl.Container.Width - mX.Value
'         If mCtl.Left < mX.MinValue Then mCtl.Left = mX.MinValue  ' Lower limit
'         If mCtl.Left > mX.MaxValue Then mCtl.Left = mX.MaxValue  ' Upper limit

      Case enumEnd         ' Avenue Fastener ( - , - , Right)
161:         mCtl.Left = mCtl.Container.Width - (mCtl.Container.Width * mX.Value) - mX2.Value
162:         mCtl.Width = mCtl.Container.Width * mWidth.Value
'         If mCtl.Left < mX.MinValue Then mCtl.Left = mX.MinValue  ' Lower limit
'         If mCtl.Left > mX.MaxValue Then mCtl.Left = mX.MaxValue  ' Upper limit

166:    End Select
   
   Select Case mY.AnchorType  ' Y anchor
   
      Case enumNone        ' Avenue Fastener ( - , - , - )
171:         mCtl.Top = mCtl.Container.Height * mY.Value
172:         mCtl.Height = mCtl.Container.Height * mHeight.Value
'         If mCtl.Top < mY.MinValue Then mCtl.Top = mY.MinValue  ' Lower limit
'         If mCtl.Top > mY.MaxValue Then mCtl.Top = mY.MaxValue  ' Upper limit

      Case enumStart       ' Avenue Fastener (Top, - , - )   DON'T ADJUST Y AT ALL!
'        mCtl.Top = mY.Value
178:         mCtl.Height = mCtl.Container.Height * mHeight.Value
'         If mCtl.Top < mY.MinValue Then mCtl.Top = mY.MinValue  ' Lower limit
'         If mCtl.Top > mY.MaxValue Then mCtl.Top = mY.MaxValue  ' Upper limit

      Case enumStartSize   ' Avenue Fastener (Top, Height, - )
'        mCtl.Top = mY.Value
'         If mCtl.Top < mY.MinValue Then mCtl.Top = mY.MinValue  ' Lower limit
'         If mCtl.Top > mY.MaxValue Then mCtl.Top = mY.MaxValue  ' Upper limit

      Case enumStartEnd    ' Avenue Fastener (Top, - , Bottom )
'        mCtl.Top = mY.Value
189:         mCtl.Height = mCtl.Container.Height - mHeight.Value
'         If mCtl.Top < mY.MinValue Then mCtl.Top = mY.MinValue  ' Lower limit
'         If mCtl.Top > mY.MaxValue Then mCtl.Top = mY.MaxValue  ' Upper limit

      Case enumSize        ' Avenue Fastener ( - , Height, - )
194:         mCtl.Top = (mCtl.Container.Height * mY.Value) - mY2.Value
'         If mCtl.Top < mY.MinValue Then mCtl.Top = mY.MinValue  ' Lower limit
'         If mCtl.Top > mY.MaxValue Then mCtl.Top = mY.MaxValue  ' Upper limit

      Case enumSizeEnd     ' Avenue Fastener ( - , Height, Bottom)
199:         mCtl.Top = mCtl.Container.Height - mY.Value
'         If mCtl.Top < mY.MinValue Then mCtl.Top = mY.MinValue  ' Lower limit
'         If mCtl.Top > mY.MaxValue Then mCtl.Top = mY.MaxValue  ' Upper limit

      Case enumEnd         ' Avenue Fastener ( - , - , Bottom)
204:         mCtl.Top = mCtl.Container.Height - (mCtl.Container.Height * mY.Value) - mY2.Value
205:         mCtl.Height = mCtl.Container.Height * mHeight.Value
'         If mCtl.Top < mY.MinValue Then mCtl.Top = mY.MinValue  ' Lower limit
'         If mCtl.Top > mY.MaxValue Then mCtl.Top = mY.MaxValue  ' Upper limit

209:    End Select
   On Error GoTo 0  ' Stop ignoring errors
End Sub


Private Sub Class_Initialize()
215:    Set mX = New Anchor       ' Create new anchor instance
216:    Set mY = New Anchor       ' Create new anchor instance
217:    Set mX2 = New Anchor      ' Create new anchor instance
218:    Set mY2 = New Anchor      ' Create new anchor instance
219:    Set mWidth = New Anchor   ' Create new anchor instance
220:    Set mHeight = New Anchor  ' Create new anchor instance
End Sub

Private Sub Class_Terminate()
224:    Set mX = Nothing       ' Discard anchor instance
225:    Set mY = Nothing       ' Discard anchor instance
226:    Set mX2 = Nothing      ' Discard anchor instance
227:    Set mY2 = Nothing      ' Discard anchor instance
228:    Set mWidth = Nothing   ' Discard anchor instance
229:    Set mHeight = Nothing  ' Discard anchor instance
End Sub

