VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "AnchorObjectList"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Anchors
' Class: AnchorObjectList
' By neophile (n_e_o_p_h_i_l_e@yahoo.com)
' 5/28/2002
' -----------------------------------------------
' MODIFIED JANUARY 2006 TO ALLOW FOR DIFFERENT ANCHOR TYPES
' JEFF JENNESS (jeffj@jennessent.com)
'

Option Explicit

Private Declare Function LockWindowUpdate Lib "user32" (ByVal hwndLock As Long) As Long

Private WithEvents mForm As Form  ' Form reference
Attribute mForm.VB_VarHelpID = -1
Private mCol As Collection  ' Item collection


Public Property Let Form(vData As Form)
19:    Set mForm = vData  ' Set reference
End Property
Public Property Get Form() As Form
22:    Set Form = mForm   ' Return reference
End Property

Public Function Count() As Long
26:    Count = mCol.Count  ' Return anchor collection count
End Function

Public Function Item(Control As Control) As AnchorObject
   Dim lIdx As Long
31:    lIdx = IndexOf(Control)  ' Get position in item collection
32:    If lIdx = 0 Then  ' If no item was found...
33:       Set Item = New AnchorObject  ' ...create a new item
34:       Item.Control = Control  ' Set reference
35:       mCol.Add Item  ' Add item to collection
36:    Else
37:       Set Item = mCol(IndexOf(Control))  ' Return item from collection
38:    End If
End Function

Public Function IndexOf(Control As Control) As Long
   Dim l As Long
43:    If mCol.Count > 0 Then  ' If there are any items...
44:       For l = 1 To mCol.Count  ' ...loop through them
45:          If mCol(l) Is Control Then  ' If the refrences match...
46:             IndexOf = l  ' ...return its position
47:             Exit For  ' Stop looping
48:          End If
49:       Next
50:    End If
End Function

Public Sub Remove(Control As Control)
54:    mCol.Remove IndexOf(Control)  ' Remove item from collection
End Sub

Public Sub SetAnchors()
   Dim oAO As AnchorObject
59:    For Each oAO In mCol  ' Loop through items
60:       oAO.SetAnchors  ' Set both anchors
61:    Next
End Sub

Public Sub DoAnchors()
   Dim oAO As AnchorObject
'   If Not (mForm Is Nothing) Then Call LockWindowUpdate(mForm.hWnd)  ' Lock repainting
67:    For Each oAO In mCol  ' Loop through items
68:       oAO.DoAnchors  ' Do both anchors
69:    Next
'   Call LockWindowUpdate(0)  ' Unlock repainting
End Sub


Private Sub mForm_Resize()
75:    Me.DoAnchors  ' Do all anchors
End Sub


Private Sub Class_Initialize()
80:    Set mCol = New Collection  ' Create new collection
End Sub

Private Sub Class_Terminate()
84:    Set mCol = Nothing  ' Discard collection
End Sub


