Attribute VB_Name = "CircScapeFunctions"
Option Explicit
' Variables used by the Error handler function - DO NOT REMOVE
Const c_sModuleFileName As String = "D:\arcGIS_stuff\consultation\az_linkages\VB_Code\Brad_Convert\CircScapeFunctions.bas"


Public Function ExportRastersToAscii(pDocParams As esriSystem.IVariantArray, _
    pParams As esriSystem.IVariantArray) As String
  On Error GoTo ErrorHandler
  
  Dim datTimeBegan As Date
11:   datTimeBegan = Now
  
  Dim pApp As IApplication
  Dim pThisExt As Brad_Convert.clsExtension
  Dim pMxDoc As IMxDocument
  
17:   Set pApp = pDocParams.Element(0)
18:   Set pThisExt = pDocParams.Element(1)
19:   Set pMxDoc = pDocParams.Element(2)
  
  ' RETURN ARRAY CONTAINS THE FOLLOWING:
  ' 0) IRasterLayer:  TEMPLATE RASTER LAYER
  ' 1) IVariantArray:  ADDITIONAL RASTER LAYERS; COULD BE EMPTY
  ' 2) String:  OUTPUT FOLDER TO SAVE ASCII RASTERS
  Dim pTemplate As IRasterLayer
  Dim pTemplateRaster As IRaster
  Dim pTemplateProps As IRasterProps
  Dim pTemplateSpRef As ISpatialReference
  Dim pTemplatePnt As IPnt
  
31:   Set pTemplate = pParams.Element(0)
32:   Set pTemplateRaster = pTemplate.Raster
33:   Set pTemplateProps = pTemplateRaster
34:   Set pTemplateSpRef = pTemplateProps.SpatialReference
35:   Set pTemplatePnt = pTemplateProps.MeanCellSize
  
  Dim booShouldClip As Boolean
  Dim pClipLayer As IFeatureLayer
  
  Dim pAdditionalRasters As esriSystem.IVariantArray
41:   Set pAdditionalRasters = pParams.Element(1)
  Dim pAdditionalFeatLayers As esriSystem.IVariantArray
43:   Set pAdditionalFeatLayers = pParams.Element(2)
  Dim strOutputFolder As String
45:   strOutputFolder = pParams.Element(3)
  Dim booAllHaveNoSpRef As Boolean
47:   booShouldClip = pParams.Element(4)
48:   Set pClipLayer = pParams.Element(5)
49:   booAllHaveNoSpRef = pParams.Element(6)
  
  ' CONVERT CLIP LAYER INTO IN-MEMORY FEATURE CLASS WITH SAME SPATIAL REFERENCE AS TEMPLATE
  Dim pInMemFClass As IFeatureClass
  Dim pGeomArray As esriSystem.IArray
  Dim pClipGeoDataset As IGeoDataset
  Dim pClipCursor As IFeatureCursor
  Dim pClipFeature As IFeature
  Dim pClipPolygon As IPolygon
58:   If booShouldClip Then
59:     Set pClipGeoDataset = pClipLayer.FeatureClass
60:     If Not Brad_Convert.MyGeneralOperations.CompareSpatialReferences(pClipGeoDataset.SpatialReference, pTemplateSpRef) Then
61:       Set pGeomArray = New esriSystem.Array
62:       Set pClipCursor = pClipLayer.FeatureClass.Search(Nothing, True)
63:       Set pClipFeature = pClipCursor.NextFeature
64:       Do Until pClipFeature Is Nothing
65:         Set pClipPolygon = pClipFeature.ShapeCopy
66:         pClipPolygon.Project pTemplateSpRef
67:         pGeomArray.Add pClipPolygon
68:         Set pClipFeature = pClipCursor.NextFeature
69:       Loop
70:       Set pInMemFClass = Brad_Convert.MyGeneralOperations.CreateInMemoryFeatureClass(pGeomArray)
71:     Else
72:       Set pInMemFClass = pClipLayer.FeatureClass
73:     End If
74:   End If
  
  Dim booAlreadyHasInfoFolder As Boolean
77:   booAlreadyHasInfoFolder = Brad_Convert.aml_func_mod.ExistFileDir(strOutputFolder & "info")
'  MsgBox "booAlreadyHasInfoFolder = " & CStr(booAlreadyHasInfoFolder)
  
  ' FOR PROGRESS
  Dim lngWorkOrderCount As Long
  Dim lngWorkOrderCounter As Long
83:   lngWorkOrderCount = pAdditionalRasters.Count + 1 + (2 * pAdditionalFeatLayers.Count)
84:   lngWorkOrderCounter = 0
  
    ' PROGRESS BAR STUFF
  Dim psbar As IStatusBar
88:   Set psbar = pApp.StatusBar
  Dim pPro As IStepProgressor
90:   Set pPro = psbar.ProgressBar
  
  Dim pAddLayer As IRasterLayer
  Dim lngIndex As Long
  
  Dim strReport As String
96:   strReport = "Function failed..."
  
  ' WORKSPACE
  Dim pWSFact As IWorkspaceFactory
100:   Set pWSFact = New RasterWorkspaceFactory
  Dim pWS As IRasterWorkspace
  Dim strWsName As String
103:   strWsName = strOutputFolder
104:   If Right(strWsName, 1) = "\" Then
'    strWsName = strWsName & "\"
106:     strWsName = Left(strWsName, Len(strWsName) - 1)
107:   End If
108:   Set pWS = pWSFact.OpenFromFile(strWsName, 0)
  Dim pOutputNames As esriSystem.IStringArray
110:   Set pOutputNames = New esriSystem.strArray
  Dim strNewName As String
  
  Dim pWorkspace As IWorkspace
114:   Set pWorkspace = pWS
'  MsgBox "Workspace Path = " & pWorkspace.PathName & vbCrLf & "Is Directory = " & CStr(pWorkspace.IsDirectory)
  
  Dim strTemplateName As String
118:   strTemplateName = Brad_Convert.MyGeneralOperations.ReplaceBadChars(pTemplate.Name, True, True, True, False) & ".asc"
119:   strTemplateName = MyGeneralOperations.MakeUniqueShapeFilename(strWsName & "\" & strTemplateName)
  
121:   ExportRastersToAscii = strReport
  
  ' DO ANALYSIS
124:   lngWorkOrderCounter = lngWorkOrderCounter + 1
125:   psbar.ShowProgressBar "Exporting " & pTemplate.Name & " to " & strTemplateName & "...", 1, lngWorkOrderCount, lngWorkOrderCounter, True
126:   DoEvents
  
  Dim pRastExportOp As IRasterExportOp
129:   Set pRastExportOp = New RasterConversionOp
  Dim pRastAnEnv As IRasterAnalysisEnvironment
131:   Set pRastAnEnv = pRastExportOp
  
  Dim dblCellSize As Double
134:   dblCellSize = (pTemplatePnt.X + pTemplatePnt.Y) / 2
  Dim pEnv As IEnvelope
136:   Set pEnv = pTemplateProps.Extent
137:   pEnv.Expand -(pTemplatePnt.X) / 10, -(pTemplatePnt.Y) / 10, False
138:   Set pRastAnEnv.OutSpatialReference = pTemplateSpRef
139:   Set pRastAnEnv.OutWorkspace = pWS
140:   pRastAnEnv.SetCellSize esriRasterEnvValue, dblCellSize
141:   pRastAnEnv.SetExtent esriRasterEnvValue, pEnv, pTemplateRaster
142:   If booShouldClip Then
143:     Set pRastAnEnv.Mask = pInMemFClass
144:   End If
  
  ' EXPORT TEMPLATE RASTER
147:   pRastExportOp.ExportToASCII pTemplateRaster, strTemplateName
  
  ' EXPORT ADDITIONAL RASTERS
  Dim pAddRaster As IRaster
151:   For lngIndex = 0 To pAdditionalRasters.Count - 1
152:     Set pAddLayer = pAdditionalRasters.Element(lngIndex)
153:     Set pAddRaster = pAddLayer.Raster
154:     strNewName = Brad_Convert.MyGeneralOperations.ReplaceBadChars(pAddLayer.Name, True, True, True, False) & ".asc"
155:     strNewName = Brad_Convert.MyGeneralOperations.MakeUniqueShapeFilename(strWsName & "\" & strNewName)
156:     pOutputNames.Add strNewName
    
158:     lngWorkOrderCounter = lngWorkOrderCounter + 1
159:     psbar.Message(1) = "Exporting " & pAddLayer.Name & " to " & strNewName & "..."
160:     pPro.Step
161:     DoEvents
    
163:     pRastExportOp.ExportToASCII pAddRaster, strNewName
164:   Next lngIndex
  
  ' EXPORT ADDITIONAL FEATURE CLASSES
  Dim pAddFeatLayer As IFeatureLayer
  Dim pOutputFNames As esriSystem.IStringArray
169:   Set pOutputFNames = New esriSystem.strArray
  Dim pTempConversionRasterDataset As IRasterDataset
  Dim pConOp As IConversionOp
172:   Set pConOp = New RasterConversionOp
  Dim pTempAnEnv As IRasterAnalysisEnvironment
174:   Set pTempAnEnv = pConOp
175:   Set pTempAnEnv.OutSpatialReference = pTemplateSpRef
176:   Set pTempAnEnv.OutWorkspace = pWS
177:   pTempAnEnv.SetCellSize esriRasterEnvValue, dblCellSize
178:   pTempAnEnv.SetExtent esriRasterEnvValue, pEnv, pTemplateRaster
179:   If booShouldClip Then
180:     Set pTempAnEnv.Mask = pInMemFClass
181:   End If
  
  ' ADDED OCT 31 2009
  Dim pFeatClassDesc As IFeatureClassDescriptor
  Dim pFeatClass As IFeatureClass
  Dim pField As IField
  Dim pSubArray As esriSystem.IVariantArray
  
  
  Dim pFeatGeoDataset As IGeoDataset
  Dim pTempRastDataset As IDataset
  Dim strTempName As String
  
194:   For lngIndex = 0 To pAdditionalFeatLayers.Count - 1
195:     Set pSubArray = pAdditionalFeatLayers.Element(lngIndex)
196:     Set pAddFeatLayer = pSubArray.Element(0)
197:     Set pField = pSubArray.Element(1)
198:     Set pFeatClass = pAddFeatLayer.FeatureClass
199:     Set pFeatGeoDataset = pFeatClass
200:     strNewName = Brad_Convert.MyGeneralOperations.ReplaceBadChars(pAddFeatLayer.Name, True, True, True, False) & ".asc"
201:     strNewName = Brad_Convert.MyGeneralOperations.MakeUniqueShapeFilename(strWsName & "\" & strNewName)
202:     strTempName = Brad_Convert.MyGeneralOperations.MakeUniqueShapeFilename(strWsName & "\" & "CS_Temp")
203:     strTempName = Brad_Convert.aml_func_mod.ReturnFilename(strTempName)
204:     pOutputFNames.Add strNewName
    
206:     lngWorkOrderCounter = lngWorkOrderCounter + 1
207:     psbar.ShowProgressBar "Exporting " & pAddFeatLayer.Name & " to " & strTempName & "...", 1, lngWorkOrderCount, lngWorkOrderCounter, True
'    pPro.Step
209:     DoEvents
    
211:     Set pFeatClassDesc = New FeatureClassDescriptor
212:     pFeatClassDesc.Create pFeatClass, Nothing, pField.Name
    
214:     Set pTempConversionRasterDataset = pConOp.ToRasterDataset(pFeatClassDesc, "GRID", pWS, strTempName)
215:     Set pTempRastDataset = pTempConversionRasterDataset
    
217:     lngWorkOrderCounter = lngWorkOrderCounter + 1
218:     psbar.ShowProgressBar "Exporting " & strTempName & " to " & strNewName & "...", 1, lngWorkOrderCount, lngWorkOrderCounter, True
'    pPro.Step
220:     DoEvents
    
222:     pRastExportOp.ExportToASCII pTempConversionRasterDataset, strNewName
    
224:     Set pTempConversionRasterDataset = Nothing
225:     If pTempRastDataset.CanDelete Then
226:       pTempRastDataset.DELETE
227:     End If
228:     Set pTempRastDataset = Nothing
    
230:   Next lngIndex
  
232:   pRastAnEnv.RestoreToPreviousDefaultEnvironment
  
234:   psbar.HideProgressBar
235:   pPro.position = 0
  
  Dim strBaseString As String
238:   strBaseString = strBaseString & "{\rtf1\ansi\ansicpg1252\deff0\deflang1033{\fonttbl{\f0\fswiss\fcharset0 Arial;}{\f1\fnil\fcharset0 MS Sans Serif;}}" & vbNewLine
239:   strBaseString = strBaseString & "\viewkind4\uc1\pard\qc\b\f0\fs16 -- Analysis Complete --\b0 " & vbNewLine
240:   strBaseString = strBaseString & "\par \pard " & vbNewLine
241:   strBaseString = strBaseString & "\par \b Template Raster Layer:\b0 " & vbNewLine
242:   strBaseString = strBaseString & "\par   --> Template Layer = " & pTemplate.Name & vbNewLine
243:   strBaseString = strBaseString & "\par   --> Spatial Reference = " & pTemplateSpRef.Name & vbNewLine
244:   strBaseString = strBaseString & "\par   --> Cell Size:  X = " & CStr(pTemplatePnt.X) & ", Y = " & CStr(pTemplatePnt.Y) & vbNewLine
245:   strBaseString = strBaseString & "\par   --> Raster Size:  " & CStr(pTemplateProps.Width) & " Columns, " & _
        CStr(pTemplateProps.Height) & " Rows" & vbNewLine
247:   strBaseString = strBaseString & "\par   --> Saved as '" & Replace(strTemplateName, "\", "\\") & "'" & vbNewLine
248:   strBaseString = strBaseString & "\par " & vbNewLine
249:   strBaseString = strBaseString & "\par \b Additional Rasters Exported:\b0 " & vbNewLine
  
251:   If pAdditionalRasters.Count > 0 Then
252:     For lngIndex = 0 To pAdditionalRasters.Count - 1
253:       Set pAddLayer = pAdditionalRasters.Element(lngIndex)
254:       strNewName = pOutputNames.Element(lngIndex)
255:       strBaseString = strBaseString & "\par   " & CStr(lngIndex + 1) & "] " & pAddLayer.Name & vbNewLine
256:       strBaseString = strBaseString & "\par       --> Saved as '" & Replace(strNewName, "\", "\\") & "'" & vbNewLine
257:     Next lngIndex
258:   Else
259:     strBaseString = strBaseString & "\par   --> None..." & vbNewLine
260:   End If
  
262:   strBaseString = strBaseString & "\par " & vbNewLine
263:   strBaseString = strBaseString & "\par \b Additional Feature Layers Exported:\b0 " & vbNewLine
  
265:   If pAdditionalFeatLayers.Count > 0 Then
266:     For lngIndex = 0 To pAdditionalFeatLayers.Count - 1
267:       Set pSubArray = pAdditionalFeatLayers.Element(lngIndex)
268:       Set pAddFeatLayer = pSubArray.Element(0)
269:       Set pField = pSubArray.Element(1)
 '     Set pAddFeatLayer = pAdditionalFeatLayers.Element(lngIndex)
271:       strNewName = pOutputFNames.Element(lngIndex)
272:       strBaseString = strBaseString & "\par   " & CStr(lngIndex + 1) & "] " & pAddFeatLayer.Name & _
          ",  Attribute Field = [" & pField.Name & "]" & vbNewLine
274:       strBaseString = strBaseString & "\par       --> Saved as '" & Replace(strNewName, "\", "\\") & "'" & vbNewLine
275:     Next lngIndex
276:   Else
277:     strBaseString = strBaseString & "\par   --> None..." & vbNewLine
278:   End If
  
280:   strBaseString = strBaseString & "\par " & vbNewLine
281:   strBaseString = strBaseString & "\par \b Option to Clip Data to Polygon Layer: " & UCase(CStr(booShouldClip)) & "\b0 " & vbNewLine
282:   If booShouldClip Then
283:     strBaseString = strBaseString & "\par   --> Clip Layer = '" & pClipLayer.Name & "'" & vbNewLine
284:   End If
  
286:   strBaseString = strBaseString & "\par " & vbNewLine
287:   strBaseString = strBaseString & "\par \b All ASCII Rasters Exported To:\b0 " & vbNewLine
288:   strBaseString = strBaseString & "\par \pard   --> " & Replace(strOutputFolder, "\", "\\") & vbNewLine
289:   strBaseString = strBaseString & "\par " & vbNewLine
290:   strBaseString = strBaseString & "\par --------------------------- \par " & vbNewLine
291:   strBaseString = strBaseString & Brad_Convert.MyGeneralOperations.ReturnTimeElapsedRTF(datTimeBegan, Now, 7)
292:   strBaseString = strBaseString & "\par }" & vbNewLine
293:   strBaseString = strBaseString & " " & vbNewLine

295:   strReport = strBaseString
  
297:   ExportRastersToAscii = strReport
  

300:   Set pFeatClassDesc = Nothing
301:   Set pFeatClass = Nothing
302:   Set pSubArray = Nothing
303:   Set pField = Nothing
304:   Set pApp = Nothing
305:   Set pThisExt = Nothing
306:   Set pMxDoc = Nothing
307:   Set pTemplate = Nothing
308:   Set pTemplateRaster = Nothing
309:   Set pTemplateProps = Nothing
310:   Set pTemplateSpRef = Nothing
311:   Set pTemplatePnt = Nothing
312:   Set pAdditionalRasters = Nothing
313:   Set pAdditionalFeatLayers = Nothing
314:   Set psbar = Nothing
315:   Set pPro = Nothing
316:   Set pAddLayer = Nothing
317:   Set pWSFact = Nothing
318:   Set pWS = Nothing
319:   Set pOutputNames = Nothing
320:   Set pWorkspace = Nothing
321:   Set pRastExportOp = Nothing
322:   Set pRastAnEnv = Nothing
323:   Set pEnv = Nothing
324:   Set pAddRaster = Nothing
325:   Set pAddFeatLayer = Nothing
326:   Set pOutputFNames = Nothing
327:   Set pTempConversionRasterDataset = Nothing
328:   Set pConOp = Nothing
329:   Set pTempAnEnv = Nothing
330:   Set pFeatGeoDataset = Nothing
331:   Set pTempRastDataset = Nothing


334:   If Not booAlreadyHasInfoFolder Then
335:     If Brad_Convert.aml_func_mod.ExistFileDir(strWsName & "\info") Then
336:       Kill strWsName & "\info\*.*"
337:       RmDir strWsName & "\info"
338:     End If
339:   End If
  
  Exit Function
ErrorHandler:
  HandleError True, "ExportRastersToAscii " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
