Attribute VB_Name = "QuickSort"
Option Explicit
Option Compare Binary
Const c_sModuleFileName As String = "D:\arcGIS_stuff\general_tools\Registration\QuickSort.bas"


''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Copyright 1996-2005 VBnet, Randy Birch, All Rights Reserved.
' Some pages may also contain other copyrights by the author.
' see http://vbnet.mvps.org/index.html?code/sort/qsvariations.htm
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Distribution: You can freely use this code in your own
'               applications, but you may not reproduce
'               or publish this code on any web site,
'               online service, or distribute as source
'               on any media without express permission.
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' MODIFIED JAN. 4, 2006 BY JEFF JENNESS, TO SIMPLIFY IMPLEMENTATION IN ARCGIS
'-----------------------------------------------------------------------------
Public Sub AngleSort(pAngleInDegrees As esriSystem.IDoubleArray, Optional booSortClockwise As Boolean = True, _
    Optional dblCentralAngle As Double = -999)
  On Error GoTo ErrorHandler

    
  Dim dblAngles() As Double
  Dim lngIndex As Long
  ReDim dblAngles(pAngleInDegrees.Count - 1)
  
28:   For lngIndex = 0 To pAngleInDegrees.Count - 1
29:     dblAngles(lngIndex) = pAngleInDegrees.Element(lngIndex)
30:   Next lngIndex
  
32:   DoubleAscending dblAngles, 0, UBound(dblAngles)
  
  
'  Debug.Print
'  Debug.Print "Sorted ..."
'  Dim dblDebugGap As Double
'  Dim strDebugGap As String
'  For lngIndex = 0 To UBound(dblAngles)
'    If lngIndex = 0 Then
'      dblDebugGap = dblAngles(0) + 360 - dblAngles(UBound(dblAngles))
'    Else
'      dblDebugGap = dblAngles(lngIndex) - dblAngles(lngIndex - 1)
'    End If
'    strDebugGap = CStr(Format(dblDebugGap, "0"))
'    Debug.Print CStr(lngIndex + 1) & "]  " & CStr(Format(dblAngles(lngIndex), "0.00")) & "       Gap = " & strDebugGap
'  Next lngIndex
  
  Dim pTempArray As esriSystem.IDoubleArray
50:   Set pTempArray = New esriSystem.DoubleArray
  
  Dim lngSplitIndex As Long
  
54:   If dblCentralAngle <> -999 Then
    
    Dim dblSplitAngle As Double
57:     dblSplitAngle = dblCentralAngle - 180
58:     If dblSplitAngle < 0 Then
59:       dblSplitAngle = dblSplitAngle + 360
60:     End If
    
62:     lngSplitIndex = 0
63:     Do While lngSplitIndex <= UBound(dblAngles)
64:       If dblAngles(lngSplitIndex) > dblSplitAngle Then
65:         Exit Do
66:       End If
67:       lngSplitIndex = lngSplitIndex + 1
68:     Loop
    
70:     If lngSplitIndex <= UBound(dblAngles) Then
71:       For lngIndex = lngSplitIndex To UBound(dblAngles)
72:         pTempArray.Add dblAngles(lngIndex)
73:       Next lngIndex
74:     End If
    
76:     If lngSplitIndex > 0 Then
77:       For lngIndex = 0 To lngSplitIndex - 1
78:         pTempArray.Add dblAngles(lngIndex)
79:       Next lngIndex
80:     End If
    
82:   Else
  
    Dim dblLargestGap As Double
85:     dblLargestGap = dblAngles(0) + 360 - dblAngles(UBound(dblAngles))
86:     lngSplitIndex = 0
    Dim dblTempGap As Double
    
89:     For lngIndex = 0 To UBound(dblAngles) - 1
90:       dblTempGap = dblAngles(lngIndex + 1) - dblAngles(lngIndex)
91:       If dblTempGap > dblLargestGap Then
92:         dblLargestGap = dblTempGap
93:         lngSplitIndex = lngIndex + 1
94:       End If
95:     Next lngIndex
    
    
98:     If lngSplitIndex <= UBound(dblAngles) Then
99:       For lngIndex = lngSplitIndex To UBound(dblAngles)
100:         pTempArray.Add dblAngles(lngIndex)
101:       Next lngIndex
102:     End If
    
104:     If lngSplitIndex > 0 Then
105:       For lngIndex = 0 To lngSplitIndex - 1
106:         pTempArray.Add dblAngles(lngIndex)
107:       Next lngIndex
108:     End If
  
110:   End If
  
'  Debug.Print
'  Debug.Print "Sorted and Wrapped..."
'  For lngIndex = 0 To UBound(dblAngles)
'    If lngIndex = 0 Then
'      dblDebugGap = pTempArray.Element(0) + 360 - pTempArray.Element(UBound(dblAngles))
'    Else
'      dblDebugGap = pTempArray.Element(lngIndex) - pTempArray.Element(lngIndex - 1)
'    End If
'    If dblDebugGap > 360 Then
'      dblDebugGap = dblDebugGap - 360
'    ElseIf dblDebugGap < 0 Then
'      dblDebugGap = dblDebugGap + 360
'    End If
'    strDebugGap = CStr(Format(dblDebugGap, "0"))
'    Debug.Print CStr(lngIndex + 1) & "]  " & CStr(Format(pTempArray.Element(lngIndex), "0.00")) & "       Gap = " & strDebugGap
'  Next lngIndex
  
129:   pAngleInDegrees.RemoveAll
130:   If booSortClockwise Then
131:     For lngIndex = 0 To pTempArray.Count - 1
132:       pAngleInDegrees.Add pTempArray.Element(lngIndex)
133:     Next lngIndex
134:   Else
135:     For lngIndex = pTempArray.Count - 1 To 0 Step -1
136:       pAngleInDegrees.Add pTempArray.Element(lngIndex)
137:     Next lngIndex
138:   End If



  Exit Sub
ErrorHandler:
  HandleError True, "AngleSort " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
Public Sub ByteAscending(narray() As Byte, inLow As Long, inHi As Long)
  On Error GoTo ErrorHandler


   Dim pivot As Byte
   Dim tmpSwap As Byte
   Dim tmpLow As Long
   Dim tmpHi  As Long
   
155:    tmpLow = inLow
156:    tmpHi = inHi
   
158:    pivot = narray((inLow + inHi) / 2)

160:    While (tmpLow <= tmpHi)
       
162:       While (narray(tmpLow) < pivot And tmpLow < inHi)
163:          tmpLow = tmpLow + 1
164:       Wend
   
166:       While (pivot < narray(tmpHi) And tmpHi > inLow)
167:          tmpHi = tmpHi - 1
168:       Wend

170:       If (tmpLow <= tmpHi) Then
171:          tmpSwap = narray(tmpLow)
172:          narray(tmpLow) = narray(tmpHi)
173:          narray(tmpHi) = tmpSwap
174:          tmpLow = tmpLow + 1
175:          tmpHi = tmpHi - 1
176:       End If
      
178:    Wend
    
180:    If (inLow < tmpHi) Then ByteAscending narray(), inLow, tmpHi
181:    If (tmpLow < inHi) Then ByteAscending narray(), tmpLow, inHi


  Exit Sub
ErrorHandler:
  HandleError True, "ByteAscending " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub


Public Sub ByteDescending(narray() As Byte, inLow As Long, inHi As Long)
  On Error GoTo ErrorHandler


   Dim pivot As Byte
   Dim tmpSwap As Byte
   Dim tmpLow As Long
   Dim tmpHi  As Long
   
199:    tmpLow = inLow
200:    tmpHi = inHi
   
202:    pivot = narray((inLow + inHi) / 2)
   
204:    While (tmpLow <= tmpHi)
        
206:       While (narray(tmpLow) > pivot And tmpLow < inHi)
207:          tmpLow = tmpLow + 1
208:       Wend
      
210:       While (pivot > narray(tmpHi) And tmpHi > inLow)
211:          tmpHi = tmpHi - 1
212:       Wend
      
214:       If (tmpLow <= tmpHi) Then
215:          tmpSwap = narray(tmpLow)
216:          narray(tmpLow) = narray(tmpHi)
217:          narray(tmpHi) = tmpSwap
218:          tmpLow = tmpLow + 1
219:          tmpHi = tmpHi - 1
220:       End If
      
222:    Wend
    
224:    If (inLow < tmpHi) Then ByteDescending narray(), inLow, tmpHi
225:    If (tmpLow < inHi) Then ByteDescending narray(), tmpLow, inHi


  Exit Sub
ErrorHandler:
  HandleError True, "ByteDescending " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
Public Sub LongAscending(narray() As Long, inLow As Long, inHi As Long)
  On Error GoTo ErrorHandler


   Dim pivot As Long
   Dim tmpSwap As Long
   Dim tmpLow As Long
   Dim tmpHi  As Long
   
241:    tmpLow = inLow
242:    tmpHi = inHi
   
244:    pivot = narray((inLow + inHi) / 2)

246:    While (tmpLow <= tmpHi)
       
248:       While (narray(tmpLow) < pivot And tmpLow < inHi)
249:          tmpLow = tmpLow + 1
250:       Wend
   
252:       While (pivot < narray(tmpHi) And tmpHi > inLow)
253:          tmpHi = tmpHi - 1
254:       Wend

256:       If (tmpLow <= tmpHi) Then
257:          tmpSwap = narray(tmpLow)
258:          narray(tmpLow) = narray(tmpHi)
259:          narray(tmpHi) = tmpSwap
260:          tmpLow = tmpLow + 1
261:          tmpHi = tmpHi - 1
262:       End If
      
264:    Wend
    
266:    If (inLow < tmpHi) Then LongAscending narray(), inLow, tmpHi
267:    If (tmpLow < inHi) Then LongAscending narray(), tmpLow, inHi


  Exit Sub
ErrorHandler:
  HandleError True, "LongAscending " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub


Public Sub LongDescending(narray() As Long, inLow As Long, inHi As Long)
  On Error GoTo ErrorHandler


   Dim pivot As Long
   Dim tmpSwap As Long
   Dim tmpLow As Long
   Dim tmpHi  As Long
   
285:    tmpLow = inLow
286:    tmpHi = inHi
   
288:    pivot = narray((inLow + inHi) / 2)
   
290:    While (tmpLow <= tmpHi)
        
292:       While (narray(tmpLow) > pivot And tmpLow < inHi)
293:          tmpLow = tmpLow + 1
294:       Wend
      
296:       While (pivot > narray(tmpHi) And tmpHi > inLow)
297:          tmpHi = tmpHi - 1
298:       Wend
      
300:       If (tmpLow <= tmpHi) Then
301:          tmpSwap = narray(tmpLow)
302:          narray(tmpLow) = narray(tmpHi)
303:          narray(tmpHi) = tmpSwap
304:          tmpLow = tmpLow + 1
305:          tmpHi = tmpHi - 1
306:       End If
      
308:    Wend
    
310:    If (inLow < tmpHi) Then LongDescending narray(), inLow, tmpHi
311:    If (tmpLow < inHi) Then LongDescending narray(), tmpLow, inHi


  Exit Sub
ErrorHandler:
  HandleError True, "LongDescending " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub




Public Sub SingleAscending(narray() As Single, inLow As Long, inHi As Long)
  On Error GoTo ErrorHandler


   Dim pivot As Single
   Dim tmpSwap As Single
   Dim tmpLow As Long
   Dim tmpHi  As Long
   
331:    tmpLow = inLow
332:    tmpHi = inHi
   
334:    pivot = narray((inLow + inHi) / 2)

336:    While (tmpLow <= tmpHi)
       
338:       While (narray(tmpLow) < pivot And tmpLow < inHi)
339:          tmpLow = tmpLow + 1
340:       Wend
   
342:       While (pivot < narray(tmpHi) And tmpHi > inLow)
343:          tmpHi = tmpHi - 1
344:       Wend

346:       If (tmpLow <= tmpHi) Then
347:          tmpSwap = narray(tmpLow)
348:          narray(tmpLow) = narray(tmpHi)
349:          narray(tmpHi) = tmpSwap
350:          tmpLow = tmpLow + 1
351:          tmpHi = tmpHi - 1
352:       End If
      
354:    Wend
    
356:    If (inLow < tmpHi) Then SingleAscending narray(), inLow, tmpHi
357:    If (tmpLow < inHi) Then SingleAscending narray(), tmpLow, inHi


  Exit Sub
ErrorHandler:
  HandleError True, "SingleAscending " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub


Public Sub SingleDescending(narray() As Single, inLow As Long, inHi As Long)
  On Error GoTo ErrorHandler


   Dim pivot As Single
   Dim tmpSwap As Single
   Dim tmpLow As Long
   Dim tmpHi  As Long
   
375:    tmpLow = inLow
376:    tmpHi = inHi
   
378:    pivot = narray((inLow + inHi) / 2)
   
380:    While (tmpLow <= tmpHi)
        
382:       While (narray(tmpLow) > pivot And tmpLow < inHi)
383:          tmpLow = tmpLow + 1
384:       Wend
      
386:       While (pivot > narray(tmpHi) And tmpHi > inLow)
387:          tmpHi = tmpHi - 1
388:       Wend
      
390:       If (tmpLow <= tmpHi) Then
391:          tmpSwap = narray(tmpLow)
392:          narray(tmpLow) = narray(tmpHi)
393:          narray(tmpHi) = tmpSwap
394:          tmpLow = tmpLow + 1
395:          tmpHi = tmpHi - 1
396:       End If
      
398:    Wend
    
400:    If (inLow < tmpHi) Then SingleDescending narray(), inLow, tmpHi
401:    If (tmpLow < inHi) Then SingleDescending narray(), tmpLow, inHi


  Exit Sub
ErrorHandler:
  HandleError True, "SingleDescending " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
Public Sub DoubleAscendingWithObjects(narray() As Double, varObjArray() As Variant, inLow As Long, inHi As Long)
  On Error GoTo ErrorHandler


  Dim pivot As Double
  Dim tmpSwap As Double
  Dim tmpSizeSwap As Variant
  Dim tmpLow As Long
  Dim tmpHi  As Long
   
418:   tmpLow = inLow
419:   tmpHi = inHi
   
421:   pivot = narray((inLow + inHi) / 2)
422:   While (tmpLow <= tmpHi)
       
424:     While (narray(tmpLow) < pivot And tmpLow < inHi)
425:        tmpLow = tmpLow + 1
426:     Wend
  
428:     While (pivot < narray(tmpHi) And tmpHi > inLow)
429:        tmpHi = tmpHi - 1
430:     Wend
431:     If (tmpLow <= tmpHi) Then
432:        tmpSwap = narray(tmpLow)
433:        narray(tmpLow) = narray(tmpHi)
434:        narray(tmpHi) = tmpSwap
       
436:        tmpSizeSwap = varObjArray(tmpLow)
437:        varObjArray(tmpLow) = varObjArray(tmpHi)
438:        varObjArray(tmpHi) = tmpSizeSwap
       
440:        tmpLow = tmpLow + 1
441:        tmpHi = tmpHi - 1
442:     End If
     
444:   Wend
    
446:   If (inLow < tmpHi) Then DoubleAscendingWithObjects narray(), varObjArray(), inLow, tmpHi
447:   If (tmpLow < inHi) Then DoubleAscendingWithObjects narray(), varObjArray(), tmpLow, inHi


  Exit Sub
ErrorHandler:
  HandleError True, "DoubleAscendingWithObjects " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Public Sub StringsAscendingWithObjects(sarray() As String, varObjArray() As Variant, inLow As Long, inHi As Long)
  On Error GoTo ErrorHandler

   Dim pivot As String
   Dim tmpSwap As String
   Dim tmpSizeSwap As Variant
   Dim tmpLow As Long
   Dim tmpHi As Long
   
464:    tmpLow = inLow
465:    tmpHi = inHi
   
467:    pivot = sarray((inLow + inHi) / 2)
  
469:    While (tmpLow <= tmpHi)
   
471:       While (sarray(tmpLow) < pivot And tmpLow < inHi)
472:          tmpLow = tmpLow + 1
473:       Wend
      
475:       While (pivot < sarray(tmpHi) And tmpHi > inLow)
476:          tmpHi = tmpHi - 1
477:       Wend
      
479:       If (tmpLow <= tmpHi) Then
480:          tmpSwap = sarray(tmpLow)
481:          sarray(tmpLow) = sarray(tmpHi)
482:          sarray(tmpHi) = tmpSwap
       
484:          tmpSizeSwap = varObjArray(tmpLow)
485:          varObjArray(tmpLow) = varObjArray(tmpHi)
486:          varObjArray(tmpHi) = tmpSizeSwap
        
488:          tmpLow = tmpLow + 1
489:          tmpHi = tmpHi - 1
490:       End If
   
492:    Wend
  
494:    If (inLow < tmpHi) Then StringsAscendingWithObjects sarray(), varObjArray(), inLow, tmpHi
495:    If (tmpLow < inHi) Then StringsAscendingWithObjects sarray(), varObjArray(), tmpLow, inHi


  Exit Sub
ErrorHandler:
  HandleError True, "StringsAscendingWithObjects " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub


Public Sub DoubleAscendingWithSizes(narray() As Double, nSizeArray() As Double, inLow As Long, inHi As Long)
  On Error GoTo ErrorHandler


  Dim pivot As Double
  Dim tmpSwap As Double
  Dim tmpSizeSwap As Double
  Dim tmpLow As Long
  Dim tmpHi  As Long
   
514:   tmpLow = inLow
515:   tmpHi = inHi
   
517:   pivot = narray((inLow + inHi) / 2)
518:   While (tmpLow <= tmpHi)
       
520:     While (narray(tmpLow) < pivot And tmpLow < inHi)
521:        tmpLow = tmpLow + 1
522:     Wend
  
524:     While (pivot < narray(tmpHi) And tmpHi > inLow)
525:        tmpHi = tmpHi - 1
526:     Wend
527:     If (tmpLow <= tmpHi) Then
528:        tmpSwap = narray(tmpLow)
529:        narray(tmpLow) = narray(tmpHi)
530:        narray(tmpHi) = tmpSwap
       
532:        tmpSizeSwap = nSizeArray(tmpLow)
533:        nSizeArray(tmpLow) = nSizeArray(tmpHi)
534:        nSizeArray(tmpHi) = tmpSizeSwap
       
536:        tmpLow = tmpLow + 1
537:        tmpHi = tmpHi - 1
538:     End If
     
540:   Wend
    
542:   If (inLow < tmpHi) Then DoubleAscendingWithSizes narray(), nSizeArray(), inLow, tmpHi
543:   If (tmpLow < inHi) Then DoubleAscendingWithSizes narray(), nSizeArray(), tmpLow, inHi


  Exit Sub
ErrorHandler:
  HandleError True, "DoubleAscendingWithSizes " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
Public Sub DoubleAscending(narray() As Double, inLow As Long, inHi As Long)
  On Error GoTo ErrorHandler


   Dim pivot As Double
   Dim tmpSwap As Double
   Dim tmpLow As Long
   Dim tmpHi  As Long
   
559:    tmpLow = inLow
560:    tmpHi = inHi
   
562:    pivot = narray((inLow + inHi) / 2)

564:    While (tmpLow <= tmpHi)
       
566:       While (narray(tmpLow) < pivot And tmpLow < inHi)
567:          tmpLow = tmpLow + 1
568:       Wend
   
570:       While (pivot < narray(tmpHi) And tmpHi > inLow)
571:          tmpHi = tmpHi - 1
572:       Wend

574:       If (tmpLow <= tmpHi) Then
575:          tmpSwap = narray(tmpLow)
576:          narray(tmpLow) = narray(tmpHi)
577:          narray(tmpHi) = tmpSwap
578:          tmpLow = tmpLow + 1
579:          tmpHi = tmpHi - 1
580:       End If
      
582:    Wend
    
584:    If (inLow < tmpHi) Then DoubleAscending narray(), inLow, tmpHi
585:    If (tmpLow < inHi) Then DoubleAscending narray(), tmpLow, inHi


  Exit Sub
ErrorHandler:
  HandleError True, "DoubleAscending " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub


Public Sub DoubleDescending(narray() As Double, inLow As Long, inHi As Long)
  On Error GoTo ErrorHandler


   Dim pivot As Double
   Dim tmpSwap As Double
   Dim tmpLow As Long
   Dim tmpHi  As Long
   
603:    tmpLow = inLow
604:    tmpHi = inHi
   
606:    pivot = narray((inLow + inHi) / 2)
   
608:    While (tmpLow <= tmpHi)
        
610:       While (narray(tmpLow) > pivot And tmpLow < inHi)
611:          tmpLow = tmpLow + 1
612:       Wend
      
614:       While (pivot > narray(tmpHi) And tmpHi > inLow)
615:          tmpHi = tmpHi - 1
616:       Wend
      
618:       If (tmpLow <= tmpHi) Then
619:          tmpSwap = narray(tmpLow)
620:          narray(tmpLow) = narray(tmpHi)
621:          narray(tmpHi) = tmpSwap
622:          tmpLow = tmpLow + 1
623:          tmpHi = tmpHi - 1
624:       End If
      
626:    Wend
    
628:    If (inLow < tmpHi) Then DoubleDescending narray(), inLow, tmpHi
629:    If (tmpLow < inHi) Then DoubleDescending narray(), tmpLow, inHi


  Exit Sub
ErrorHandler:
  HandleError True, "DoubleDescending " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Public Sub StringsAscending(sarray() As String, inLow As Long, inHi As Long)
  On Error GoTo ErrorHandler

  
   Dim pivot As String
   Dim tmpSwap As String
   Dim tmpLow As Long
   Dim tmpHi As Long
   
646:    tmpLow = inLow
647:    tmpHi = inHi
   
649:    pivot = sarray((inLow + inHi) / 2)
  
651:    While (tmpLow <= tmpHi)
   
653:       While (sarray(tmpLow) < pivot And tmpLow < inHi)
654:          tmpLow = tmpLow + 1
655:       Wend
      
657:       While (pivot < sarray(tmpHi) And tmpHi > inLow)
658:          tmpHi = tmpHi - 1
659:       Wend
      
661:       If (tmpLow <= tmpHi) Then
662:          tmpSwap = sarray(tmpLow)
663:          sarray(tmpLow) = sarray(tmpHi)
664:          sarray(tmpHi) = tmpSwap
665:          tmpLow = tmpLow + 1
666:          tmpHi = tmpHi - 1
667:       End If
   
669:    Wend
  
671:    If (inLow < tmpHi) Then StringsAscending sarray(), inLow, tmpHi
672:    If (tmpLow < inHi) Then StringsAscending sarray(), tmpLow, inHi


  Exit Sub
ErrorHandler:
  HandleError True, "StringsAscending " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub


Public Sub StringsDescending(sarray() As String, inLow As Long, inHi As Long)
  On Error GoTo ErrorHandler

  
   Dim pivot As String
   Dim tmpSwap As String
   Dim tmpLow As Long
   Dim tmpHi As Long
   
690:    tmpLow = inLow
691:    tmpHi = inHi
   
693:    pivot = sarray((inLow + inHi) / 2)
   
695:    While (tmpLow <= tmpHi)
      
697:       While (sarray(tmpLow) > pivot And tmpLow < inHi)
698:          tmpLow = tmpLow + 1
699:       Wend
    
701:       While (pivot > sarray(tmpHi) And tmpHi > inLow)
702:          tmpHi = tmpHi - 1
703:       Wend

705:       If (tmpLow <= tmpHi) Then
706:          tmpSwap = sarray(tmpLow)
707:          sarray(tmpLow) = sarray(tmpHi)
708:          sarray(tmpHi) = tmpSwap
709:          tmpLow = tmpLow + 1
710:          tmpHi = tmpHi - 1
711:       End If
  
713:    Wend
  
715:    If (inLow < tmpHi) Then StringsDescending sarray(), inLow, tmpHi
716:    If (tmpLow < inHi) Then StringsDescending sarray(), tmpLow, inHi


  Exit Sub
ErrorHandler:
  HandleError True, "StringsDescending " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub


Public Sub VariantAscending(sarray() As Variant, inLow As Long, inHi As Long)
  On Error GoTo ErrorHandler

  
   Dim pivot As Variant
   Dim tmpSwap As Variant
   Dim tmpLow As Long
   Dim tmpHi As Long
   
734:    tmpLow = inLow
735:    tmpHi = inHi
   
737:    pivot = sarray((inLow + inHi) / 2)
  
739:    While (tmpLow <= tmpHi)
   
741:       While (sarray(tmpLow) < pivot And tmpLow < inHi)
742:          tmpLow = tmpLow + 1
743:       Wend
      
745:       While (pivot < sarray(tmpHi) And tmpHi > inLow)
746:          tmpHi = tmpHi - 1
747:       Wend
      
749:       If (tmpLow <= tmpHi) Then
750:          tmpSwap = sarray(tmpLow)
751:          sarray(tmpLow) = sarray(tmpHi)
752:          sarray(tmpHi) = tmpSwap
753:          tmpLow = tmpLow + 1
754:          tmpHi = tmpHi - 1
755:       End If
   
757:    Wend
  
759:    If (inLow < tmpHi) Then VariantAscending sarray(), inLow, tmpHi
760:    If (tmpLow < inHi) Then VariantAscending sarray(), tmpLow, inHi


  Exit Sub
ErrorHandler:
  HandleError True, "VariantAscending " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub


Public Sub VariantDescending(sarray() As Variant, inLow As Long, inHi As Long)
  On Error GoTo ErrorHandler

  
   Dim pivot As Variant
   Dim tmpSwap As Variant
   Dim tmpLow As Long
   Dim tmpHi As Long
   
778:    tmpLow = inLow
779:    tmpHi = inHi
   
781:    pivot = sarray((inLow + inHi) / 2)
   
783:    While (tmpLow <= tmpHi)
      
785:       While (sarray(tmpLow) > pivot And tmpLow < inHi)
786:          tmpLow = tmpLow + 1
787:       Wend
    
789:       While (pivot > sarray(tmpHi) And tmpHi > inLow)
790:          tmpHi = tmpHi - 1
791:       Wend

793:       If (tmpLow <= tmpHi) Then
794:          tmpSwap = sarray(tmpLow)
795:          sarray(tmpLow) = sarray(tmpHi)
796:          sarray(tmpHi) = tmpSwap
797:          tmpLow = tmpLow + 1
798:          tmpHi = tmpHi - 1
799:       End If
  
801:    Wend
  
803:    If (inLow < tmpHi) Then VariantDescending sarray(), inLow, tmpHi
804:    If (tmpLow < inHi) Then VariantDescending sarray(), tmpLow, inHi


  Exit Sub
ErrorHandler:
  HandleError True, "VariantDescending " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Public Sub DatesDescending(narray() As Date, inLow As Long, inHi As Long)
  On Error GoTo ErrorHandler


   Dim pivot As Long
   Dim tmpSwap As Long
   Dim tmpLow As Long
   Dim tmpHi  As Long
   
821:    tmpLow = inLow
822:    tmpHi = inHi
   
824:    pivot = DateToJulian(narray((inLow + inHi) / 2))
   
826:    While (tmpLow <= tmpHi)
        
828:       While DateToJulian(narray(tmpLow)) > pivot And (tmpLow < inHi)
829:          tmpLow = tmpLow + 1
830:       Wend
      
832:       While (pivot > DateToJulian(narray(tmpHi))) And (tmpHi > inLow)
833:          tmpHi = tmpHi - 1
834:       Wend
      
836:       If (tmpLow <= tmpHi) Then
837:          tmpSwap = narray(tmpLow)
838:          narray(tmpLow) = narray(tmpHi)
839:          narray(tmpHi) = tmpSwap
840:          tmpLow = tmpLow + 1
841:          tmpHi = tmpHi - 1
842:       End If
      
844:    Wend
    
846:    If (inLow < tmpHi) Then DatesDescending narray(), inLow, tmpHi
847:    If (tmpLow < inHi) Then DatesDescending narray(), tmpLow, inHi


  Exit Sub
ErrorHandler:
  HandleError True, "DatesDescending " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub


Public Sub DatesAscending(narray() As Date, inLow As Long, inHi As Long)
  On Error GoTo ErrorHandler


   Dim pivot As Long
   Dim tmpSwap As Long
   Dim tmpLow As Long
   Dim tmpHi  As Long
   
865:    tmpLow = inLow
866:    tmpHi = inHi
   
868:    pivot = DateToJulian(narray((inLow + inHi) / 2))

870:    While (tmpLow <= tmpHi)
       
872:       While (DateToJulian(narray(tmpLow)) < pivot) And (tmpLow < inHi)
873:          tmpLow = tmpLow + 1
874:       Wend
   
876:       While (pivot < DateToJulian(narray(tmpHi))) And (tmpHi > inLow)
877:          tmpHi = tmpHi - 1
878:       Wend

880:       If (tmpLow <= tmpHi) Then
      
882:          tmpSwap = narray(tmpLow)
883:          narray(tmpLow) = narray(tmpHi)
884:          narray(tmpHi) = tmpSwap
885:          tmpLow = tmpLow + 1
886:          tmpHi = tmpHi - 1
         
888:       End If
      
890:    Wend
    
892:    If (inLow < tmpHi) Then DatesAscending narray(), inLow, tmpHi
893:    If (tmpLow < inHi) Then DatesAscending narray(), tmpLow, inHi


  Exit Sub
ErrorHandler:
  HandleError True, "DatesAscending " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Function DateToJulian(MyDate As Date) As Long
  On Error GoTo ErrorHandler


  'Return a numeric value representing
  'the passed date
907:    DateToJulian = DateValue(MyDate)


  Exit Function
ErrorHandler:
  HandleError False, "DateToJulian " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

