Attribute VB_Name = "QuickSortNonCase"
Option Explicit
Option Compare Text
' Variables used by the Error handler function - DO NOT REMOVE
Const c_sModuleFileName As String = "D:\arcGIS_stuff\saguaro\QuickSortNonCase.bas"



''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Copyright 1996-2005 VBnet, Randy Birch, All Rights Reserved.
' Some pages may also contain other copyrights by the author.
' see http://vbnet.mvps.org/index.html?code/sort/qsvariations.htm
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Distribution: You can freely use this code in your own
'               applications, but you may not reproduce
'               or publish this code on any web site,
'               online service, or distribute as source
'               on any media without express permission.
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' MODIFIED JAN. 4, 2006 BY JEFF JENNESS, TO SIMPLIFY IMPLEMENTATION IN ARCGIS
'-----------------------------------------------------------------------------

Public Sub CurrencyDescending(narray() As Currency, inLow As Long, inHi As Long)
  On Error GoTo ErrorHandler


   Dim pivot As Currency
   Dim tmpSwap As Currency
   Dim tmpLow As Long
   Dim tmpHi  As Long
   
31:    tmpLow = inLow
32:    tmpHi = inHi
   
34:    pivot = narray((inLow + inHi) / 2)
   
36:    While (tmpLow <= tmpHi)
        
38:       While (narray(tmpLow) > pivot And tmpLow < inHi)
39:          tmpLow = tmpLow + 1
40:       Wend
      
42:       While (pivot > narray(tmpHi) And tmpHi > inLow)
43:          tmpHi = tmpHi - 1
44:       Wend
      
46:       If (tmpLow <= tmpHi) Then
47:          tmpSwap = narray(tmpLow)
48:          narray(tmpLow) = narray(tmpHi)
49:          narray(tmpHi) = tmpSwap
50:          tmpLow = tmpLow + 1
51:          tmpHi = tmpHi - 1
52:       End If
      
54:    Wend
    
56:    If (inLow < tmpHi) Then CurrencyDescending narray(), inLow, tmpHi
57:    If (tmpLow < inHi) Then CurrencyDescending narray(), tmpLow, inHi


  Exit Sub
ErrorHandler:
  HandleError True, "CurrencyDescending " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
Public Sub CurrencyAscending(narray() As Currency, inLow As Long, inHi As Long)
  On Error GoTo ErrorHandler


   Dim pivot As Currency
   Dim tmpSwap As Currency
   Dim tmpLow As Long
   Dim tmpHi  As Long
   
73:    tmpLow = inLow
74:    tmpHi = inHi
   
76:    pivot = narray((inLow + inHi) / 2)

78:    While (tmpLow <= tmpHi)
       
80:       While (narray(tmpLow) < pivot And tmpLow < inHi)
81:          tmpLow = tmpLow + 1
82:       Wend
   
84:       While (pivot < narray(tmpHi) And tmpHi > inLow)
85:          tmpHi = tmpHi - 1
86:       Wend

88:       If (tmpLow <= tmpHi) Then
89:          tmpSwap = narray(tmpLow)
90:          narray(tmpLow) = narray(tmpHi)
91:          narray(tmpHi) = tmpSwap
92:          tmpLow = tmpLow + 1
93:          tmpHi = tmpHi - 1
94:       End If
      
96:    Wend
    
98:    If (inLow < tmpHi) Then CurrencyAscending narray(), inLow, tmpHi
99:    If (tmpLow < inHi) Then CurrencyAscending narray(), tmpLow, inHi


  Exit Sub
ErrorHandler:
  HandleError True, "CurrencyAscending " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Public Sub IntegerDescending(narray() As Integer, inLow As Long, inHi As Long)
  On Error GoTo ErrorHandler


   Dim pivot As Integer
   Dim tmpSwap As Integer
   Dim tmpLow As Long
   Dim tmpHi  As Long
   
116:    tmpLow = inLow
117:    tmpHi = inHi
   
119:    pivot = narray((inLow + inHi) / 2)
   
121:    While (tmpLow <= tmpHi)
        
123:       While (narray(tmpLow) > pivot And tmpLow < inHi)
124:          tmpLow = tmpLow + 1
125:       Wend
      
127:       While (pivot > narray(tmpHi) And tmpHi > inLow)
128:          tmpHi = tmpHi - 1
129:       Wend
      
131:       If (tmpLow <= tmpHi) Then
132:          tmpSwap = narray(tmpLow)
133:          narray(tmpLow) = narray(tmpHi)
134:          narray(tmpHi) = tmpSwap
135:          tmpLow = tmpLow + 1
136:          tmpHi = tmpHi - 1
137:       End If
      
139:    Wend
    
141:    If (inLow < tmpHi) Then IntegerDescending narray(), inLow, tmpHi
142:    If (tmpLow < inHi) Then IntegerDescending narray(), tmpLow, inHi


  Exit Sub
ErrorHandler:
  HandleError True, "IntegerDescending " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
Public Sub IntegerAscending(narray() As Integer, inLow As Long, inHi As Long)
  On Error GoTo ErrorHandler


   Dim pivot As Integer
   Dim tmpSwap As Integer
   Dim tmpLow As Long
   Dim tmpHi  As Long
   
158:    tmpLow = inLow
159:    tmpHi = inHi
   
161:    pivot = narray((inLow + inHi) / 2)

163:    While (tmpLow <= tmpHi)
       
165:       While (narray(tmpLow) < pivot And tmpLow < inHi)
166:          tmpLow = tmpLow + 1
167:       Wend
   
169:       While (pivot < narray(tmpHi) And tmpHi > inLow)
170:          tmpHi = tmpHi - 1
171:       Wend

173:       If (tmpLow <= tmpHi) Then
174:          tmpSwap = narray(tmpLow)
175:          narray(tmpLow) = narray(tmpHi)
176:          narray(tmpHi) = tmpSwap
177:          tmpLow = tmpLow + 1
178:          tmpHi = tmpHi - 1
179:       End If
      
181:    Wend
    
183:    If (inLow < tmpHi) Then IntegerAscending narray(), inLow, tmpHi
184:    If (tmpLow < inHi) Then IntegerAscending narray(), tmpLow, inHi


  Exit Sub
ErrorHandler:
  HandleError True, "IntegerAscending " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Public Sub ByteAscending(narray() As Byte, inLow As Long, inHi As Long)
  On Error GoTo ErrorHandler


   Dim pivot As Byte
   Dim tmpSwap As Byte
   Dim tmpLow As Long
   Dim tmpHi  As Long
   
201:    tmpLow = inLow
202:    tmpHi = inHi
   
204:    pivot = narray((inLow + inHi) / 2)

206:    While (tmpLow <= tmpHi)
       
208:       While (narray(tmpLow) < pivot And tmpLow < inHi)
209:          tmpLow = tmpLow + 1
210:       Wend
   
212:       While (pivot < narray(tmpHi) And tmpHi > inLow)
213:          tmpHi = tmpHi - 1
214:       Wend

216:       If (tmpLow <= tmpHi) Then
217:          tmpSwap = narray(tmpLow)
218:          narray(tmpLow) = narray(tmpHi)
219:          narray(tmpHi) = tmpSwap
220:          tmpLow = tmpLow + 1
221:          tmpHi = tmpHi - 1
222:       End If
      
224:    Wend
    
226:    If (inLow < tmpHi) Then ByteAscending narray(), inLow, tmpHi
227:    If (tmpLow < inHi) Then ByteAscending narray(), tmpLow, inHi


  Exit Sub
ErrorHandler:
  HandleError True, "ByteAscending " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Public Sub ByteDescending(narray() As Byte, inLow As Long, inHi As Long)
  On Error GoTo ErrorHandler


   Dim pivot As Byte
   Dim tmpSwap As Byte
   Dim tmpLow As Long
   Dim tmpHi  As Long
   
244:    tmpLow = inLow
245:    tmpHi = inHi
   
247:    pivot = narray((inLow + inHi) / 2)
   
249:    While (tmpLow <= tmpHi)
        
251:       While (narray(tmpLow) > pivot And tmpLow < inHi)
252:          tmpLow = tmpLow + 1
253:       Wend
      
255:       While (pivot > narray(tmpHi) And tmpHi > inLow)
256:          tmpHi = tmpHi - 1
257:       Wend
      
259:       If (tmpLow <= tmpHi) Then
260:          tmpSwap = narray(tmpLow)
261:          narray(tmpLow) = narray(tmpHi)
262:          narray(tmpHi) = tmpSwap
263:          tmpLow = tmpLow + 1
264:          tmpHi = tmpHi - 1
265:       End If
      
267:    Wend
    
269:    If (inLow < tmpHi) Then ByteDescending narray(), inLow, tmpHi
270:    If (tmpLow < inHi) Then ByteDescending narray(), tmpLow, inHi


  Exit Sub
ErrorHandler:
  HandleError True, "ByteDescending " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
Public Sub LongAscending(narray() As Long, inLow As Long, inHi As Long)
  On Error GoTo ErrorHandler


   Dim pivot As Long
   Dim tmpSwap As Long
   Dim tmpLow As Long
   Dim tmpHi  As Long
   
286:    tmpLow = inLow
287:    tmpHi = inHi
   
289:    pivot = narray((inLow + inHi) / 2)

291:    While (tmpLow <= tmpHi)
       
293:       While (narray(tmpLow) < pivot And tmpLow < inHi)
294:          tmpLow = tmpLow + 1
295:       Wend
   
297:       While (pivot < narray(tmpHi) And tmpHi > inLow)
298:          tmpHi = tmpHi - 1
299:       Wend

301:       If (tmpLow <= tmpHi) Then
302:          tmpSwap = narray(tmpLow)
303:          narray(tmpLow) = narray(tmpHi)
304:          narray(tmpHi) = tmpSwap
305:          tmpLow = tmpLow + 1
306:          tmpHi = tmpHi - 1
307:       End If
      
309:    Wend
    
311:    If (inLow < tmpHi) Then LongAscending narray(), inLow, tmpHi
312:    If (tmpLow < inHi) Then LongAscending narray(), tmpLow, inHi


  Exit Sub
ErrorHandler:
  HandleError True, "LongAscending " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub


Public Sub LongDescending(narray() As Long, inLow As Long, inHi As Long)
  On Error GoTo ErrorHandler


   Dim pivot As Long
   Dim tmpSwap As Long
   Dim tmpLow As Long
   Dim tmpHi  As Long
   
330:    tmpLow = inLow
331:    tmpHi = inHi
   
333:    pivot = narray((inLow + inHi) / 2)
   
335:    While (tmpLow <= tmpHi)
        
337:       While (narray(tmpLow) > pivot And tmpLow < inHi)
338:          tmpLow = tmpLow + 1
339:       Wend
      
341:       While (pivot > narray(tmpHi) And tmpHi > inLow)
342:          tmpHi = tmpHi - 1
343:       Wend
      
345:       If (tmpLow <= tmpHi) Then
346:          tmpSwap = narray(tmpLow)
347:          narray(tmpLow) = narray(tmpHi)
348:          narray(tmpHi) = tmpSwap
349:          tmpLow = tmpLow + 1
350:          tmpHi = tmpHi - 1
351:       End If
      
353:    Wend
    
355:    If (inLow < tmpHi) Then LongDescending narray(), inLow, tmpHi
356:    If (tmpLow < inHi) Then LongDescending narray(), tmpLow, inHi


  Exit Sub
ErrorHandler:
  HandleError True, "LongDescending " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub




Public Sub SingleAscending(narray() As Single, inLow As Long, inHi As Long)
  On Error GoTo ErrorHandler


   Dim pivot As Single
   Dim tmpSwap As Single
   Dim tmpLow As Long
   Dim tmpHi  As Long
   
376:    tmpLow = inLow
377:    tmpHi = inHi
   
379:    pivot = narray((inLow + inHi) / 2)

381:    While (tmpLow <= tmpHi)
       
383:       While (narray(tmpLow) < pivot And tmpLow < inHi)
384:          tmpLow = tmpLow + 1
385:       Wend
   
387:       While (pivot < narray(tmpHi) And tmpHi > inLow)
388:          tmpHi = tmpHi - 1
389:       Wend

391:       If (tmpLow <= tmpHi) Then
392:          tmpSwap = narray(tmpLow)
393:          narray(tmpLow) = narray(tmpHi)
394:          narray(tmpHi) = tmpSwap
395:          tmpLow = tmpLow + 1
396:          tmpHi = tmpHi - 1
397:       End If
      
399:    Wend
    
401:    If (inLow < tmpHi) Then SingleAscending narray(), inLow, tmpHi
402:    If (tmpLow < inHi) Then SingleAscending narray(), tmpLow, inHi


  Exit Sub
ErrorHandler:
  HandleError True, "SingleAscending " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub


Public Sub SingleDescending(narray() As Single, inLow As Long, inHi As Long)
  On Error GoTo ErrorHandler


   Dim pivot As Single
   Dim tmpSwap As Single
   Dim tmpLow As Long
   Dim tmpHi  As Long
   
420:    tmpLow = inLow
421:    tmpHi = inHi
   
423:    pivot = narray((inLow + inHi) / 2)
   
425:    While (tmpLow <= tmpHi)
        
427:       While (narray(tmpLow) > pivot And tmpLow < inHi)
428:          tmpLow = tmpLow + 1
429:       Wend
      
431:       While (pivot > narray(tmpHi) And tmpHi > inLow)
432:          tmpHi = tmpHi - 1
433:       Wend
      
435:       If (tmpLow <= tmpHi) Then
436:          tmpSwap = narray(tmpLow)
437:          narray(tmpLow) = narray(tmpHi)
438:          narray(tmpHi) = tmpSwap
439:          tmpLow = tmpLow + 1
440:          tmpHi = tmpHi - 1
441:       End If
      
443:    Wend
    
445:    If (inLow < tmpHi) Then SingleDescending narray(), inLow, tmpHi
446:    If (tmpLow < inHi) Then SingleDescending narray(), tmpLow, inHi


  Exit Sub
ErrorHandler:
  HandleError True, "SingleDescending " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Public Sub DoubleAscending(narray() As Double, inLow As Long, inHi As Long)
  On Error GoTo ErrorHandler


   Dim pivot As Double
   Dim tmpSwap As Double
   Dim tmpLow As Long
   Dim tmpHi As Long
   
463:    tmpLow = inLow
464:    tmpHi = inHi
   
466:    pivot = narray((inLow + inHi) / 2)

468:    While (tmpLow <= tmpHi)
       
470:       While (narray(tmpLow) < pivot And tmpLow < inHi)
471:          tmpLow = tmpLow + 1
472:       Wend
   
474:       While (pivot < narray(tmpHi) And tmpHi > inLow)
475:          tmpHi = tmpHi - 1
476:       Wend

478:       If (tmpLow <= tmpHi) Then
479:          tmpSwap = narray(tmpLow)
480:          narray(tmpLow) = narray(tmpHi)
481:          narray(tmpHi) = tmpSwap
482:          tmpLow = tmpLow + 1
483:          tmpHi = tmpHi - 1
484:       End If
      
486:    Wend
    
488:    If (inLow < tmpHi) Then DoubleAscending narray(), inLow, tmpHi
489:    If (tmpLow < inHi) Then DoubleAscending narray(), tmpLow, inHi


  Exit Sub
ErrorHandler:
  HandleError True, "DoubleAscending " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub


Public Sub DoubleDescending(narray() As Double, inLow As Long, inHi As Long)
  On Error GoTo ErrorHandler


   Dim pivot As Double
   Dim tmpSwap As Double
   Dim tmpLow As Long
   Dim tmpHi  As Long
   
507:    tmpLow = inLow
508:    tmpHi = inHi
   
510:    pivot = narray((inLow + inHi) / 2)
   
512:    While (tmpLow <= tmpHi)
        
514:       While (narray(tmpLow) > pivot And tmpLow < inHi)
515:          tmpLow = tmpLow + 1
516:       Wend
      
518:       While (pivot > narray(tmpHi) And tmpHi > inLow)
519:          tmpHi = tmpHi - 1
520:       Wend
      
522:       If (tmpLow <= tmpHi) Then
523:          tmpSwap = narray(tmpLow)
524:          narray(tmpLow) = narray(tmpHi)
525:          narray(tmpHi) = tmpSwap
526:          tmpLow = tmpLow + 1
527:          tmpHi = tmpHi - 1
528:       End If
      
530:    Wend
    
532:    If (inLow < tmpHi) Then DoubleDescending narray(), inLow, tmpHi
533:    If (tmpLow < inHi) Then DoubleDescending narray(), tmpLow, inHi


  Exit Sub
ErrorHandler:
  HandleError True, "DoubleDescending " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Public Sub StringsAscending(sarray() As String, inLow As Long, inHi As Long)
  On Error GoTo ErrorHandler

  
   Dim pivot As String
   Dim tmpSwap As String
   Dim tmpLow As Long
   Dim tmpHi As Long
   
550:    tmpLow = inLow
551:    tmpHi = inHi
   
553:    pivot = sarray((inLow + inHi) / 2)
  
555:    While (tmpLow <= tmpHi)
   
557:       While (sarray(tmpLow) < pivot And tmpLow < inHi)
558:          tmpLow = tmpLow + 1
559:       Wend
      
561:       While (pivot < sarray(tmpHi) And tmpHi > inLow)
562:          tmpHi = tmpHi - 1
563:       Wend
      
565:       If (tmpLow <= tmpHi) Then
566:          tmpSwap = sarray(tmpLow)
567:          sarray(tmpLow) = sarray(tmpHi)
568:          sarray(tmpHi) = tmpSwap
569:          tmpLow = tmpLow + 1
570:          tmpHi = tmpHi - 1
571:       End If
   
573:    Wend
  
575:    If (inLow < tmpHi) Then StringsAscending sarray(), inLow, tmpHi
576:    If (tmpLow < inHi) Then StringsAscending sarray(), tmpLow, inHi
  

  Exit Sub
ErrorHandler:
  HandleError True, "StringsAscending " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub


Public Sub StringsDescending(sarray() As String, inLow As Long, inHi As Long)
  On Error GoTo ErrorHandler

  
   Dim pivot As String
   Dim tmpSwap As String
   Dim tmpLow As Long
   Dim tmpHi As Long
   
594:    tmpLow = inLow
595:    tmpHi = inHi
   
597:    pivot = sarray((inLow + inHi) / 2)
   
599:    While (tmpLow <= tmpHi)
      
601:       While (sarray(tmpLow) > pivot And tmpLow < inHi)
602:          tmpLow = tmpLow + 1
603:       Wend
    
605:       While (pivot > sarray(tmpHi) And tmpHi > inLow)
606:          tmpHi = tmpHi - 1
607:       Wend

609:       If (tmpLow <= tmpHi) Then
610:          tmpSwap = sarray(tmpLow)
611:          sarray(tmpLow) = sarray(tmpHi)
612:          sarray(tmpHi) = tmpSwap
613:          tmpLow = tmpLow + 1
614:          tmpHi = tmpHi - 1
615:       End If
  
617:    Wend
  
619:    If (inLow < tmpHi) Then StringsDescending sarray(), inLow, tmpHi
620:    If (tmpLow < inHi) Then StringsDescending sarray(), tmpLow, inHi
  

  Exit Sub
ErrorHandler:
  HandleError True, "StringsDescending " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub


Public Sub VariantAscending(sarray() As Variant, inLow As Long, inHi As Long)
  On Error GoTo ErrorHandler

  
   Dim pivot As Variant
   Dim tmpSwap As Variant
   Dim tmpLow As Long
   Dim tmpHi As Long
   
638:    tmpLow = inLow
639:    tmpHi = inHi
   
641:    pivot = sarray((inLow + inHi) / 2)
  
643:    While (tmpLow <= tmpHi)
   
645:       While (sarray(tmpLow) < pivot And tmpLow < inHi)
646:          tmpLow = tmpLow + 1
647:       Wend
      
649:       While (pivot < sarray(tmpHi) And tmpHi > inLow)
650:          tmpHi = tmpHi - 1
651:       Wend
      
653:       If (tmpLow <= tmpHi) Then
654:          tmpSwap = sarray(tmpLow)
655:          sarray(tmpLow) = sarray(tmpHi)
656:          sarray(tmpHi) = tmpSwap
657:          tmpLow = tmpLow + 1
658:          tmpHi = tmpHi - 1
659:       End If
   
661:    Wend
  
663:    If (inLow < tmpHi) Then VariantAscending sarray(), inLow, tmpHi
664:    If (tmpLow < inHi) Then VariantAscending sarray(), tmpLow, inHi
  

  Exit Sub
ErrorHandler:
  HandleError True, "VariantAscending " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub


Public Sub VariantDescending(sarray() As Variant, inLow As Long, inHi As Long)
  On Error GoTo ErrorHandler

  
   Dim pivot As Variant
   Dim tmpSwap As Variant
   Dim tmpLow As Long
   Dim tmpHi As Long
   
682:    tmpLow = inLow
683:    tmpHi = inHi
   
685:    pivot = sarray((inLow + inHi) / 2)
   
687:    While (tmpLow <= tmpHi)
      
689:       While (sarray(tmpLow) > pivot And tmpLow < inHi)
690:          tmpLow = tmpLow + 1
691:       Wend
    
693:       While (pivot > sarray(tmpHi) And tmpHi > inLow)
694:          tmpHi = tmpHi - 1
695:       Wend

697:       If (tmpLow <= tmpHi) Then
698:          tmpSwap = sarray(tmpLow)
699:          sarray(tmpLow) = sarray(tmpHi)
700:          sarray(tmpHi) = tmpSwap
701:          tmpLow = tmpLow + 1
702:          tmpHi = tmpHi - 1
703:       End If
  
705:    Wend
  
707:    If (inLow < tmpHi) Then VariantDescending sarray(), inLow, tmpHi
708:    If (tmpLow < inHi) Then VariantDescending sarray(), tmpLow, inHi
  

  Exit Sub
ErrorHandler:
  HandleError True, "VariantDescending " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub


Public Sub DatesDescending(narray() As Date, inLow As Long, inHi As Long)
  On Error GoTo ErrorHandler


   Dim pivot As Long
   Dim tmpSwap As Long
   Dim tmpLow As Long
   Dim tmpHi  As Long
   
726:    tmpLow = inLow
727:    tmpHi = inHi
   
729:    pivot = DateToJulian(narray((inLow + inHi) / 2))
   
731:    While (tmpLow <= tmpHi)
        
733:       While DateToJulian(narray(tmpLow)) > pivot And (tmpLow < inHi)
734:          tmpLow = tmpLow + 1
735:       Wend
      
737:       While (pivot > DateToJulian(narray(tmpHi))) And (tmpHi > inLow)
738:          tmpHi = tmpHi - 1
739:       Wend
      
741:       If (tmpLow <= tmpHi) Then
742:          tmpSwap = narray(tmpLow)
743:          narray(tmpLow) = narray(tmpHi)
744:          narray(tmpHi) = tmpSwap
745:          tmpLow = tmpLow + 1
746:          tmpHi = tmpHi - 1
747:       End If
      
749:    Wend
    
751:    If (inLow < tmpHi) Then DatesDescending narray(), inLow, tmpHi
752:    If (tmpLow < inHi) Then DatesDescending narray(), tmpLow, inHi


  Exit Sub
ErrorHandler:
  HandleError True, "DatesDescending " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub


Public Sub DatesAscending(narray() As Date, inLow As Long, inHi As Long)
  On Error GoTo ErrorHandler


   Dim pivot As Long
   Dim tmpSwap As Long
   Dim tmpLow As Long
   Dim tmpHi  As Long
   
770:    tmpLow = inLow
771:    tmpHi = inHi
   
773:    pivot = DateToJulian(narray((inLow + inHi) / 2))

775:    While (tmpLow <= tmpHi)
       
777:       While (DateToJulian(narray(tmpLow)) < pivot) And (tmpLow < inHi)
778:          tmpLow = tmpLow + 1
779:       Wend
   
781:       While (pivot < DateToJulian(narray(tmpHi))) And (tmpHi > inLow)
782:          tmpHi = tmpHi - 1
783:       Wend

785:       If (tmpLow <= tmpHi) Then
      
787:          tmpSwap = narray(tmpLow)
788:          narray(tmpLow) = narray(tmpHi)
789:          narray(tmpHi) = tmpSwap
790:          tmpLow = tmpLow + 1
791:          tmpHi = tmpHi - 1
         
793:       End If
      
795:    Wend
    
797:    If (inLow < tmpHi) Then DatesAscending narray(), inLow, tmpHi
798:    If (tmpLow < inHi) Then DatesAscending narray(), tmpLow, inHi


  Exit Sub
ErrorHandler:
  HandleError True, "DatesAscending " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Private Function DateToJulian(MyDate As Date) As Long
  On Error GoTo ErrorHandler


  'Return a numeric value representing
  'the passed date
812:    DateToJulian = DateValue(MyDate)


  Exit Function
ErrorHandler:
  HandleError False, "DateToJulian " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
