Attribute VB_Name = "MyGeneralOperations"
Option Explicit

' MyGeneralOperations
' Jeff Jenness
' Jenness Enterprises
' http://www.jennessent.com

'  BasicStatsFromArray - GIVEN anArray, Field Name, Table Name, and Application, _
            Returns Sum, Mean, Minimum, Maximum, Range, Count, StDev, Variance, Median, Standard Error of Mean and Mode String
'  BasicStatsFromArraySimple - Simplified version of BasicStatsFromArray, with no progress info and no mode data.
'           GIVEN anArray, optional directive to calculate standard deviation info,
'           Returns Sum, Mean, Minimum, Maximum, Range, Count, StDev, Variance, Median, Standard Error of Mean
'  BasicStatsFromArray_Weighted - GIVEN 2-Dimensional anArray with Values and Weights, Field Name, Table Name, and Application, _
            Returns Weighted Mean, Weighted StDev and Weighted Variance
'  BasicStatsFromVAT - GIVEN 2-Dimensional Arrays (Value and Size, both sorted by Value), Field Name, Table Name, and Application, _
            Returns Sum, Mean, Minimum, Maximum, Range, Count, StDev, Variance, Median, Standard Error of Mean and Mode String
'  CalcStatistics - GIVEN AN ARRAY OF DOUBLES AND AN ARRAY OF BOOLEAN STAT OPTIONS, RETURNS AN ARRAY OF STATISTICS
'  CheckCollectionForKey - GIVEN pCollection and STRING, RETURNS BOOLEAN INDICATING WHETHER COLLECTION HAS THAT KEY OR NOT
'  CheckIfCompressedFGDB - GIVEN pFeatureClass, RETURNS BOOLEAN IF THIS FEATURE CLASS COMES FROM A COMPRESSED FILE GEODATABASE
'  CheckIfFeatureClassExists - GIVEN FEATURE WORKSPACE AND FEATURE CLASS NAME, RETURNS BOOLEAN IF FEATURE CLASS ALREADY EXISTS
'  CheckIfTableExists - GIVEN FEATURE WORKSPACE AND TABLE NAME, RETURNS BOOLEAN IF TABLE WITH THAT NAME ALREADY EXISTS
'  CheckNumericReal - GIVEN KEYASCII AND TEXTBOX, RESTRICTS INPUT TO ANY REAL NUMBER
'  CheckNumericRealPositive - GIVEN KEYASCII AND TEXTBOX, RESTRICTS INPUT TO ANY POSITIVE REAL NUMBER
'  CheckNumericInteger - GIVEN KEYASCII AND TEXTBOX, RESTRICTS INPUT TO ANY INTEGER
'  CheckNumericIntegerPositive - GIVEN KEYASCII AND TEXTBOX, RESTRICTS INPUT TO ANY POSITIVE INTEGER
'  CheckSpRefDomain - GIVEN SPATIAL REFERENCE, RETURNS BOOLEAN STATING WHETHER IT HAS A VALID XY DOMAIN
'  CompareSpatialReferences - RETURNS A BOOLEAN STATING WHETHER PROJECTION / DATUM ARE SAME.
'  ConvertLongBinary - GIVEN A LONG AND OPTIONAL NUMBER OF CHARACTERS, RETURNS BINARY REPRESENTATION.
'  CreateDatasetFeatureClass - GIVEN A FEATURE DATASET, FEATURE CLASS NAME, OPTIONAL GOEMETRY TYPE AND FIELD ARRAY, RETURNS A
'           NEW FEATURE CLASS INSIDE THE SPECIFIED FEATURE DATASET:  MODIFIED FROM ESRI SAMPLE
'  CreateGDBFeatureClass - GIVEN A FILE OR PERSONAL GEODATABASE, FEATURE CLASS NAME, OPTIONAL GOEMETRY TYPE, FIELD ARRAY, ETC, RETURNS A
'           NEW GEODATABASE FEATURE CLASS:  MODIFIED FROM ESRI SAMPLE
'  CreateGDBTable - GIVEN A FILE OR PERSONAL GEODATABASE, TABLE NAME, FIELD ARRAY, ETC, RETURNS A
'           NEW GEODATABASE TABLE:  MODIFIED FROM ESRI SAMPLE FOR CREATING GEODATABASE FEATURE CLASSES
'  CreateGeneralFeatureClass - RETURNS A NEW FEATURE CLASS IN A FOLDER (I.E. SHAPEFILE) OR IN A FILE / PERSONAL GEODATABASE.
'           CAN SEND IT SPECIFIC INSTRUCTIONS REGARDING NAME AND LOCATION, OR CAN HAVE IT ASK THE USER.
'  CreateGeneralTable - RETURNS A NEW TABLE IN A FOLDER (I.E. dBASE TABLE) OR IN A FILE / PERSONAL GEODATABASE.
'           CAN SEND IT SPECIFIC INSTRUCTIONS REGARDING NAME AND LOCATION, OR CAN HAVE IT ASK THE USER.
'  CreateInMemoryFeatureClass - GIVEN AN IARRAY OF GEOMETRIES (ALL OF SAME TYPE), RETURNS AN IN-MEMORY FEATURE CLASS.
'  CreateNestedFoldersByPath - GIVEN A PATH NAME, CREATES ANY MISSING FOLDERS IN THAT PATH
'  CreateShapefileFeatureClass - GIVEN A FOLDER, NAME, SPATIAL REFERENCE, GEOMETRY TYPE, OPTIONAL FIELD ARRAY,
'           RETURNS SHAPEFILE FEATURE CLASS.
'  CreatedBASETableInFolder - GIVEN A FOLDER, NAME, OPTIONAL FIELD ARRAY, CREATEDS dBASE TABLE AND RETURNS ITable OBJECT.
'  CursorToSet_Features - GIVEN A FEATURE CURSOR, RETURNS AN ISET OF FEATURES ALLOWING SET TO BE RUN THROUGH MULTIPLE TIMES
'  CursorToSet_TableRow - GIVEN A CURSOR, RETURNS AN ISET OF ROWS ALLOWING SET TO BE RUN THROUGH MULTIPLE TIMES
'  DeleteGraphicsByName - GIVEN A NAME AND MAP DOCUMENT, DELETES ALL GRAPHICS WITH A PARTICULAR NAME
'  DoSpatialQuery - SELECTS ALL FEATURES FROM FIRST FEATURE LAYER THAT INTERSECT SELECTED FEATURES OF SECONDS FEATURE LAYER
'  EnableSelectTool - GIVEN Application, CLICKS THE "SELECT ELEMENTS" TOOL
'  ForceUppercase - GIVEN KEYASCII AND TEXTBOX, FORCES ENTERED KEYSTROKE TO BE UPPERCASE
'  GetPart - GIVEN A STRING AND DELIMITER, CLIPS OFF PORTION OF STRING IN FRONT OF DELIMITER AND RETURNS IT.  THE ORIGINAL
'           STRING HAS THE PART AND DELIMITER REMOVED FROM THE FRONT.  USED BY CreateNestedFoldersByPath FUNCTION
'  Graphic_MakeFromGeometry - GIVEN A MAP DOCUMENT, GEOMETRY AND OPTIONAL NAME AND SYMBOLOGY, ADDS GRAPHIC TO MAP.
'  Graphic_ReturnElementFromGeometry - GIVEN MAP DOC, GEOMETRY, OPTIONAL NAME AND OPTIONAL ADD-TO-VIEW, RETURNS THE GRAPHIC
'           ELEMENT
'  GraphicsSetNameSelected - GIVEN A MAP DOCUMENT AND NAME, ASSIGNS THAT NAME TO ALL SELECTED GRAPHICS
'  IsNaN - GIVEN A VARIANT, RETURNS A BOOLEAN INDICATING WHETHER A NUMBER IS A "NOT-A-NUMBER" VALUE
'  MakeColorRGB - GIVEN RED, GREEN AND BLUE, RETURN ICOLOR
'  MakeColorHSV - GIVEN HUE, SATURATION AND VALUE, RETURN ICOLOR
'  MakeFieldNameArray - GIVEN ORIGINAL FEATURE CLASS, NEW FEATURE CLASS, AND IVARIANARRAY OF NEW FIELD NAMES,
'                   RETURN ARRAY CONTAINING INDEX VALUES FOR EACH FIELD NAME
'  MakeRandomNormal - GIVEN MEAN, SD, PLACEHOLDER VARIABLE, OPTIONAL SECOND PLACEHOLDER, REPLACES PLACEHOLDERS WITH RANDOM NUMBERS
'                   FROM NORMAL DISTRIBUTION WITH SPECIFIED MEAN AND STANDARD DEVIATION
'                   USES BOX-MULLER TRANSFORMATION
'  MakeRandomNormalPolar - GIVEN MEAN, SD, PLACEHOLDER VARIABLE, OPTIONAL SECOND PLACEHOLDER, REPLACES PLACEHOLDERS WITH RANDOM NUMBERS
'                   FROM NORMAL DISTRIBUTION WITH SPECIFIED MEAN AND STANDARD DEVIATION
'                   Marsaglia's variation of the Box-Muller Transformation (http://en.wikipedia.org/wiki/Box-Muller_transform)
'  MakeUniquedBASEName - GIVEN A FULL FILE NAME, RETURNS A UNIQUE FILENAME IN THAT FOLDER BY APPENDING COUNTER TO ORIGINAL NAME
'  MakeUniqueGDBFeatureClassName - GIVEN IWorkspace AND NAME STRING, RETURNS A NAME STRING THAT REFLECTS A UNIQUE NAME IN THAT GDB
'  MakeUniqueGDBTableName - GIVEN IWorkspace AND NAME STRING, RETURNS A NAME STRING THAT REFLECTS A UNIQUE TABLE NAME IN THAT GDB
'  MakeUniqueRasterName - GIVEN JenDatasetType, WORKSPACE PATH STRING AND RASTER NAME, RETURNS A UNIQUE RASTER NAME FOR THAT WORKSPACE
'                   OPTIONALLY WILL TRIM TO GRID RESTRICTIONS FOR FILE-BASED RASTER
'  MakeUniqueRasterName2 - GIVEN IWorkspace, RASTER NAME AND OPTIONAL BOOLEAN TO TRIM TO 13 CHARACTERS, RETURNS A UNIQUE RASTER NAME FOR THAT WORKSPACE
'  MakeUniqueShapeFilename - GIVEN A FULL FILE NAME, RETURNS A UNIQUE FILENAME IN THAT FOLDER BY APPENDING COUNTER TO ORIGINAL NAME
'  OpenFile - GIVEN A DOCUMENT FILENAME AND PATH, OPENS THAT FILE USING THE REGISTERED WINDOWS PROGRAM
'  RemoveKeyFromCollection - GIVEN A COLLECTION AND KEY, REMOVE THE KEY WITHOUT CRASHING CODE IF COLLECTION DOES NOT HAVE THAT KEY
'  ReplaceBadChars - GIVEN A NAME, REPLACES ALL NON-STANDARD CHARACTERS WITH "_" CHARACTERS
'  ReturnCurrentMapUnits - GIVE IT AN IMAP, IT RETURNS THE NAME OF THE MAP UNITS
'  ReturnDBASEFieldName - GIVEN SAMPLE FIELD NAME AND LIST, RETURNS A NAME THAT IS VALID FOR DBASE AND DOES NOT EXIST IN THE LIST.
'                         LIST CAN BE AN IFields, IStringArray or IVarArray (CONTAINING EITHER STRINGS OR FIELDS)
'  ReturnDistanceUnitsName - GIVEN AN esriUnits, RETURNS THE NAME
'  ReturnFieldsByType - GIVEN pFields AND JenFieldType ENUMERATION, RETURNS AN IVarARRAY OF FIELDS
'  ReturnGraphicsByName - GIVEN A MAP DOCUMENT AND NAME, RETURNS A COLLECTION CONTAINING THE GEOMETRIES OF THOSE GRAPHICS
'  ReturnGraphicsByType - GIVEN A MAP DOCUMENT AND SHAPE TYPE, RETURNS A COLLECTION CONTAINING THE GEOMETRIES OF THOSE GRAPHICS
'  ReturnHistStatsFromDouble - MODIFICATION OF BasicStatsFromArraySimple
'           GIVEN anArray, optional directive to calculate standard deviation info, optional boolean for sample / population,
'                   optional boolean to return sorted array of numbers
'           RETURNS pArray, containing 4 sub-arrays: 1) Double Array of unique values, 2) Long array of counts of values,
'                   Double Array of standard stats (Sum, Mean, Minimum, Maximum, Range, Count, StDev, Variance, Median, Standard Error of Mean)
'                   Optional array of sorted numbers
'  ReturnLayersByType - GIVEN FOCUSMAP AND TYPE, RETURNS IVariantArray OF LAYERS
'  ReturnLayerByName - GIVEN NAME AND MAP, RETURNS pLayer OR NOTHING
'  ReturnTempRasterWorkspace - RETURNS A RASTER WORKSPACE OBJECT LOCATED IN CURRENT TEMP DIRECTORY
'  ReturnTimeStamp - RETURNS STRING FORMATTED AS "YYYYMMDD_HHMMSS", OR SOMETHING LIKE "20081314_083230"
'  ReturnTimeElapsed - GIVEN A START AND END TIME, RETURNS A STRING DESCRIBING THE TIME ELAPSED.
'           Analysis Began: Wednesday, July 26, 2006;  4:39:01 PM
'           Analysis Complete: Wednesday, July 27, 2006;  5:47:22 PM
'           Time Elapsed: 1 day, 1 hour, 8 minutes, 21 seconds...
'  ReturnTimeElapsedFromMilliseconds - GIVEN A MILLISECOND COUNT (FROM GetTickCount API FUNCTION), RETURNS A STRING DESCRIBING THE TIME ELAPSED.
'           Analysis Began: Wednesday, July 26, 2006;  4:39:01 PM
'           Analysis Complete: Wednesday, July 27, 2006;  5:47:22 PM
'           Time Elapsed: 1 day, 1 hour, 8 minutes, 21 seconds...
'  ReturnTimeElapsedRTF - GIVEN A START AND END TIME, RETURNS AN RTF-FORMATTED STRING DESCRIBING THE TIME ELAPSED.
'           Analysis Began: Wednesday, July 26, 2006;  4:39:01 PM
'           Analysis Complete: Wednesday, July 27, 2006;  5:47:22 PM
'           Time Elapsed: 1 day, 1 hour, 8 minutes, 21 seconds...
'  TrimZerosAndDecimas - GIVEN A NUMERIC VARIANT, RETURNS STRING WILL ALL TRAILING ZEROS AND DECIMALS TRIMMED OFF.  OPTIONAL TO ADD COMMAS
'  TrueLayerCount - GIVEN AN IMAP, RETURNS TRUE LAYER COUNT INCLUDING GROUP LAYERS

Public Declare Function CopyFile Lib "Kernel32" Alias "CopyFileA" _
  (ByVal lpExistingFileName As String, ByVal lpNewFileName As String, _
  ByVal bFailIfExists As Long) As Long
  
Private Declare Function ShellExecute Lib "shell32.dll" Alias _
           "ShellExecuteA" (ByVal hWnd As Long, ByVal lpOperation As String, _
           ByVal lpFile As String, ByVal lpParameters As String, _
           ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long

Public Declare Function SetWindowPos Lib "user32" (ByVal hWnd As Long, ByVal _
  hWndInsertAfter As Long, ByVal X As Long, ByVal Y As _
  Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags _
  As Long) As Long

Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" _
  (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Public Const GWL_HWNDPARENT = (-8)
Private Const INVALID_HANDLE_VALUE As Long = -1
Private Const MAX_PATH As Long = 260

Declare Function GetDesktopWindow Lib "user32.dll" () As Long
Public Declare Function GetTickCount Lib "Kernel32" () As Long

Private Type SECURITY_ATTRIBUTES
   nLength As Long
   lpSecurityDescriptor As Long
   bInheritHandle As Long
End Type

Private Declare Function CreateDirectory Lib "Kernel32" _
   Alias "CreateDirectoryA" _
  (ByVal lpPathName As String, _
   lpSecurityAttributes As SECURITY_ATTRIBUTES) As Long
   
Public Enum JenFieldTypes
  ENUM_FieldString = 1
  ENUM_FieldNumber = 2
  ENUM_FieldDate = 4
  ENUM_FieldOID = 8
  ENUM_FieldGeometry = 16
  ENUM_FieldBlob = 32
  ENUM_FieldRaster = 64
  ENUM_FieldGUID = 128
  ENUM_FieldGlobalID = 256
  ENUM_FieldXML = 512
End Enum

Public Enum JenLayerTypes
  ENUM_jenFeatureLayers = 1
  ENUM_jenRasterLayers = 2
  ENUM_jenStandaloneTables = 4
  ENUM_jenPointLayers = 8
  ENUM_jenPolylineLayers = 16
  ENUM_jenPolygonLayers = 32
  ENUM_jenMultipointLayers = 64
  ENUM_jenTinLayers = 128
  ENUM_jenRastCatalogLayers = 256
End Enum

Public Enum JenDatasetTypes
  ENUM_Shapefile = 1
  ENUM_FileGDB = 2
  ENUM_PersonalGDB = 4
  ENUM_Coverage = 8
  ENUM_SDC_FeatureClass = 16
  ENUM_File_Raster = 32
End Enum

Const dblPi As Double = 3.14159265358979
Const c_sModuleFileName As String = "...MyGeneralOperations.bas"

Public Function TrimZerosAndDecimals(varNumber As Variant, Optional booAddCommas As Boolean = True) As String
  On Error GoTo ErrorHandler

  Dim dblValue As Double
185:   dblValue = CDbl(varNumber)
  Dim strValue As String
187:   If booAddCommas Then
188:     strValue = CStr(Format(dblValue, "#,##0.000000000000000"))
189:   Else
190:     strValue = CStr(Format(dblValue, "0.000000000000000"))
191:   End If
  
193:   Do Until Right(strValue, 1) <> "0" Or Len(strValue) = 0
194:     strValue = Left(strValue, Len(strValue) - 1)
195:   Loop
  
197:   Do Until Right(strValue, 1) <> "." Or Len(strValue) = 0
198:     strValue = Left(strValue, Len(strValue) - 1)
199:   Loop
  
201:   If strValue = "" Then
202:     strValue = "0"
203:   End If
  
205:   TrimZerosAndDecimals = strValue
  

  Exit Function
ErrorHandler:
  HandleError True, "TrimZerosAndDecimals " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function


Public Function MakeFieldNameVarArray(pOrigFClass As IFeatureClass, pNewFClass As IFeatureClass, _
      pFieldArray As esriSystem.IVariantArray, booFieldArrayContainsNamePairs As Boolean) As esriSystem.IVariantArray
  On Error GoTo ErrorHandler

      
  ' MAKE IVariantArray OF FIELD NAME INDICES
  ' STRUCTURE:  ARRAY OF 4-ITEM VARIANT ARRAYS
  '             ITEMS = 0) ORIGINAL FCLASS FIELD NAME
  '                     1) ORIGINAL FCLASS FIELD INDEX
  '                     2) NEW FCLASS FIELD NAME
  '                     3) NEW FCLASS FIELD INDEX
  
  Dim lngIndex As Long
  Dim pField As IField
  Dim strOrigName As String
  Dim strNewName As String
  Dim pNamePair As esriSystem.IStringArray
  Dim pFieldData As esriSystem.IVariantArray
232:   Set MakeFieldNameVarArray = New VarArray
  
234:   For lngIndex = 0 To pFieldArray.Count - 1
235:     If booFieldArrayContainsNamePairs Then
236:       Set pNamePair = pFieldArray.Element(lngIndex)
237:       strOrigName = pNamePair.Element(0)
238:       strNewName = pNamePair.Element(1)
239:     Else
240:       Set pField = pFieldArray.Element(lngIndex)
241:       strOrigName = pField.Name
242:       strNewName = pField.Name
243:     End If
244:     Set pFieldData = New esriSystem.VarArray
245:     pFieldData.Add strOrigName
246:     pFieldData.Add pOrigFClass.FindField(strOrigName)
247:     pFieldData.Add strNewName
248:     pFieldData.Add pNewFClass.FindField(strNewName)
249:     MakeFieldNameVarArray.Add pFieldData
250:   Next lngIndex
      

  Exit Function
ErrorHandler:
  HandleError True, "MakeFieldNameVarArray " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Sub MakeRandomNormal(dblMean As Double, dblSD As Double, ByVal dblRand1 As Double, Optional ByVal dblRand2 As Double = -999)
  On Error GoTo ErrorHandler


262:   Static dblSeed
' Based on the Box-Muller Transformation:.
'          y1 = sqrt( - 2 ln(x1) ) cos( 2 pi x2 )
'          y2 = sqrt( - 2 ln(x1) ) sin( 2 pi x2 )
'        where:
'          x1 = first uniform random number (between 0 and 1)
'          x2 = second uniform random number (between 0 and 1)
'          y1 = first normally distributed random number
'          y2 = second normally distributed random number.
271:   If dblSeed = 0 Then
272:     Randomize            ' USE SYSTEM TIMER
273:   Else
274:     Randomize dblSeed
275:   End If
  Dim dblX1 As Double
  Dim dblX2 As Double
278:   dblX1 = Rnd
279:   dblX2 = Rnd
  
281:   dblRand1 = (Sqr(-2 * Log(dblX1)) * Cos(2 * dblPi * dblX2) * dblSD#) + dblMean#
282:   dblRand2 = (Sqr(-2 * Log(dblX1)) * Sin(2 * dblPi * dblX2) * dblSD#) + dblMean#
  
284:   dblSeed = dblRand2
  

  Exit Sub
ErrorHandler:
  HandleError True, "MakeRandomNormal " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Public Function ReturnHistStatsFromDouble(pDouble As esriSystem.IDoubleArray, _
            Optional pCounts As esriSystem.IDoubleArray, _
            Optional booVariance As Boolean = False, _
            Optional booIsSample As Boolean = False, _
            Optional booReturnSortedArray As Boolean = False, _
            Optional strName As String = "Statistics") As esriSystem.IVariantArray
  On Error GoTo ErrorHandler

    
  Dim dblVals() As Double
  Dim lngIndex As Long
  Dim lngCount As Long
  Dim dblWeight As Double
  
  Dim booHasWeight As Boolean
307:   booHasWeight = Not pCounts Is Nothing
  
309:   lngCount = pDouble.Count - 1
  ReDim dblVals(lngCount)
  
312:   If booHasWeight Then
    Dim dblWeightArray() As Double
    ReDim dblWeightArray(lngCount)
315:     For lngIndex = 0 To lngCount
316:       dblVals(lngIndex) = pDouble.Element(lngIndex)
317:       dblWeightArray(lngIndex) = pCounts.Element(lngIndex)
318:     Next lngIndex
    
    ' SORT VALUES
321:     QuickSort.DoubleAscendingWithSizes dblVals, dblWeightArray, 0, lngCount
322:   Else
323:     dblWeight = 1
324:     For lngIndex = 0 To lngCount
325:       dblVals(lngIndex) = pDouble.Element(lngIndex)
326:     Next lngIndex
    
    ' SORT VALUES
329:     QuickSort.DoubleAscending dblVals, 0, lngCount
330:   End If
    
  ' ASSUMES ARRAY IS SORTED!!!! --------------------------------------
  Dim theSum As Double
  Dim theCount As Double
  Dim theMinimum As Double
  Dim theMaximum As Double
  Dim theMean As Double
  Dim theSumSqDev As Double
  Dim theSqDev As Double
  Dim theMedian As Double
  Dim theVariance As Double
  Dim theStDev As Double
  Dim theStErrMean As Double
  Dim theRange As Double
  Dim dblSumSquaredWeights As Double
  Dim dblCheckVal As Double
  Dim dblHalfCount As Double         ' FOR MEDIAN WHEN USING WEIGHTED VALUES
  Dim booFoundMedian As Boolean      ' FOR MEDIAN WHEN USING WEIGHTED VALUES
  Dim dblRunningCountTotal As Double ' FOR MEDIAN WHEN USING WEIGHTED VALUES
  
351:   booFoundMedian = False
  
  ' MAKE ARRAYS TO RETURN
  Dim pReturnArray As esriSystem.IDoubleArray
  Dim pCountArray As esriSystem.IDoubleArray  ' "Counts" might be <1 nor non-integer if they are feature lengths or areas
  Dim pResponse As esriSystem.IDoubleArray
  
358:   Set pReturnArray = New esriSystem.DoubleArray
359:   Set pCountArray = New esriSystem.DoubleArray
360:   Set pResponse = New esriSystem.DoubleArray
  
  Dim dblCounter As Long
  Dim dblTestVal As Double
  
365:   If lngCount = 0 Then
  
367:     pResponse.Add -999
368:     pResponse.Add -999
369:     pResponse.Add -999
370:     pResponse.Add -999
371:     pResponse.Add -999
372:     pResponse.Add -999
373:     pResponse.Add -999
374:     pResponse.Add -999
375:     pResponse.Add -999
376:     pResponse.Add -999
377:     pResponse.Add -999   ' FOR dblTrueCount
  
379:   Else
  
381:     dblTestVal = dblVals(0)
382:     If booHasWeight Then
383:       dblCounter = dblWeightArray(0)
384:     Else
385:       dblCounter = 1
386:     End If
387:     theMinimum = dblVals(0)
388:     theMaximum = dblVals(UBound(dblVals))
389:     theRange = theMaximum - theMinimum
390:     theSum = dblTestVal
391:     theCount = dblCounter
392:     dblSumSquaredWeights = dblCounter ^ 2
'     theCount = lngCount + 1         ' ARRAY INDEX STARTS AT 0
    
395:     If lngCount > 1 Then
    
      '  PASS 1:  MINIMUM, MAXIMUM HISTOGRAM ARRAYS AND SUM --------------------------------------------------
398:       For lngIndex = 1 To lngCount
399:         dblCheckVal = dblVals(lngIndex)
400:         If booHasWeight Then
401:           dblWeight = dblWeightArray(lngIndex)  ' OTHERWISE WEIGHT DEFAULTS TO 1
402:           dblSumSquaredWeights = dblSumSquaredWeights + (dblWeight ^ 2)
403:         End If
          
        ' BUILD HISTOGRAM ARRAYS
406:         If dblTestVal = dblCheckVal Then
407:           dblCounter = dblCounter + dblWeight
408:         Else
409:           pReturnArray.Add dblTestVal
410:           pCountArray.Add dblCounter
411:           dblTestVal = dblCheckVal
412:           dblCounter = dblWeight
413:         End If
        
        ' GENERAL STATS
416:         theSum = theSum + (dblCheckVal * dblWeight)
417:         theCount = theCount + dblWeight
418:       Next lngIndex
      
      ' FOR HISTOGRAM ARRAYS, ADD LAST VALUE
421:       pReturnArray.Add dblTestVal
422:       pCountArray.Add dblCounter
      
      ' FOR GENERAL STATS
425:       theMean = theSum / theCount
426:       dblHalfCount = theCount / 2
427:       dblRunningCountTotal = 0
      
      '  PASS 2:  STANDARD DEVIATION AND VARIANCE --------------------------------------------------
430:       If booVariance Then
431:         For lngIndex = 0 To lngCount
                    
433:           dblCheckVal = dblVals(lngIndex)
          
435:           If booHasWeight Then
436:             dblWeight = dblWeightArray(lngIndex)
437:             theSqDev = dblWeight * ((dblCheckVal - theMean) ^ 2)
438:             If Not booFoundMedian Then
439:               dblRunningCountTotal = dblRunningCountTotal + dblWeight
440:               If dblRunningCountTotal >= dblHalfCount Then
441:                 booFoundMedian = True
442:                 theMedian = dblCheckVal
443:               End If
444:             End If
445:           Else
446:             theSqDev = (dblCheckVal - theMean) ^ 2
447:           End If
          
449:           theSumSqDev = theSqDev + theSumSqDev
450:         Next lngIndex
451:       Else
452:         theSqDev = 0
453:         theSumSqDev = 0
454:       End If
      
456:       If booHasWeight Then
        ' THEN MEDIAN IS CALCULATED UP IN PASS 2
458:       Else
459:         If theCount Mod 2 = 0 Then      ' EVEN NUMBER
460:           theMedian = (dblVals((theCount / 2) - 1) + dblVals(theCount / 2)) / 2
461:         Else
462:           theMedian = dblVals((theCount - 1) / 2)
463:         End If
464:       End If
      
466:       If booHasWeight Then
467:         If booIsSample Then
          ' FROM http://en.wikipedia.org/wiki/Weighted_standard_deviation#Weighted_sample_variance
          ' FROM http://pygsl.sourceforge.net/reference/pygsl/node36.html
470:           theVariance = (theCount / ((theCount ^ 2) - dblSumSquaredWeights)) * theSumSqDev
471:         Else
          ' FROM http://en.wikipedia.org/wiki/Weighted_standard_deviation#Weighted_sample_variance
473:           theVariance = theSumSqDev / theCount
474:         End If
475:       Else
476:         If booIsSample Then
477:           theVariance = theSumSqDev / (theCount - 1)
478:         Else
479:           theVariance = theSumSqDev / theCount
480:         End If
481:       End If
      
483:       theStDev = Sqr(theVariance)
484:       theStErrMean = theStDev / (Sqr(theCount))
      
486:     Else
487:       pReturnArray.Add dblTestVal
488:       pCountArray.Add 1
      
490:       theMean = dblTestVal
491:       theMedian = dblTestVal
492:       theVariance = 0
493:       theStDev = 0
494:       theStErrMean = 0
      
496:     End If
      
498:     pResponse.Add theSum
499:     pResponse.Add theMean
500:     pResponse.Add theMinimum
501:     pResponse.Add theMaximum
502:     pResponse.Add theRange
503:     pResponse.Add theCount
504:     pResponse.Add theStDev
505:     pResponse.Add theVariance
506:     pResponse.Add theMedian
507:     pResponse.Add theStErrMean
    
509:   End If
  
511:   Set ReturnHistStatsFromDouble = New esriSystem.VarArray
512:   ReturnHistStatsFromDouble.Add pReturnArray
513:   ReturnHistStatsFromDouble.Add pCountArray
514:   ReturnHistStatsFromDouble.Add pResponse
515:   If booReturnSortedArray Then
516:     ReturnHistStatsFromDouble.Add dblVals
517:   Else
518:     ReturnHistStatsFromDouble.Add -999
519:   End If
520:   ReturnHistStatsFromDouble.Add strName
  

  Exit Function
ErrorHandler:
  HandleError True, "ReturnHistStatsFromDouble " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
Public Function ReplaceBadChars(strName As String, Optional booReplacePeriod As Boolean = False, _
    Optional booReplaceBackSlash As Boolean = False, Optional booReplaceSpace As Boolean = True, _
    Optional booStartWithLetter As Boolean = False) As String
  On Error GoTo ErrorHandler

532:   If strName = "" Then
533:     ReplaceBadChars = "z"
534:   Else
    Dim strAcceptable As String
536:     strAcceptable = "abcdefghijklmnopqrstuvwxyz0123456789_"
537:     If Not booReplacePeriod Then strAcceptable = strAcceptable & "."
538:     If Not booReplaceBackSlash Then strAcceptable = strAcceptable & "\"
539:     If Not booReplaceSpace Then strAcceptable = strAcceptable & " "
    
    Dim strOutput As String
542:     strOutput = strName
    Dim lngIndex As Long
    Dim strChar As String
545:     For lngIndex = 1 To Len(strOutput)
546:       strChar = Mid(strOutput, lngIndex, 1)
547:       If InStr(1, strAcceptable, strChar, vbTextCompare) = 0 Then
548:         strOutput = Replace(strOutput, strChar, "_")
549:       End If
550:     Next lngIndex
551:     If booStartWithLetter Then
      Dim strLetters As String
553:       strLetters = "abcdefghijklmnopqrstuvwxyz"
554:       If InStr(1, strLetters, Left(strOutput, 1), vbTextCompare) = 0 Then
555:         strOutput = "z" & strOutput
556:       End If
557:     End If
558:     ReplaceBadChars = strOutput
559:   End If


  Exit Function
ErrorHandler:
  HandleError True, "ReplaceBadChars " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function CreateGeneralTable(Optional strDir As String = "", Optional strName As String = "", _
    Optional lngCategory As JenDatasetTypes = ENUM_Shapefile, Optional pAddFields As esriSystem.IVariantArray, _
    Optional strGxDialogCaption As String = "Specify New Table Name:") As ITable
  On Error GoTo ErrorHandler

  ' IF booIsFClass = FALSE, THEN THIS FUNCTION WILL CREATE A TABLE INSTEAD
  
  ' THIS FUNCTION ONLY ALLOWS YOU TO WRITE TO A FEATURE DATASET IF IT FORCES USER TO SELECT FEATURE DATASET WITH IGxCatalog.
  ' IF YOU SEND A SPECIFIC PATHNAME AND FILENAME, THIS FUNCTION WILL NOT ALLOW YOU TO SAVE TO A FEATURE DATASET.
  
  Dim pGxDataset As IGxDataset
  Dim pDataset As IDataset
  Dim pWorkspace As IWorkspace
  Dim pFeatureClassName As IFeatureClassName
  Dim pFeatureDatasetName As IName
  Dim pFeatureDataset As IFeatureDataset
  Dim booHasFeatureDataset As Boolean
  Dim strFeatDataset As String
  Dim strPath As String
  Dim strCategory As String
  Dim strParent As String
  Dim strBaseName As String
  Dim pFeatWS As IFeatureWorkspace
  Dim pWSFact As IWorkspaceFactory2
  Dim pTableName As String
  Dim pTable As ITable
  Dim strWsPathName As String
  Dim pGxObj As IGxObject
  Dim pGxDialog As IGxDialog
  Dim pGxFCFilter As IGxObjectFilter
  Dim pFilterCol As IGxObjectFilterCollection

  ' CHECK IF TABLE ALREADY EXISTS
  Dim booAlreadyExists As Boolean
601:   booAlreadyExists = True
  Dim lngResponse As VbMsgBoxResult
  
604:   Do Until booAlreadyExists = False
     
    ' FIRST, CHECK IF DIRECTORY, NAME AND CATEGORY ARE SPECIFIED
607:     If strDir <> "" And strName <> "" Then
      
      Select Case lngCategory
        Case ENUM_Shapefile
611:           strCategory = "Shapefile"
612:           strName = Brad_Convert.aml_func_mod.SetExtension(strName, "dbf")
613:           If Right(strDir, 1) <> "\" Then strDir = strDir & "\"
        Case ENUM_FileGDB
615:           strCategory = "File Geodatabase Feature Class"
        Case ENUM_PersonalGDB
617:           strCategory = "Personal Geodatabase Feature Class"
        Case Else
619:           MsgBox "PROBLEM:  This function can only create dBASE Tables, File GeoDatabase Tables, or " & vbCrLf & _
              "Personal GeoDatabase Tables.  Bailing out...", vbOKOnly, "Invalid Output Type:"
621:           Set CreateGeneralTable = Nothing
          Exit Function
623:       End Select
      
625:       strWsPathName = strDir
626:       booHasFeatureDataset = False
627:       strBaseName = strName
628:       booHasFeatureDataset = False
629:       strFeatDataset = ""
630:     Else
    
 '     If pGxObj Is Nothing Or IsMissing(pGxObj) Then  ' IF NEED TO ASK USER TO SPECIFY GxObject
      
634:       Set pGxDialog = New GxDialog
635:       Set pGxFCFilter = New GxFilterTables
      
637:       Set pFilterCol = pGxDialog
638:       pFilterCol.AddFilter pGxFCFilter, True
639:       pGxDialog.Title = strGxDialogCaption
640:       pGxDialog.AllowMultiSelect = False
641:       pGxDialog.ButtonCaption = "Enter"
        
643:       If Not pGxDialog.DoModalSave(0) Then
644:           Set CreateGeneralTable = Nothing
          Exit Function 'Exit if user press Cancel
646:       End If
      
648:       Set pGxObj = pGxDialog.FinalLocation
649:       strWsPathName = pGxObj.FullName
650:       strBaseName = pGxDialog.Name
    
 '     End If
  
  '    Dim pGxCat As IGxCatalog
  '    Set pGxCat = pGxDialog.InternalCatalog
  
      ' CHECK TO SEE IF WE ARE WRITING TO A FEATURE DATASET
658:       If TypeOf pGxObj Is IGxDataset Then
659:         Set pGxDataset = pGxObj
          
661:         Set pDataset = pGxDataset.Dataset
662:         Set pWorkspace = pDataset.Workspace
663:         strWsPathName = pWorkspace.PathName
      
665:         Set pFeatureDatasetName = pDataset.FullName
        
667:         booHasFeatureDataset = TypeOf pDataset Is IFeatureDataset
668:         If booHasFeatureDataset Then
669:           Set pGxObj = pGxObj.Parent  ' BACK OUT IF FEATURE DATASET IF WE ARE IN ONE
670:         End If
671:       End If
      
673:       strCategory = pGxObj.Category
674:     End If
    
    ' NOW WE KNOW NAME, CATEGORY AND WORKSPACE.  NEXT CREATE WORKSPACE FACTORY
    Select Case strCategory
       Case "Shapefile", "Folder", "dBASE Table"
679:          Set pWSFact = New ShapefileWorkspaceFactory
680:          pTableName = strBaseName
       Case "File Geodatabase Feature Class", "File Geodatabase Raster Catalog", _
           "File Geodatabase", "File Geodatabase Feature Dataset", "File Geodatabase Table"
683:          Set pWSFact = New FileGDBWorkspaceFactory
684:          pTableName = strBaseName
       Case "Personal Geodatabase Feature Class", "Personal Geodatabase Raster Catalog", _
           "Personal Geodatabase", "Personal Geodatabase Feature Dataset", _
           "Personal Geodatabase Table"
688:          Set pWSFact = New AccessWorkspaceFactory
689:          pTableName = strBaseName
'       Case "Polygon Feature Class", "Arc Feature Class", "Point Feature Class", "Route Feature Class", _
'            "Tic Feature Class", "Region Feature Class", "Label Feature Class"
'         Set pWSFact = New ArcInfoWorkspaceFactory
'         If booHasFeatureDataset Then
'           pTableName = strFeatDataset & ":" & strBaseName
'         Else
'           pTableName = strBaseName
'         End If
'       Case "SDC Feature Class"
'         Set pWSFact = New SDCWorkspaceFactory
'         If booHasFeatureDataset Then
'           pTableName = strFeatDataset & ":" & strBaseName
'         Else
'           pTableName = strBaseName
'         End If
       Case Else
706:          MsgBox "Unexpected Workspace Type (" & strCategory & ")!  Need to write new code for this..."
707:          Set CreateGeneralTable = Nothing
         Exit Function
709:     End Select
    
  '  Debug.Print "Full Name = " & strPath & vbCrLf & "Name = " & strName & vbCrLf & _
        "Base Name = " & strBaseName & vbCrLf & "Category = " & strCategory & vbCrLf & "Parent = " & strParent & _
        vbCrLf & "Show String = " & strShowString & vbCrLf & "Save String = " & strSaveString & vbCrLf & _
        "Workspace Pathname = " & pWorkspace.PathName
     
    ' FOR DEBUGGING
  '  Dim frmReportForm As EcoAir_Map.frmReportDialog
  '  Beep
  '  Set frmReportForm = New EcoAir_Map.frmReportDialog
  '  frmReportForm.txtReport.Text = strWsPathName & vbCrLf & strCategory & vbCrLf & pTableName
  '  frmReportForm.Show vbModal
  '  Set frmReportForm = Nothing
  '  MsgBox strWsPathname & vbCrLf & strCategory & vbCrLf & lngCategory
724:     If Right(strWsPathName, 1) = "\" Or Right(strWsPathName, 1) = "/" Then
725:       strWsPathName = Left(strWsPathName, Len(strWsPathName) - 1)
726:     End If
727:     Set pFeatWS = pWSFact.OpenFromFile(strWsPathName, 0)
        
729:     booAlreadyExists = CheckIfTableExists(pFeatWS, strBaseName)
730:     If booAlreadyExists Then
731:       lngResponse = MsgBox("The Table '" & pTableName & "' already exists!  Do you wish to overwrite it?", _
            vbYesNo, "Table Already Exists:")
733:       If lngResponse = vbYes Then
        ' DELETE FEATURE CLASS
        Dim pDelete As ITable
        Dim pDelDataset As IDataset
737:         Set pDelete = pFeatWS.OpenTable(strBaseName)
738:         Set pDelDataset = pDelete
739:         If pDelDataset.CanDelete Then
740:           pDelDataset.DELETE
741:         Else
742:           MsgBox "Unable to delete " & pDataset.Name & "!  Bailing out..."
743:           Set CreateGeneralTable = Nothing
          Exit Function
745:         End If
746:         booAlreadyExists = CheckIfTableExists(pFeatWS, strBaseName)
747:       Else
748:         Set CreateGeneralTable = Nothing
749:         Set pGxObj = Nothing
750:         strName = ""
751:       End If
752:     End If
753:   Loop
  
  ' NOW READY TO CREATE TABLE
756:   If strCategory = "Shapefile" Or strCategory = "Folder" Or strCategory = "dBASE Table" Then      ' IF dBASE TABLE
757:     Set pTable = CreatedBASETableInFolder(strWsPathName, strBaseName, pAddFields)
758:   Else                                                                                            ' IF IN FILE OR PERSONAL GEODATABASE
759:     Set pTable = CreateGDBTable(pFeatWS, strBaseName, pAddFields)
760:   End If
  
762:   Set CreateGeneralTable = pTable
  

  Exit Function
ErrorHandler:
  HandleError True, "CreateGeneralTable " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function


Public Function CreateGeneralFeatureClass(pGeomType As esriGeometryType, pSpatialReference As ISpatialReference, _
    Optional strDir As String = "", Optional strName As String = "", Optional lngCategory As JenDatasetTypes = ENUM_Shapefile, _
    Optional pAddFields As esriSystem.IVariantArray, Optional strGxDialogCaption As String = "Specify New Feature Class Name:", _
    Optional booIsInFeatureDataset As Boolean = False, Optional strFeatureDatasetName As String, _
    Optional booIsFClass As Boolean = True, Optional booForceUniqueIDField As Boolean = True, _
    Optional pExtent As IEnvelope, Optional lngOriginalRecCount As Long = -9999) As IFeatureClass
  On Error GoTo ErrorHandler

  ' IF booIsFClass = FALSE, THEN THIS FUNCTION WILL CREATE A TABLE INSTEAD
  
  ' THIS FUNCTION ONLY ALLOWS YOU TO WRITE TO A FEATURE DATASET IF IT FORCES USER TO SELECT FEATURE DATASET WITH IGxCatalog.
  ' IF YOU SEND A SPECIFIC PATHNAME AND FILENAME, THIS FUNCTION WILL NOT ALLOW YOU TO SAVE TO A FEATURE DATASET.
  
  Dim pGxDataset As IGxDataset
  Dim pDataset As IDataset
  Dim pWorkspace As IWorkspace
  Dim pFeatureClassName As IFeatureClassName
  Dim pFeatureDatasetName As IName
  Dim pFeatureDataset As IFeatureDataset
  Dim booHasFeatureDataset As Boolean
  Dim strFeatDataset As String
  Dim strPath As String
  Dim strCategory As String
  Dim strParent As String
  Dim strBaseName As String
  Dim pFeatWS As IFeatureWorkspace
  Dim pWSFact As IWorkspaceFactory2
  Dim pFClassName As String
  Dim pFClass As IFeatureClass
  Dim strWsPathName As String
  Dim pGxObj As IGxObject
  Dim pGxDialog As IGxDialog
  Dim pGxFCFilter As IGxObjectFilter
  Dim pFilterCol As IGxObjectFilterCollection

  ' CHECK IF FEATURECLASS ALREADY EXISTS
  Dim booAlreadyExists As Boolean
808:   booAlreadyExists = True
  Dim lngResponse As VbMsgBoxResult
  
811:   Do Until booAlreadyExists = False
     
    ' FIRST, CHECK IF DIRECTORY, NAME AND CATEGORY ARE SPECIFIED
814:     If strDir <> "" And strName <> "" Then
      
      Select Case lngCategory
        Case ENUM_Shapefile
818:           strCategory = "Shapefile"
819:           strName = Brad_Convert.aml_func_mod.SetExtension(strName, "shp")
820:           If Right(strDir, 1) <> "\" Then strDir = strDir & "\"
        Case ENUM_FileGDB
822:           strCategory = "File Geodatabase Feature Class"
        Case ENUM_PersonalGDB
824:           strCategory = "Personal Geodatabase Feature Class"
        Case Else
826:           MsgBox "PROBLEM:  This function can only create shapefiles, file geodatabase feature classes, or " & vbCrLf & _
              "personal geodatabase feature classes.  Bailing out...", vbOKOnly, "Invalid Output Type:"
828:           Set CreateGeneralFeatureClass = Nothing
          Exit Function
830:       End Select
      
832:       strWsPathName = strDir
833:       booHasFeatureDataset = False
834:       strBaseName = strName
835:       booHasFeatureDataset = booIsInFeatureDataset
836:       strFeatDataset = strFeatureDatasetName
837:     Else
    
 '     If pGxObj Is Nothing Or IsMissing(pGxObj) Then  ' IF NEED TO ASK USER TO SPECIFY GxObject
      
841:       Set pGxDialog = New GxDialog
842:       Set pGxFCFilter = New GxFilterFeatureClasses
      
844:       Set pFilterCol = pGxDialog
845:       pFilterCol.AddFilter pGxFCFilter, True
846:       pGxDialog.Title = strGxDialogCaption
847:       pGxDialog.AllowMultiSelect = False
848:       pGxDialog.ButtonCaption = "Enter"
        
850:       If Not pGxDialog.DoModalSave(0) Then
851:           Set CreateGeneralFeatureClass = Nothing
          Exit Function 'Exit if user press Cancel
853:       End If
      
855:       Set pGxObj = pGxDialog.FinalLocation
856:       strWsPathName = pGxObj.FullName
857:       strBaseName = pGxDialog.Name
    
 '     End If
  
  '    Dim pGxCat As IGxCatalog
  '    Set pGxCat = pGxDialog.InternalCatalog
  
      ' CHECK TO SEE IF WE ARE WRITING TO A FEATURE DATASET
865:       If TypeOf pGxObj Is IGxDataset Then
866:         Set pGxDataset = pGxObj
          
868:         Set pDataset = pGxDataset.Dataset
869:         Set pWorkspace = pDataset.Workspace
870:         strWsPathName = pWorkspace.PathName
      
''        Set pFeatureClassName = pDataset.FullName
873:         Set pFeatureDatasetName = pDataset.FullName
        
875:         booHasFeatureDataset = TypeOf pDataset Is IFeatureDataset
876:         If booHasFeatureDataset Then
877:           Set pFeatureDataset = pDataset
878:           strFeatDataset = pFeatureDataset.Name
879:         End If
880:       End If
          
'      strPath = pGxObj.FullName
883:       strCategory = pGxObj.Category
'      strName = pGxObj.Name
'      strParent = pGxObj.Parent.FullName
'      strBaseName = pGxObj.BaseName
'      strWsPathName = pWorkspace.PathName
888:     End If
    
    ' NOW WE KNOW NAME, CATEGORY AND WORKSPACE.  NEXT CREATE WORKSPACE FACTORY
    Select Case strCategory
       Case "Shapefile", "Folder"
893:          Set pWSFact = New ShapefileWorkspaceFactory
894:          pFClassName = strBaseName
       Case "File Geodatabase Feature Class", "File Geodatabase Raster Catalog", "File Geodatabase", "File Geodatabase Feature Dataset"
896:          Set pWSFact = New FileGDBWorkspaceFactory
897:          If booHasFeatureDataset Then
898:            pFClassName = strFeatDataset & ":" & strBaseName
899:          Else
900:            pFClassName = strBaseName
901:          End If
       Case "Personal Geodatabase Feature Class", "Personal Geodatabase Raster Catalog", "Personal Geodatabase", "Personal Geodatabase Feature Dataset"
903:          Set pWSFact = New AccessWorkspaceFactory
904:          If booHasFeatureDataset Then
905:            pFClassName = strFeatDataset & ":" & strBaseName
906:          Else
907:            pFClassName = strBaseName
908:          End If
'       Case "Polygon Feature Class", "Arc Feature Class", "Point Feature Class", "Route Feature Class", _
'            "Tic Feature Class", "Region Feature Class", "Label Feature Class"
'         Set pWSFact = New ArcInfoWorkspaceFactory
'         If booHasFeatureDataset Then
'           pFClassName = strFeatDataset & ":" & strBaseName
'         Else
'           pFClassName = strBaseName
'         End If
'       Case "SDC Feature Class"
'         Set pWSFact = New SDCWorkspaceFactory
'         If booHasFeatureDataset Then
'           pFClassName = strFeatDataset & ":" & strBaseName
'         Else
'           pFClassName = strBaseName
'         End If
       Case Else
925:          MsgBox "Unexpected Feature Class Type (" & strCategory & ")!  Need to write new code for this..."
926:          Set CreateGeneralFeatureClass = Nothing
         Exit Function
928:     End Select
    
  '  Debug.Print "Full Name = " & strPath & vbCrLf & "Name = " & strName & vbCrLf & _
        "Base Name = " & strBaseName & vbCrLf & "Category = " & strCategory & vbCrLf & "Parent = " & strParent & _
        vbCrLf & "Show String = " & strShowString & vbCrLf & "Save String = " & strSaveString & vbCrLf & _
        "Workspace Pathname = " & pWorkspace.PathName
     
    ' FOR DEBUGGING
  '  Dim frmReportForm As EcoAir_Map.frmReport_modal
  '  Beep
  '  Set frmReportForm = New EcoAir_Map.frmReport_modal
  '  frmReportForm.txtReport.Text = strWsPathName & vbCrLf & strCategory & vbCrLf & pFClassName
  '  frmReportForm.Show vbModal
  '  Set frmReportForm = Nothing
  '  MsgBox strWsPathname & vbCrLf & strCategory & vbCrLf & lngCategory
943:     If Right(strWsPathName, 1) = "\" Or Right(strWsPathName, 1) = "/" Then
944:       strWsPathName = Left(strWsPathName, Len(strWsPathName) - 1)
945:     End If
946:     If Right(strWsPathName, 1) = "\" Or Right(strWsPathName, 1) = "/" Then
947:       strWsPathName = Left(strWsPathName, Len(strWsPathName) - 1)
948:     End If
949:     Set pFeatWS = pWSFact.OpenFromFile(strWsPathName, 0)
    
    ' GET FEATURE DATASET IF IT EXISTS
952:     If booHasFeatureDataset Then Set pFeatureDataset = pFeatWS.OpenFeatureDataset(strFeatDataset)
    
954:     booAlreadyExists = CheckIfFeatureClassExists(pFeatWS, strBaseName)
955:     If booAlreadyExists Then
956:       lngResponse = MsgBox("The Feature Class '" & pFClassName & "' already exists!  Do you wish to overwrite it?", _
            vbYesNo, "Feature Class Already Exists:")
958:       If lngResponse = vbYes Then
        ' DELETE FEATURE CLASS
        Dim pDelete As IFeatureClass
        Dim pDelDataset As IDataset
962:         Set pDelete = pFeatWS.OpenFeatureClass(strBaseName)
963:         Set pDelDataset = pDelete
964:         pDelDataset.DELETE
965:         booAlreadyExists = CheckIfFeatureClassExists(pFeatWS, strBaseName)
966:       Else
967:         Set CreateGeneralFeatureClass = Nothing
968:         Set pGxObj = Nothing
969:         strName = ""
970:       End If
971:     End If
972:   Loop
  
  
  ' NOW READY TO CREATE FEATURE CLASS
976:   If booHasFeatureDataset Then                                                     ' IF IN FEATURE DATASET
977:     Set pFClass = CreateDatasetFeatureClass(pFeatureDataset, strBaseName, esriFTSimple, pGeomType, pAddFields)
978:   ElseIf strCategory = "Shapefile" Or strCategory = "Folder" Then                  ' IF SHAPEFILE
979:     Set pFClass = CreateShapefileFeatureClass(strWsPathName, strBaseName, pSpatialReference, pGeomType, pAddFields, booForceUniqueIDField)
980:   Else                                                                             ' IF IN FILE OR PERSONAL GEODATABASE
'    Set pFClass = invoiceCreator.Brad_Convert.aml_func_mod.createWorkspaceFeatureClass(pFeatWS, strBaseName, esriFTSimple, pGeomType)
982:     Set pFClass = CreateGDBFeatureClass(pFeatWS, strBaseName, esriFTSimple, pSpatialReference, pGeomType, pAddFields, , , , , _
          lngCategory, pExtent, lngOriginalRecCount)
984:   End If
  
986:   Set CreateGeneralFeatureClass = pFClass
  

  Exit Function
ErrorHandler:
  HandleError True, "CreateGeneralFeatureClass " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function CheckIfTableExists(pWS As IFeatureWorkspace, strName As String) As Boolean
  On Error GoTo ErrorHandler

    Dim pTable As ITable
    On Error Resume Next
999:     Set pTable = pWS.OpenTable(strName)
1000:     If pTable Is Nothing Then
1001:         CheckIfTableExists = False
1002:     Else
1003:         CheckIfTableExists = True
1004:     End If
1005:     If CheckIfTableExists = False Then
      Dim pFClass As ITable
1007:       Set pFClass = pWS.OpenFeatureClass(strName)
1008:       If pFClass Is Nothing Then
1009:           CheckIfTableExists = False
1010:       Else
1011:           CheckIfTableExists = True
1012:       End If
1013:     End If

  Exit Function
ErrorHandler:
  HandleError True, "CheckIfTableExists " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
Public Function CheckIfFeatureClassExists(pWS As IFeatureWorkspace, strName As String) As Boolean
  On Error GoTo ErrorHandler

    Dim pFClass As IFeatureClass
    On Error Resume Next
1024:     Set pFClass = pWS.OpenFeatureClass(strName)
1025:     If pFClass Is Nothing Then
1026:         CheckIfFeatureClassExists = False
1027:     Else
1028:         CheckIfFeatureClassExists = True
1029:     End If
1030:     If CheckIfFeatureClassExists = False Then
      Dim pTable As ITable
1032:       Set pTable = pWS.OpenTable(strName)
1033:       If pTable Is Nothing Then
1034:           CheckIfFeatureClassExists = False
1035:       Else
1036:           CheckIfFeatureClassExists = True
1037:       End If
1038:     End If

  Exit Function
ErrorHandler:
  HandleError True, "CheckIfFeatureClassExists " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function MakeUniqueGDBTableName(pWS As IWorkspace, strName As String) As String
  On Error GoTo ErrorHandler
  
  Dim booTableExists As Boolean
1049:   booTableExists = CheckIfTableExists(pWS, strName)
  Dim theCounter As Long
1051:   theCounter = 1
  Dim strBaseName As String
  Dim strNewName As String
1054:   strBaseName = strName
1055:   strNewName = strName
1056:   Do Until booTableExists = False
1057:     theCounter = theCounter + 1
1058:     strNewName = strBaseName & "_" & CStr(theCounter)
1059:     booTableExists = CheckIfTableExists(pWS, strNewName)
1060:   Loop
  
1062:   MakeUniqueGDBTableName = strNewName
  
  Exit Function
ErrorHandler:
  HandleError True, "MakeUniqueGDBTableName " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
Public Function MakeUniqueGDBFeatureClassName(pWS As IWorkspace, strName As String) As String
  On Error GoTo ErrorHandler
  
  Dim booFCExists As Boolean
1072:   booFCExists = CheckIfFeatureClassExists(pWS, strName)
  Dim theCounter As Long
1074:   theCounter = 1
  Dim strBaseName As String
  Dim strNewName As String
1077:   strBaseName = strName
1078:   strNewName = strName
1079:   Do Until booFCExists = False
1080:     theCounter = theCounter + 1
1081:     strNewName = strBaseName & "_" & CStr(theCounter)
1082:     booFCExists = CheckIfFeatureClassExists(pWS, strNewName)
1083:   Loop
  
1085:   MakeUniqueGDBFeatureClassName = strNewName
  
  Exit Function
ErrorHandler:
  HandleError True, "MakeUniqueGDBFeatureClassName " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function MakeUniquedBASEName(strFileName As String) As String
  On Error GoTo ErrorHandler

1095:   If Not ExistFileDir(strFileName) Then
1096:     MakeUniquedBASEName = strFileName
    Exit Function
1098:   Else
    
    Dim theCounter As Long
1101:     theCounter = 1
    
    Dim theFilename As String
    Dim theBaseName As String
    Dim thePointPos As Long
    Dim theExtension As String
    
1108:     If InStr(1, Right(strFileName, 5), ".", vbTextCompare) > 0 Then
1109:       thePointPos = InStrRev(strFileName, ".", -1, vbTextCompare)
1110:       theExtension = Right(strFileName, Len(strFileName) - (thePointPos - 1))
1111:       theFilename = Left(strFileName, thePointPos - 1)
1112:     Else
1113:       theExtension = ""
1114:       theFilename = strFileName
1115:     End If
    
1117:     theBaseName = theFilename
    
1119:     Do While ExistFileDir(theFilename & theExtension)
1120:       theCounter = theCounter + 1
1121:       theFilename = theBaseName & "_" & CStr(theCounter)
1122:     Loop
    
1124:     MakeUniquedBASEName = theFilename & theExtension
    
1126:   End If

  Exit Function
ErrorHandler:
  HandleError True, "MakeUniquedBASEName " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function MakeUniqueShapeFilename(strFileName As String) As String
  On Error GoTo ErrorHandler

1136:   If Not ExistFileDir(strFileName) Then
1137:     MakeUniqueShapeFilename = strFileName
    Exit Function
1139:   Else
    
    Dim theCounter As Long
1142:     theCounter = 1
    
    Dim theFilename As String
    Dim theBaseName As String
    Dim thePointPos As Long
    Dim theExtension As String
    
1149:     If InStr(1, Right(strFileName, 5), ".", vbTextCompare) > 0 Then
1150:       thePointPos = InStrRev(strFileName, ".", -1, vbTextCompare)
1151:       theExtension = Right(strFileName, Len(strFileName) - (thePointPos - 1))
1152:       theFilename = Left(strFileName, thePointPos - 1)
1153:     Else
1154:       theExtension = ""
1155:       theFilename = strFileName
1156:     End If
    
1158:     theBaseName = theFilename
    
1160:     Do While ExistFileDir(theFilename & theExtension)
1161:       theCounter = theCounter + 1
1162:       theFilename = theBaseName & "_" & CStr(theCounter)
1163:     Loop
    
1165:     MakeUniqueShapeFilename = theFilename & theExtension
    
1167:   End If

  Exit Function
ErrorHandler:
  HandleError True, "MakeUniqueShapeFilename " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function


Public Function CreateGDBTable(featWorkspace As IFeatureWorkspace, _
                                            Name As String, _
                                            Optional pAddFields As esriSystem.IVariantArray, _
                                            Optional pCLSID As UID, _
                                            Optional pCLSEXT As UID, _
                                            Optional ConfigWord As String = "" _
                                            ) As ITable
  On Error GoTo ErrorHandler
 
'' createWorkspaceFeatureClass: simple helper to create a featureclass in a geodatabase workspace.
'' NOTE: when creating a feature class in a workspace it is important to assign the spatial
''       reference to the geometry field.
'' MODIFIED BY JENNESS APRIL 23 2008 FROM ESRI SAMPLE
  
1189:   Set CreateGDBTable = Nothing
  If featWorkspace Is Nothing Then Exit Function
  If Name = "" Then Exit Function
  
1193:   If (pCLSID Is Nothing) Or IsMissing(pCLSID) Then
1194:     Set pCLSID = Nothing
1195:     Set pCLSID = New UID
1196:     pCLSID.Value = "esriGeoDatabase.Object"
1197:   End If
  
  ' CREATE OBJECT ID FIELD; ADD ANY REQUESTED FIELDS IF NECESSARY
  ' establish a fields collection
  Dim pFields As IFields
  Dim pFieldsEdit As IFieldsEdit
  Dim pGeomDef As IGeometryDef
  Dim pGeomDefEdit As IGeometryDefEdit
  Dim pField As IField
  Dim pFieldEdit As IFieldEdit
  
1208:   Set pFields = New Fields
1209:   Set pFieldsEdit = pFields
  
  '' create the object id field
1212:   Set pField = New Field
1213:   Set pFieldEdit = pField
1214:   pFieldEdit.Name = "Object_ID"
 '   pFieldEdit.AliasName = "object identifier"
1216:   pFieldEdit.Type = esriFieldTypeOID
1217:   pFieldsEdit.AddField pField
 
  ' ADD FIELDS IF REQUESTED
1220:   If Not (pAddFields Is Nothing Or IsMissing(pAddFields)) Then
    Dim lngIndex As Long
1222:     For lngIndex = 0 To pAddFields.Count - 1
1223:       pFieldsEdit.AddField pAddFields.Element(lngIndex)
1224:     Next lngIndex
1225:   End If
  
  ' establish the class extension
1228:   If (pCLSEXT Is Nothing) Or IsMissing(pCLSEXT) Then
1229:     Set pCLSEXT = Nothing
1230:   End If
  
1232:   Set CreateGDBTable = featWorkspace.CreateTable(Name, pFields, pCLSID, pCLSEXT, "")
    
  Exit Function
ErrorHandler:
  HandleError True, "CreateGDBTable " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function CreateGDBFeatureClass(featWorkspace As IFeatureWorkspace, _
                                            Name As String, _
                                            featType As esriFeatureType, _
                                            pSpRef As ISpatialReference, _
                                            Optional geomType As esriGeometryType = esriGeometryPoint, _
                                            Optional pAddFields As esriSystem.IVariantArray, _
                                            Optional pCLSID As UID, _
                                            Optional pCLSEXT As UID, _
                                            Optional ConfigWord As String = "", _
                                            Optional booForceUniqueIDField As Boolean = True, _
                                            Optional lngCategory As JenDatasetTypes, _
                                            Optional pExtent As IEnvelope, _
                                            Optional lngOriginalRecCount As Long = -9999) As IFeatureClass
  On Error GoTo ErrorHandler

 
'' createWorkspaceFeatureClass: simple helper to create a featureclass in a geodatabase workspace.
'' NOTE: when creating a feature class in a workspace it is important to assign the spatial
''       reference to the geometry field.
'' MODIFIED BY JENNESS APRIL 23 2008 FROM ESRI SAMPLE
  
1260:   Set CreateGDBFeatureClass = Nothing
  If featWorkspace Is Nothing Then Exit Function
  If Name = "" Then Exit Function
  
1264:   If (pCLSID Is Nothing) Or IsMissing(pCLSID) Then
1265:     Set pCLSID = Nothing
1266:     Set pCLSID = New UID
    
    '' determine the appropriate geometry type corresponding the the feature type
    Select Case featType
      Case esriFTSimple
1271:         pCLSID.Value = "esriGeoDatabase.Feature"
1272:         If geomType = esriGeometryLine Then geomType = esriGeometryPolyline
      Case esriFTSimpleJunction
1274:         geomType = esriGeometryPoint
1275:         pCLSID.Value = "esriGeoDatabase.SimpleJunctionFeature"
      Case esriFTComplexJunction
1277:         pCLSID.Value = "esriGeoDatabase.ComplexJunctionFeature"
      Case esriFTSimpleEdge
1279:         geomType = esriGeometryPolyline
1280:         pCLSID.Value = "esriGeoDatabase.SimpleEdgeFeature"
      Case esriFTComplexEdge
1282:         geomType = esriGeometryPolyline
1283:         pCLSID.Value = "esriGeoDatabase.ComplexEdgeFeature"
      Case esriFTAnnotation
        Exit Function
1286:     End Select
1287:   End If
  
  ' CREATE GEOMETRY AND OBJECT ID FIELD; ADD ANY REQUESTED FIELDS IF NECESSARY
  ' establish a fields collection
  Dim pFields As IFields
  Dim pFieldsEdit As IFieldsEdit
  Dim pGeomDef As IGeometryDef
  Dim pGeomDefEdit As IGeometryDefEdit
  Dim pField As IField
  Dim pFieldEdit As IFieldEdit
  
1298:   Set pFields = New Fields
1299:   Set pFieldsEdit = pFields
  
  '' create the geometry field
1302:   Set pGeomDef = New GeometryDef
1303:   Set pGeomDefEdit = pGeomDef
  
  ' SPATIAL INDEX STUFF
  ' WOULD LIKE THE AVERAGE NUMBER OF FEATURES PER GRID CELL TO BE AROUND 200
  ' GOING TO DEFAULT TO ONE SPATIAL INDEX GRID
  Dim dblIndex0 As Double
  Dim dblIndex1 As Double
  Dim dblIndex2 As Double
1311:   dblIndex0 = 100
1312:   dblIndex1 = 0
1313:   dblIndex2 = 0
  
1315:   If Not pExtent Is Nothing And lngOriginalRecCount > 0 Then
1316:     If Not pExtent.IsEmpty Then
      Dim dblOptimalGridCells As Double
1318:       dblOptimalGridCells = lngOriginalRecCount / 200
      Dim dblX As Double
      Dim dblY As Double
1321:       dblX = pExtent.Width
1322:       dblY = pExtent.Height
1323:       dblIndex0 = Sqr(dblX * dblY / dblOptimalGridCells)
1324:       If dblIndex0 > dblX Then
1325:         dblIndex0 = dblX
1326:       End If
1327:       If dblIndex0 > dblY Then
1328:         dblIndex0 = dblY
1329:       End If
      
1331:       dblIndex1 = 0
1332:       dblIndex2 = 0
1333:     End If
1334:   End If
  
1336:   If Not CheckSpRefDomain(pSpRef) Then
    Dim pSpRefRes As ISpatialReferenceResolution
1338:     Set pSpRefRes = pSpRef
1339:     pSpRefRes.ConstructFromHorizon
1340:   End If
  
  '' assign the geometry definiton properties.
1343:   With pGeomDefEdit
1344:     .GeometryType = geomType
1345:     If lngCategory = ENUM_FileGDB Then       ' FILE GDB
1346:       .GridCount = 1
1347:       .GridSize(0) = dblIndex0
'      .GridSize(1) = dblIndex1
'      .GridSize(2) = dblIndex2
'      .AvgNumPoints = 2
1351:     Else
1352:       .GridCount = 1
1353:       .GridSize(0) = dblIndex0
1354:     End If
1355:     .HasM = False
1356:     .HasZ = False
1357:     Set .SpatialReference = pSpRef
1358:   End With
  
1360:   Set pField = New Field
1361:   Set pFieldEdit = pField
  
1363:   pFieldEdit.Name = "Shape"
1364:   pFieldEdit.AliasName = "geometry"
1365:   pFieldEdit.Type = esriFieldTypeGeometry
1366:   Set pFieldEdit.GeometryDef = pGeomDef
1367:   pFieldsEdit.AddField pField

  '' create the object id field
'  If booForceUniqueIDField Then
    
    
    Dim strUniqueName As String
    Dim strUniqueBase As String
1375:     strUniqueName = "Object_ID"
1376:     strUniqueBase = strUniqueName
    Dim lngUniqueCounter As Long
1378:     lngUniqueCounter = 1
    Dim lngCounterLength As Long
    Dim lngUniqueIndex As Long
    Dim booNameExists As Boolean
    Dim pCheckField As IField
1383:     booNameExists = True
1384:     If (pAddFields Is Nothing Or IsMissing(pAddFields)) Then
1385:       booNameExists = False
1386:     Else
1387:       Do Until booNameExists = False
1388:         booNameExists = False
1389:         For lngUniqueIndex = 0 To pAddFields.Count - 1
1390:           Set pCheckField = pAddFields.Element(lngUniqueIndex)
1391:           If pCheckField.Name = strUniqueName Then
1392:             booNameExists = True
1393:             Exit For
1394:           End If
1395:         Next lngUniqueIndex
1396:         If booNameExists Then
1397:           lngUniqueCounter = lngUniqueCounter + 1
1398:           lngCounterLength = Len(CStr(lngUniqueCounter))
1399:           strUniqueName = Left(strUniqueBase, 11 - lngCounterLength) & CStr(lngUniqueCounter)
1400:         End If
1401:       Loop
1402:     End If
    
1404:     Set pField = New Field
1405:     Set pFieldEdit = pField
1406:     pFieldEdit.Name = strUniqueName
1407:     pFieldEdit.AliasName = "object identifier"
1408:     pFieldEdit.Type = esriFieldTypeOID
1409:     pFieldsEdit.AddField pField
'  End If
  
  ' ADD FIELDS IF REQUESTED
1413:   If Not (pAddFields Is Nothing Or IsMissing(pAddFields)) Then
    Dim lngIndex As Long
1415:     For lngIndex = 0 To pAddFields.Count - 1
1416:       pFieldsEdit.AddField pAddFields.Element(lngIndex)
1417:     Next lngIndex
1418:   End If
  
  
  ' establish the class extension
1422:   If (pCLSEXT Is Nothing) Or IsMissing(pCLSEXT) Then
1423:     Set pCLSEXT = Nothing
1424:   End If
  
  ' locate the shape field
  Dim strShapeFld As String
  Dim j As Integer
1429:   For j = 0 To pFields.FieldCount - 1
1430:     If pFields.Field(j).Type = esriFieldTypeGeometry Then
1431:       strShapeFld = pFields.Field(j).Name
1432:     End If
1433:   Next
  
1435:   Set CreateGDBFeatureClass = featWorkspace.CreateFeatureClass(Name, pFields, pCLSID, _
                             pCLSEXT, featType, strShapeFld, ConfigWord)
  
  Exit Function
ErrorHandler:
  HandleError True, "CreateGDBFeatureClass " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Private Function CheckSpRefDomain(pSpRef As ISpatialReference) As Boolean
  On Error GoTo ErrorHandler
  
  Dim dXmax As Double
  Dim dYmax As Double
  Dim dXmin As Double
  Dim dYmin As Double
  
  'get the xy domain extent of the dataset
  
1453:   pSpRef.GetDomain dXmin, dXmax, dYmin, dYmax
1454:   CheckSpRefDomain = True
  
ErrorHandler:
1457:   CheckSpRefDomain = False

End Function

Public Function CreatedBASETableInFolder(sPath As String, sName As String, Optional pAddFields As esriSystem.IVariantArray) As ITable
  On Error GoTo ErrorHandler
  
1464:   If Right(sPath, 4) = ".dbf" Then sPath = ReturnDir(sPath)
1465:   If Right(sName, 4) = ".dbf" Then sName = Left(sName, Len(sName) - 4)
  
  ' Open the folder to contain the shapefile as a workspace
  Dim pFWS As IFeatureWorkspace
  Dim pWorkspaceFactory As IWorkspaceFactory
1470:   Set pWorkspaceFactory = New ShapefileWorkspaceFactory
  
1472:   If Not ExistFileDir(sPath) Then
1473:     MsgBox "Unable to create dBASE Table:" & vbCrLf & _
           sPath & " is not a valid workspace...", , "Failed to Create Table:"
1475:     Set CreatedBASETableInFolder = Nothing
    Exit Function
1477:   End If
  
1479:   Set pFWS = pWorkspaceFactory.OpenFromFile(sPath, 0)
  
'   Set up a simple fields collection
  Dim pFields As IFields
  Dim pFieldsEdit As IFieldsEdit
1484:   Set pFields = New Fields
1485:   Set pFieldsEdit = pFields

  Dim pField As IField
  Dim pFieldEdit As IFieldEdit
  
1490:   Set pField = New Field
1491:   Set pFieldEdit = pField
1492:   With pFieldEdit
1493:       .Precision = 8
1494:       .Name = "Unique_ID"
1495:       .Type = esriFieldTypeInteger
1496:   End With
1497:   pFieldsEdit.AddField pField
  
  ' ADD FIELDS IF REQUESTED
1500:   If Not (pAddFields Is Nothing Or IsMissing(pAddFields)) Then
    Dim lngIndex As Long
1502:     For lngIndex = 0 To pAddFields.Count - 1
1503:       pFieldsEdit.AddField pAddFields.Element(lngIndex)
1504:     Next lngIndex
1505:   End If
    
  ' Create the dBASE Table
  ' (some parameters apply to geodatabase options and can be defaulted as Nothing)
  Dim booFileExists As Boolean
  Dim strCheckString As String
1511:   If Right(sPath, 1) = "\" Then
1512:     strCheckString = sPath & sName & ".dbf"
'    MsgBox sPath & sName & ".dbf" & vbCrLf & "File Exists? " & CStr(Dir(sPath & sName & ".dbf") <> "")
1514:   Else
1515:     strCheckString = sPath & "\" & sName & ".dbf"
'    MsgBox sPath & "\" & sName & ".dbf" & vbCrLf & "File Exists? " & CStr(Dir(sPath & "\" & sName & ".dbf") <> "")
1517:   End If
  
1519:   booFileExists = (Dir(strCheckString) <> "")
  
1521:   If booFileExists Then
1522:     MsgBox "The following file already exists:" & vbCrLf & vbCrLf & strCheckString & vbCrLf & vbCrLf & _
           "Please select a new filename...", , "Duplicate Filename:"
1524:     Set CreatedBASETableInFolder = Nothing
    Exit Function
1526:   End If
  
  Dim pTable As ITable
1529:   Set pTable = pFWS.CreateTable(sName, pFields, Nothing, Nothing, "")
  
1531:   Set CreatedBASETableInFolder = pTable
  
  Exit Function
ErrorHandler:
  HandleError True, "CreatedBASETableInFolder " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
    

Public Function CreateShapefileFeatureClass(sPath As String, sName As String, pSpatialReference As ISpatialReference, _
    pGeomType As esriGeometryType, Optional pAddFields As esriSystem.IVariantArray, _
    Optional booForceUniqueIDField As Boolean = True) As IFeatureClass       ' Don't include filename!
  On Error GoTo ErrorHandler

  
1545:   If Right(sPath, 4) = ".shp" Then sPath = ReturnDir(sPath)
1546:   If Right(sName, 4) = ".shp" Then sName = Left(sName, Len(sName) - 4)
  
  ' SET GEOMETRY TYPE, AND EXIT IF NOT ONE OF STANDARD OPTIONS
  Dim pGeomDef As IGeometryDef
  Dim pGeomDefEdit As IGeometryDefEdit
1551:   Set pGeomDef = New GeometryDef
1552:   Set pGeomDefEdit = pGeomDef
1553:   With pGeomDefEdit
1554:     .GeometryType = pGeomType
1555:     Set .SpatialReference = pSpatialReference
1556:   End With
  
  ' Open the folder to contain the shapefile as a workspace
  Dim pFWS As IFeatureWorkspace
  Dim pWorkspaceFactory As IWorkspaceFactory
1561:   Set pWorkspaceFactory = New ShapefileWorkspaceFactory
  
1563:   If Not ExistFileDir(sPath) Then
1564:     MsgBox "Unable to create Feature Class:" & vbCrLf & _
           sPath & " is not a valid workspace...", , "Failed to Create Feature Class:"
1566:     Set CreateShapefileFeatureClass = Nothing
    Exit Function
1568:   End If
  
1570:   Set pFWS = pWorkspaceFactory.OpenFromFile(sPath, 0)
  
'   Set up a simple fields collection
  Dim pFields As IFields
  Dim pFieldsEdit As IFieldsEdit
1575:   Set pFields = New Fields
1576:   Set pFieldsEdit = pFields

  Dim pField As IField
  Dim pFieldEdit As IFieldEdit
  
  ' Make the shape field
  ' it will need a geometry definition, with a spatial reference
1583:   Set pField = New Field
1584:   Set pFieldEdit = pField
1585:   pFieldEdit.Name = "Shape"
1586:   pFieldEdit.Type = esriFieldTypeGeometry

1588:   Set pFieldEdit.GeometryDef = pGeomDef
1589:   pFieldsEdit.AddField pField
  
  ' MAKE SURE UNIQUE ID FIELD IS UNIQUELY NAMED
 
1593:   If booForceUniqueIDField Then
    Dim strUniqueName As String
    Dim strUniqueBase As String
1596:     strUniqueName = "Unique_ID"
1597:     strUniqueBase = strUniqueName
    Dim lngUniqueCounter As Long
1599:     lngUniqueCounter = 1
    Dim lngCounterLength As Long
    Dim lngUniqueIndex As Long
    Dim booNameExists As Boolean
    Dim pCheckField As IField
1604:     booNameExists = True
1605:     If (pAddFields Is Nothing Or IsMissing(pAddFields)) Then
1606:       booNameExists = False
1607:     Else
1608:       Do Until booNameExists = False
1609:         booNameExists = False
1610:         For lngUniqueIndex = 0 To pAddFields.Count - 1
1611:           Set pCheckField = pAddFields.Element(lngUniqueIndex)
1612:           If pCheckField.Name = strUniqueName Then
1613:             booNameExists = True
1614:             Exit For
1615:           End If
1616:         Next lngUniqueIndex
1617:         If booNameExists Then
1618:           lngUniqueCounter = lngUniqueCounter + 1
1619:           lngCounterLength = Len(CStr(lngUniqueCounter))
1620:           strUniqueName = Left(strUniqueBase, 10 - lngCounterLength) & CStr(lngUniqueCounter)
1621:         End If
1622:       Loop
1623:     End If
    
1625:     Set pField = New Field
1626:     Set pFieldEdit = pField
1627:     With pFieldEdit
1628:         .Precision = 8
1629:         .Name = strUniqueName
1630:         .Type = esriFieldTypeInteger
1631:     End With
1632:     pFieldsEdit.AddField pField
1633:   End If
  
  ' ADD FIELDS IF REQUESTED
'  Dim strDebugReport As String
'  Dim pDebugField As IField
1638:   If Not (pAddFields Is Nothing Or IsMissing(pAddFields)) Then
    Dim lngIndex As Long
1640:     For lngIndex = 0 To pAddFields.Count - 1
'      Set pDebugField = pAddFields.Element(lngIndex)
'      strDebugReport = strDebugReport & CStr(lngIndex) & "]  Field Name = " & pDebugField.Name & vbCrLf
1643:       pFieldsEdit.AddField pAddFields.Element(lngIndex)
1644:     Next lngIndex
1645:   End If
'  MsgBox CStr(pGeomDef.GeometryType) & vbCrLf & strDebugReport
  ' Create the shapefile
  ' (some parameters apply to geodatabase options and can be defaulted as Nothing)
  Dim booFileExists As Boolean
  Dim strCheckString As String
1651:   If Right(sPath, 1) = "\" Then
1652:     strCheckString = sPath & sName & ".shp"
'    MsgBox sPath & sName & ".shp" & vbCrLf & "File Exists? " & CStr(Dir(sPath & sName & ".shp") <> "")
1654:   Else
1655:     strCheckString = sPath & "\" & sName & ".shp"
'    MsgBox sPath & "\" & sName & ".shp" & vbCrLf & "File Exists? " & CStr(Dir(sPath & "\" & sName & ".shp") <> "")
1657:   End If
  
'  booFileExists = (Dir(strCheckString) <> "")
'  MsgBox strCheckString & vbCrLf & CStr(booFileExists)
  
1662:   If booFileExists Then
1663:     MsgBox "The following file already exists:" & vbCrLf & vbCrLf & strCheckString & vbCrLf & vbCrLf & _
           "Please select a new filename...", , "Duplicate Filename:"
1665:     Set CreateShapefileFeatureClass = Nothing
    Exit Function
1667:   End If
  
  Dim pFeatClass As IFeatureClass
1670:   Set pFeatClass = pFWS.CreateFeatureClass(sName, pFields, Nothing, _
                                           Nothing, esriFTSimple, "Shape", "")
                                           
1673:   Set CreateShapefileFeatureClass = pFeatClass



  Exit Function
ErrorHandler:
  HandleError True, "CreateShapefileFeatureClass " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

  
Public Function CreateDatasetFeatureClass(pFDS As IFeatureDataset, _
                                  Name As String, featType As esriFeatureType, _
                                  Optional geomType As esriGeometryType = esriGeometryPoint, _
                                  Optional pAddFields As esriSystem.IVariantArray, _
                                  Optional pCLSID As UID, _
                                  Optional pCLSEXT As UID, _
                                  Optional ConfigWord As String = "" _
                                  ) As IFeatureClass
  On Error GoTo ErrorHandler

  
'' createDatasetFeatureClass: simple helper to create a featureclass in a geodatabase Dataset.
'' NOTE: when creating a feature class in a dataset the spatial reference is inherited
'' from the dataset object
'' MODIFIED BY JENNESS APRIL 23 2008 FROM ESRI SAMPLE

  Dim pFields As IFields
  Dim pFieldsEdit As IFieldsEdit
  Dim pGeomDef As IGeometryDef
  Dim pGeomDefEdit As IGeometryDefEdit
  Dim pField As IField
  Dim pFieldEdit As IFieldEdit
  Dim strShapeFld As String
  Dim j As Integer
  
1708:   Set CreateDatasetFeatureClass = Nothing
  If pFDS Is Nothing Then Exit Function
  If Name = "" Then Exit Function
  
1712:   If (pCLSID Is Nothing) Or IsMissing(pCLSID) Then
1713:     Set pCLSID = Nothing
1714:     Set pCLSID = New UID
    
    '' determine the appropriate geometry type corresponding the the feature type
    Select Case featType
      Case esriFTSimple
1719:         pCLSID.Value = "esriGeoDatabase.Feature"
      Case esriFTSimpleJunction
1721:         geomType = esriGeometryPoint
1722:         pCLSID.Value = "esriGeoDatabase.SimpleJunctionFeature"
      Case esriFTComplexJunction
1724:         pCLSID.Value = "esriGeoDatabase.ComplexJunctionFeature"
      Case esriFTSimpleEdge
1726:         geomType = esriGeometryPolyline
1727:         pCLSID.Value = "esriGeoDatabase.SimpleEdgeFeature"
      Case esriFTComplexEdge
1729:         geomType = esriGeometryPolyline
1730:         pCLSID.Value = "esriGeoDatabase.ComplexEdgeFeature"
      Case esriFTAnnotation
        Exit Function
1733:     End Select
1734:   End If
  
  ' CREATE GEOMETRY AND OBJECT ID FIELD; ADD ANY REQUESTED FIELDS IF NECESSARY
  ' establish a fields collection
1738:   Set pFields = New Fields
1739:   Set pFieldsEdit = pFields
  
  '' create the geometry field
1742:   Set pGeomDef = New GeometryDef
1743:   Set pGeomDefEdit = pGeomDef
  
  '' assign the geometry definiton properties.
1746:   With pGeomDefEdit
1747:     .GeometryType = geomType
1748:     .GridCount = 1
1749:     .GridSize(0) = 10
1750:     .AvgNumPoints = 2
1751:     .HasM = False
1752:     .HasZ = False
1753:   End With
  
1755:   Set pField = New Field
1756:   Set pFieldEdit = pField
  
1758:   pFieldEdit.Name = "Shape"
1759:   pFieldEdit.AliasName = "geometry"
1760:   pFieldEdit.Type = esriFieldTypeGeometry
1761:   Set pFieldEdit.GeometryDef = pGeomDef
1762:   pFieldsEdit.AddField pField

  '' create the object id field
1765:   Set pField = New Field
1766:   Set pFieldEdit = pField
1767:   pFieldEdit.Name = "Object_ID"
1768:   pFieldEdit.AliasName = "object identifier"
1769:   pFieldEdit.Type = esriFieldTypeOID
1770:   pFieldsEdit.AddField pField
  
  ' ADD FIELDS IF REQUESTED
1773:   If Not (pAddFields Is Nothing Or IsMissing(pAddFields)) Then
    Dim lngIndex As Long
1775:     For lngIndex = 0 To pAddFields.Count - 1
1776:       pFieldsEdit.AddField pAddFields.Element(lngIndex)
1777:     Next lngIndex
1778:   End If
  
  ' establish the class extension
1781:   If (pCLSEXT Is Nothing) Or IsMissing(pCLSEXT) Then
1782:     Set pCLSEXT = Nothing
1783:   End If
  
  ' locate the shape field
1786:   For j = 0 To pFields.FieldCount - 1
1787:     If pFields.Field(j).Type = esriFieldTypeGeometry Then
1788:       strShapeFld = pFields.Field(j).Name
1789:     End If
1790:   Next
  
1792:   Set CreateDatasetFeatureClass = pFDS.CreateFeatureClass(Name, pFields, pCLSID, pCLSEXT, featType, strShapeFld, ConfigWord)
  

  Exit Function
ErrorHandler:
  HandleError True, "CreateDatasetFeatureClass " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
           


Public Function ReturnFieldsByType(pFields As IFields, enumJenFieldTypes As JenFieldTypes) As esriSystem.IVariantArray
  On Error GoTo ErrorHandler


  Dim booString As Boolean
  Dim booNumber As Boolean
  Dim booDate As Boolean
  Dim booOID As Boolean
  Dim booGeometry As Boolean
  Dim booBlob As Boolean
  Dim booRaster As Boolean
  Dim booGUID As Boolean
  Dim booGlobalID As Boolean
  Dim booXML As Boolean
  
  Dim strBinary As String
1818:   strBinary = ConvertLongBinary(enumJenFieldTypes, 10)
'  MsgBox "Number = " & enumJenFieldTypes & vbCrLf & "Binary = " & strBinary

1821:   booXML = Mid(strBinary, 1, 1) = "1"
1822:   booGlobalID = Mid(strBinary, 2, 1) = "1"
1823:   booGUID = Mid(strBinary, 3, 1) = "1"
1824:   booRaster = Mid(strBinary, 4, 1) = "1"
1825:   booBlob = Mid(strBinary, 5, 1) = "1"
1826:   booGeometry = Mid(strBinary, 6, 1) = "1"
1827:   booOID = Mid(strBinary, 7, 1) = "1"
1828:   booDate = Mid(strBinary, 8, 1) = "1"
1829:   booNumber = Mid(strBinary, 9, 1) = "1"
1830:   booString = Mid(strBinary, 10, 1) = "1"
  
'  MsgBox "booString = " & booString & vbCrLf & _
      "booNumber = " & booNumber & vbCrLf & _
      "booDate = " & booDate & vbCrLf & _
      "booOID = " & booOID & vbCrLf & _
      "booGeometry = " & booGeometry & vbCrLf & _
      "booBlob = " & booBlob & vbCrLf & _
      "booRaster = " & booRaster & vbCrLf & _
      "booGUID = " & booGUID & vbCrLf & _
      "booGlobalID = " & booGlobalID & vbCrLf & _
      "booXML = " & booXML
  
  Dim pField As IField
  Dim lngIndex As Long
  Dim pType As esriFieldType
  
1847:   Set ReturnFieldsByType = New esriSystem.VarArray
    
1849:   For lngIndex = 0 To pFields.FieldCount - 1
1850:     Set pField = pFields.Field(lngIndex)
1851:     pType = pField.Type
1852:     If booXML And (pType = esriFieldTypeXML) Then
1853:       ReturnFieldsByType.Add pField
1854:     ElseIf booGlobalID And (pType = esriFieldTypeGlobalID) Then
1855:       ReturnFieldsByType.Add pField
1856:     ElseIf booGUID And (pType = esriFieldTypeGUID) Then
1857:       ReturnFieldsByType.Add pField
1858:     ElseIf booRaster And (pType = esriFieldTypeRaster) Then
1859:       ReturnFieldsByType.Add pField
1860:     ElseIf booBlob And (pType = esriFieldTypeBlob) Then
1861:       ReturnFieldsByType.Add pField
1862:     ElseIf booGeometry And (pType = esriFieldTypeGeometry) Then
1863:       ReturnFieldsByType.Add pField
1864:     ElseIf booOID And (pType = esriFieldTypeOID) Then
1865:       ReturnFieldsByType.Add pField
1866:     ElseIf booDate And (pType = esriFieldTypeDate) Then
1867:       ReturnFieldsByType.Add pField
1868:     ElseIf booNumber And ((pType = esriFieldTypeDouble) Or (pType = esriFieldTypeInteger) _
      Or (pType = esriFieldTypeSingle) Or (pType = esriFieldTypeSmallInteger)) Then
1870:       ReturnFieldsByType.Add pField
1871:     ElseIf booString And (pType = esriFieldTypeString) Then
1872:       ReturnFieldsByType.Add pField
1873:     End If
1874:   Next lngIndex


  Exit Function
ErrorHandler:
  HandleError True, "ReturnFieldsByType " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function ReturnDBASEFieldName(strName As String, pFieldSet As Variant) As String
  On Error GoTo ErrorHandler


  Dim lngIndex As Long
  
  Dim strAcceptable As String
1889:   strAcceptable = "abcdefghijklmnopqrstuvwxyz1234567890_"
  Dim strCharacters As String
1891:   strCharacters = "abcdefghijklmnopqrstuvwxyz"
  
  Dim pField As IField
  
  Dim strNewName As String
  Dim strChar As String
  
  ' MAKE SURE SUGGESTED NAME IS VALID FOR dBASE IN GENERAL
  ' CHECK IF FIELD NAME IS EMPTY STRING
1900:   If strName = "" Then strName = "zField"
  
  ' CHECK IF FIELD NAME IS PROPER LENGTH
1903:   strName = Left(strName, 10)
  
  ' CHECK IF FIELD NAME DOES NOT START WITH A LETTER
1906:   If Not (InStr(1, strCharacters, Left(strName, 1), vbTextCompare) > 0) Then
1907:     strName = Left("z" & strName, 10)
1908:   End If
  
  ' CHECK FOR NON_CONFORMING CHARACTERS
1911:   strNewName = ""
1912:   For lngIndex = 1 To Len(strName)
1913:     strChar = Mid(strName, lngIndex, 1)
1914:     If Not (InStr(1, strAcceptable, strChar, vbTextCompare) > 0) Then
1915:       strNewName = strNewName & "_"
1916:     Else
1917:       strNewName = strNewName & strChar
1918:     End If
1919:   Next lngIndex
1920:   strName = strNewName
  
  Dim strTestName As String
    
  ' MAKE SURE FIELD NAME DOES NOT ALREADY EXIST IN LIST
  ' CONVERT OBJECT INTO LIST OF EXISTING NAMES
  Dim pFieldArray As esriSystem.IStringArray
1927:   Set pFieldArray = New esriSystem.strArray
  
1929:   If TypeOf pFieldSet Is IFields Then
    
    Dim pFields As IFields
1932:     Set pFields = pFieldSet
1933:     If pFields.FieldCount > 0 Then
1934:       For lngIndex = 0 To pFields.FieldCount - 1
1935:         strTestName = pFields.Field(lngIndex).Name
1936:         pFieldArray.Add strTestName
1937:       Next lngIndex
1938:     End If
    
1940:   ElseIf TypeOf pFieldSet Is esriSystem.IVariantArray Then
    
    Dim pVar As Variant
    Dim pVarArray As esriSystem.IVariantArray
1944:     Set pVarArray = pFieldSet
1945:     If pVarArray.Count > 0 Then
1946:       For lngIndex = 0 To pVarArray.Count - 1
1947:         If VarType(pVarArray.Element(lngIndex)) = vbDataObject Then           ' IS AN IField
1948:           Set pField = pVarArray.Element(lngIndex)
1949:           strTestName = pField.Name
1950:         Else
1951:           strTestName = pVarArray.Element(lngIndex)
1952:         End If
1953:         pFieldArray.Add strTestName
1954:       Next lngIndex
1955:     End If
  
1957:   ElseIf TypeOf pFieldSet Is esriSystem.IStringArray Then
    
1959:     Set pFieldArray = pFieldSet
  
1961:   End If
  
  ' CHECK CURRENT NAME AGAINST LIST
1964:   If pFieldArray.Count > 0 Then
    Dim lngCounter As Long
    Dim strBaseName As String
1967:     strBaseName = strName
    Dim booFoundConflict As Boolean
1969:     booFoundConflict = True
1970:     Do Until booFoundConflict = False
1971:       booFoundConflict = False
1972:       For lngIndex = 0 To pFieldArray.Count - 1
1973:         strTestName = pFieldArray.Element(lngIndex)
1974:         If StrComp(strName, strTestName, vbTextCompare) = 0 Then
1975:           booFoundConflict = True
1976:           Exit For
1977:         End If
1978:       Next lngIndex
1979:       If booFoundConflict Then
1980:         lngCounter = lngCounter + 1
1981:         strName = Left(strBaseName, 10 - Len(CStr(lngCounter))) & CStr(lngCounter)
1982:       End If
1983:     Loop
1984:   End If
  
1986:   ReturnDBASEFieldName = strName


  Exit Function
ErrorHandler:
  HandleError True, "ReturnDBASEFieldName " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function ReturnLayerByName(strName As String, pMap As IMap) As ILayer
  On Error GoTo ErrorHandler


1998:   Set ReturnLayerByName = Nothing
  Dim pLayers As IEnumLayer
2000:   Set pLayers = pMap.Layers(Nothing, True)
  Dim pLayer As ILayer
2002:   pLayers.Reset
2003:   Set pLayer = pLayers.Next
2004:   Do Until pLayer Is Nothing
2005:     If pLayer.Name = strName Then
2006:       Set ReturnLayerByName = pLayer
2007:       Exit Do
2008:     End If
2009:     Set pLayer = pLayers.Next
2010:   Loop


  Exit Function
ErrorHandler:
  HandleError True, "ReturnLayerByName " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function CheckIfCompressedFGDB(pFeatureClass As IFeatureClass) As Boolean
  ' NOTE:  WILL ONLY RETURN TRUE IF EVERYTHING WORKS; IF FUNCTION CRASHES, THEN
  ' ASSUME THIS IS NOT A FILE GEODATABASE AND THEREFORE CANNOT BE A COMPRESSED FGDB.
  ' FOR EXAMPLE, APPARENTLY PERSONAL GEODATABASES AND SHAPEFILES DON'T HAVE PROPERTY SETS???
  
  On Error GoTo EH
  
  Dim pDataset As IDataset
2026:   Set pDataset = pFeatureClass
  Dim pGeoDataset As IGeoDataset
2028:   Set pGeoDataset = pFeatureClass
  Dim strCategory As String
2030:   strCategory = pDataset.Category
  Dim booIsFGDB As Boolean
2032:   booIsFGDB = InStr(1, strCategory, "file geodatabase", vbTextCompare)
  
2034:   CheckIfCompressedFGDB = False
  
2036:   If booIsFGDB Then      ' IF FILE GEODATABASE, CHECK IF IT IS COMPRESSED
    Dim pPropSet As IPropertySet
2038:     Set pPropSet = pDataset.PropertySet
    Dim varFormat As Variant
2040:     varFormat = pPropSet.GetProperty("Datafile Format")
2041:     If varFormat = 1 Then
2042:       CheckIfCompressedFGDB = True
2043:     Else
2044:       CheckIfCompressedFGDB = False
2045:     End If
2046:   End If
  
  Exit Function
EH:
2050:   CheckIfCompressedFGDB = False
End Function

Public Function TrueLayerCount(pMap As IMap) As Long
  On Error GoTo ErrorHandler


  Dim lngLayerCount As Long
2058:   lngLayerCount = 0
  
2060:   If pMap.LayerCount > 0 Then
    Dim pEnumLayer As IEnumLayer
2062:     Set pEnumLayer = pMap.Layers
2063:     pEnumLayer.Reset
    Dim pLayer As IUnknown
2065:     Set pLayer = pEnumLayer.Next
2066:     Do Until pLayer Is Nothing
2067:       lngLayerCount = lngLayerCount + 1
2068:       Set pLayer = pEnumLayer.Next
2069:     Loop
2070:   End If
  
2072:   TrueLayerCount = lngLayerCount


  Exit Function
ErrorHandler:
  HandleError True, "TrueLayerCount " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function


Public Function ReturnDistanceUnitsName(lngEsriUnits As esriUnits) As String
  On Error GoTo ErrorHandler


  Select Case lngEsriUnits
    Case 0
2087:       ReturnDistanceUnitsName = "Unknown"
    Case 1
2089:       ReturnDistanceUnitsName = "Inches"
    Case 2
2091:       ReturnDistanceUnitsName = "Points"
    Case 3
2093:       ReturnDistanceUnitsName = "Feet"
    Case 4
2095:       ReturnDistanceUnitsName = "Yards"
    Case 5
2097:       ReturnDistanceUnitsName = "Miles"
    Case 6
2099:       ReturnDistanceUnitsName = "Nautical miles"
    Case 7
2101:       ReturnDistanceUnitsName = "Millimeters"
    Case 8
2103:       ReturnDistanceUnitsName = "Centimeters"
    Case 9
2105:       ReturnDistanceUnitsName = "Meters"
    Case 10
2107:       ReturnDistanceUnitsName = "Kilometers"
    Case 11
2109:       ReturnDistanceUnitsName = "Decimal degrees"
    Case 12
2111:       ReturnDistanceUnitsName = "Decimeters"
2112:   End Select


  Exit Function
ErrorHandler:
  HandleError True, "ReturnDistanceUnitsName " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function ConvertLongBinary(lngNumber As Long, Optional MinimumNumDigits As Long = -1) As String
  On Error GoTo ErrorHandler


  Dim strBinary As String
  Dim lngIntermediate As Long
  Dim lngRemainder As Long
2127:   lngIntermediate = lngNumber
2128:   Do Until lngIntermediate = 1
2129:     lngRemainder = lngIntermediate Mod 2
2130:     lngIntermediate = Int(lngIntermediate / 2)
2131:     strBinary = CStr(lngRemainder) & strBinary
2132:   Loop
2133:   strBinary = "1" & strBinary
  
2135:   If Len(strBinary) < MinimumNumDigits Then
2136:     Do While Len(strBinary) < MinimumNumDigits
2137:       strBinary = "0" & strBinary
2138:     Loop
2139:   End If
  
2141:   ConvertLongBinary = strBinary


  Exit Function
ErrorHandler:
  HandleError True, "ConvertLongBinary " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function


Public Function ReturnLayersByType(pFocusMap As IMap, enumLayerTypes As JenLayerTypes) As esriSystem.IVariantArray
  On Error GoTo ErrorHandler


  Dim booFeatureLayers As Boolean
  Dim booRasterLayers As Boolean
  Dim booStandaloneTables As Boolean
  Dim booPointLayers As Boolean
  Dim booPolylineLayers As Boolean
  Dim booPolygonLayers As Boolean
  Dim booMultipointLayers As Boolean
  Dim booTinLayers As Boolean
  Dim booTerrainLayers As Boolean
  Dim booRasterCatalogLayers As Boolean
  
  Dim strBinary As String
2166:   strBinary = ConvertLongBinary(enumLayerTypes, 9)
'  MsgBox "Number = " & enumLayerTypes & vbCrLf & "Binary = " & strBinary
2168:   booFeatureLayers = Mid(strBinary, 9, 1) = "1"
2169:   booRasterLayers = Mid(strBinary, 8, 1) = "1"
2170:   booStandaloneTables = Mid(strBinary, 7, 1) = "1"
2171:   booPointLayers = Mid(strBinary, 6, 1) = "1"
2172:   booPolylineLayers = Mid(strBinary, 5, 1) = "1"
2173:   booPolygonLayers = Mid(strBinary, 4, 1) = "1"
2174:   booMultipointLayers = Mid(strBinary, 3, 1) = "1"
2175:   booTinLayers = Mid(strBinary, 2, 1) = "1"
2176:   booRasterCatalogLayers = Mid(strBinary, 1, 1) = "1"
  
'  MsgBox "booFeatureLayers = " & booFeatureLayers & vbCrLf & _
'      "booRasterLayers = " & booRasterLayers & vbCrLf & _
'      "booStandaloneTables = " & booStandaloneTables & vbCrLf & _
'      "booPointLayers = " & booPointLayers & vbCrLf & _
'      "booPolylineLayers = " & booPolylineLayers & vbCrLf & _
'      "booPolygonLayers = " & booPolygonLayers & vbCrLf & _
'      "booMultipointLayers = " & booMultipointLayers & vbCrLf & _
'      "booTinLayers = " & booTinLayers

  Dim pEnumLayer As IEnumLayer
  Dim pFeatureLayer As IFeatureLayer
  Dim pLayer As IUnknown
  Dim pFeatureClass As IFeatureClass
  Dim pGeometryType As esriGeometryType
  Dim pFeatureLayerForValid As IFeatureLayer
  Dim booOpenDialog As Boolean
2194:   booOpenDialog = False
  Dim pRasterLayer As IRasterLayer
'  Dim pAsLayer As ILayer
    
2198:   Set ReturnLayersByType = New esriSystem.VarArray
    
2200:   If (pFocusMap.LayerCount > 0) Then
2201:     Set pEnumLayer = pFocusMap.Layers(, True)
2202:     pEnumLayer.Reset
    
2204:     Set pLayer = pEnumLayer.Next
2205:     Do Until pLayer Is Nothing
'      Set pAsLayer = pLayer
'      MsgBox "Layer Name = " & pAsLayer.Name & vbCrLf & _
'             "Feature Layer:  " & CStr(TypeOf pLayer Is IFeatureLayer) & vbCrLf & _
'             "Raster Layer:  " & CStr(TypeOf pLayer Is IRasterLayer) & vbCrLf & _
'             "TIN Layer:  " & CStr(TypeOf pLayer Is ITinLayer)
             
2212:       If TypeOf pLayer Is IGdbRasterCatalogLayer Then
2213:         Set pFeatureLayerForValid = pLayer
2214:         If pFeatureLayerForValid.Valid Then
2215:           If booRasterCatalogLayers Then ReturnLayersByType.Add pLayer
2216:         End If
            
2218:       ElseIf TypeOf pLayer Is IFeatureLayer Then
2219:         Set pFeatureLayerForValid = pLayer
        ' CHECK IF FEATURE LAYER IS VALID
2221:         If pFeatureLayerForValid.Valid Then
          ' CHECK IF POLYGON LAYER
2223:           Set pFeatureClass = pFeatureLayerForValid.FeatureClass          ' CHECK IF FEATURE LAYER
2224:           pGeometryType = pFeatureClass.ShapeType
2225:           If booFeatureLayers Then
2226:             ReturnLayersByType.Add pLayer
2227:           Else
2228:             If (pGeometryType = esriGeometryPolygon) Then                 ' CHECK IF POLYGON LAYER
2229:               If booPolygonLayers Then ReturnLayersByType.Add pLayer
2230:             ElseIf pGeometryType = esriGeometryPolyline Then              ' CHECK IF POLYLINE LAYER
2231:               If booPolylineLayers Then ReturnLayersByType.Add pLayer
2232:             ElseIf pGeometryType = esriGeometryPoint Then                 ' CHECK IF POINT LAYER
2233:               If booPointLayers Then ReturnLayersByType.Add pLayer
2234:             ElseIf pGeometryType = esriGeometryMultipoint Then            ' CHECK IF MULTIPOINT LAYER
2235:               If booMultipointLayers Then ReturnLayersByType.Add pLayer
2236:             End If
2237:           End If
2238:         End If
2239:       ElseIf TypeOf pLayer Is IRasterLayer Then                           ' CHECK IF RASTER LAYER
2240:         Set pRasterLayer = pLayer
2241:         If pRasterLayer.Valid Then
2242:           If booRasterLayers Then ReturnLayersByType.Add pLayer
2243:         End If
2244:       ElseIf TypeOf pLayer Is ITinLayer Then                              ' CHECK IF TIN LAYER
        Dim pTinLayer As ITinLayer
2246:         Set pTinLayer = pLayer
2247:         If pTinLayer.Valid Then
2248:           If booTinLayers Then ReturnLayersByType.Add pLayer
2249:         End If
2250:       End If
2251:       Set pLayer = pEnumLayer.Next
2252:     Loop
2253:   End If
  
2255:   If booStandaloneTables Then
    Dim pSTCollection As IStandaloneTableCollection
2257:     Set pSTCollection = pFocusMap
    Dim pStTble As IStandaloneTable
2259:     If pSTCollection.StandaloneTableCount > 0 Then
      Dim lngIndex As Long
2261:       For lngIndex = 0 To pSTCollection.StandaloneTableCount - 1
2262:         Set pStTble = pSTCollection.StandaloneTable(lngIndex)
2263:         If booStandaloneTables Then ReturnLayersByType.Add pStTble
2264:       Next lngIndex
2265:     End If
2266:   End If
  
'  Dim strReport As String
'  For lngIndex = 0 To ReturnLayersByType.Count - 1
'    Set pAsLayer = ReturnLayersByType.Element(lngIndex)
'    strReport = strReport & CStr(lngIndex) & "] " & pAsLayer.Name & vbCrLf
'  Next lngIndex
'  MsgBox strReport


  Exit Function
ErrorHandler:
  HandleError True, "ReturnLayersByType " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function


Public Function BasicStatsFromVAT(anArray() As Double, dblSizeArray() As Double, _
      theFieldName As String, theTableName As String, _
      m_App As Application, Optional lngNumberHistBins As Long = -9999) As esriSystem.IVariantArray
  On Error GoTo ErrorHandler

  
  
  ' ASSUMES ARRAYS ARE SORTED!!!! --------------------------------------
  
  Dim pResponse As esriSystem.IVariantArray
2292:   Set pResponse = New esriSystem.VarArray
  
    ' PROGRESS BAR STUFF
  Dim psbar As IStatusBar
2296:   Set psbar = m_App.StatusBar
  Dim pPro As IStepProgressor
2298:   Set pPro = psbar.ProgressBar
  
  ' IF MAKING A HISTOGRAM
  Dim booMakeHistogram As Boolean
2302:   booMakeHistogram = (lngNumberHistBins > 0)
  Dim lngHistCountArray() As Long            ' WILL CONTAIN COUNTS OF VALUES LYING IN EACH HISTOGRAM BIN
2304:   If booMakeHistogram Then
    Dim dblHistLow As Double
    Dim dblHistHigh As Double
2307:     dblHistLow = anArray(0)
2308:     dblHistHigh = anArray(UBound(anArray))
    Dim dblInterval As Double
2310:     dblInterval = (dblHistHigh - dblHistLow) / lngNumberHistBins
    
    ReDim lngHistCountArray(lngNumberHistBins)
    Dim lngHistBinIndex As Long
2314:     lngHistBinIndex = 0
    Dim dblCurrentBinThreshold As Double
2316:     dblCurrentBinThreshold = dblHistLow + dblInterval
2317:   End If
  
2319:   Screen.MousePointer = vbHourglass
  
2321:   If booMakeHistogram Then
2322:     psbar.ShowProgressBar "Calculating Statistics on field [" & theFieldName & "] in " & theTableName, 1, _
          4 * (UBound(anArray) - 1), 1, True
2324:   Else
2325:     psbar.ShowProgressBar "Calculating Statistics on field [" & theFieldName & "] in " & theTableName, 1, _
          3 * (UBound(anArray) - 1), 1, True
2327:   End If
  
  Dim FoundMode As Boolean
2330:   FoundMode = False
  
  Dim theModeValList() As Double
  ReDim theModeValList(1, UBound(anArray))
  
  Dim theHighModeCount As Long
2336:   theHighModeCount = 0
  
  Dim anIndex As Long
  Dim theVal As Double
  Dim theSize As Double
  Dim theValTimesSize As Double
  Dim theModeCounter As Long
  Dim theModeIndex As Long
2344:   theModeIndex = -1
  
2346:   anIndex = 0
2347:   psbar.StepProgressBar
  
  ' IF MAKING HISTOGRAM
2350:   If booMakeHistogram Then
2351:     Do While anIndex <= UBound(anArray)
2352:       theVal = anArray(anIndex)
2353:       theSize = dblSizeArray(anIndex)
2354:       theValTimesSize = theVal * theSize
2355:       If theVal <= dblCurrentBinThreshold Then
2356:         lngHistCountArray(lngHistBinIndex) = lngHistCountArray(lngHistBinIndex) + theSize
2357:       Else
2358:         Do While dblCurrentBinThreshold < theVal
2359:           dblCurrentBinThreshold = dblCurrentBinThreshold + dblInterval
2360:           lngHistBinIndex = lngHistBinIndex + 1
2361:         Loop
2362:         lngHistCountArray(lngHistBinIndex) = theSize
2363:       End If
2364:       anIndex = anIndex + 1
2365:       psbar.StepProgressBar
2366:     Loop
2367:   End If
  
  '  PASS 1:  MODE --------------------------------------------------
2370:   anIndex = 0
  
2372:   Do While anIndex < UBound(anArray)
    
2374:     theModeCounter = 0
2375:     theVal = anArray(anIndex)
2376:     theSize = dblSizeArray(anIndex)
    
2378:     Do While (anIndex < UBound(anArray))
      ' IF THE NEXT VALUE UP IS DIFFERENT, THEN START NEW COUNT
2380:       If Not (anArray(anIndex + 1) = theVal) Then
2381:         theModeCounter = theSize
2382:         Exit Do
2383:       End If
            
      ' IF NEXT VALUE UP IS THE SAME, THEN ADD NEW SIZE TO CURRENT TALLY.  THEN CONTINUE LOOKING FOR A NEW VALUE.
2386:       theModeCounter = theModeCounter + theSize
      
2388:       anIndex = anIndex + 1
2389:       theSize = dblSizeArray(anIndex)
      
2391:       psbar.StepProgressBar
2392:     Loop
    
2394:     If theModeCounter > 1 Then
2395:       FoundMode = True
2396:       theModeIndex = theModeIndex + 1
2397:       theModeValList(0, theModeIndex) = theModeCounter
2398:       theModeValList(1, theModeIndex) = theVal
      
'      Debug.Print "Value = " & theModeValList(1, theModeIndex) & "[" & theModeValList(0, theModeIndex) & " cases]"
      
2402:     End If
    
2404:     anIndex = anIndex + 1
2405:     psbar.StepProgressBar
2406:   Loop
  
  Dim theModeString As String
  
  ' IF ANY VALUE OCCURED > 1 TIME
  Dim theFinalModes() As Double
2412:   If FoundMode Then
    ReDim Preserve theModeValList(1, theModeIndex)
    
    Dim theFinalModeCount As Long
2416:     theFinalModeCount = 0
    Dim theTempCount As Long
2418:     theTempCount = 0
        
    Dim theFinalModeIndex As Long
        
2422:     For anIndex = 0 To theModeIndex
2423:       theTempCount = theModeValList(0, anIndex)
2424:       If theTempCount > theFinalModeCount Then
2425:         theFinalModeCount = theTempCount
        ReDim theFinalModes(0)
2427:         theFinalModes(0) = theModeValList(1, anIndex)
2428:       ElseIf theTempCount = theFinalModeCount Then
2429:         theFinalModeIndex = UBound(theFinalModes) + 1
        ReDim Preserve theFinalModes(theFinalModeIndex)
2431:         theFinalModes(theFinalModeIndex) = theModeValList(1, anIndex)
2432:       End If
2433:     Next anIndex
    
2435:     If UBound(theFinalModes) > 0 Then
2436:       theModeString = UBound(theFinalModes) + 1 & " modes found [" & Brad_Convert.aml_func_mod.InsertCommas(theFinalModeCount) & " cases each]: Values = "
2437:       For anIndex = 0 To UBound(theFinalModes)
2438:         theModeString = theModeString & theFinalModes(anIndex) & ", "
2439:       Next anIndex
      
2441:       theModeString = Brad_Convert.aml_func_mod.BasicTrimAvenue(theModeString, "", ", ")
      
2443:     Else
2444:       theModeString = "1 mode found [" & Brad_Convert.aml_func_mod.InsertCommas(theFinalModeCount) & " cases]: Value = " & theFinalModes(0)
2445:     End If
    
2447:   Else
2448:     theModeString = " < No Mode Found >"
2449:   End If
  
  Dim theSum As Double
  Dim theCount As Double
  Dim theMinimum As Double
  Dim theMaximum As Double
  
2456:   theSum = 0
2457:   theCount = 0
2458:   theMinimum = anArray(0)
2459:   theMaximum = anArray(0)
  
  '  PASS 2:  MINIMUM, MAXIMUM AND SUM --------------------------------------------------
2462:   For anIndex = LBound(anArray) To UBound(anArray)
        
2464:     psbar.StepProgressBar
    
2466:     theVal = anArray(anIndex)
2467:     theSize = dblSizeArray(anIndex)
2468:     theCount = theCount + theSize
    
2470:     theValTimesSize = theVal * theSize
    
2472:     If theVal < theMinimum Then
2473:       theMinimum = theVal
2474:     End If
2475:     If theVal > theMaximum Then
2476:       theMaximum = theVal
2477:     End If
2478:     theSum = theSum + theValTimesSize
    
2480:   Next anIndex
  
  Dim theMean As Double
2483:   theMean = theSum / theCount
  
  Dim theSumSqDev As Double
  Dim theSqDev As Double
  Dim theMedian As Double
  Dim lngMiddleIndex As Long     ' DON'T HAVE TO WORRY ABOUT DECIMAL COUNTS BECAUSE WORKING WITH VAT.  ALL COUNTS ARE INTEGER.
  Dim theRunningCount As Double
2490:   theRunningCount = 0
  Dim booFoundMedian As Boolean
2492:   booFoundMedian = False
  
2494:   If theCount = 0 Then
2495:     lngMiddleIndex = 0
2496:   ElseIf theCount Mod 2 = 0 Then      ' EVEN NUMBER
'      theMedian = (anArray((theCount / 2) - 1) + anArray(theCount / 2)) / 2
2498:     lngMiddleIndex = (((theCount / 2) - 1) + (theCount / 2)) / 2
2499:   Else
'      theMedian = anArray((theCount - 1) / 2)
2501:     lngMiddleIndex = (theCount - 1) / 2
2502:   End If
  
  '  PASS 2: MEDIAN, STANDARD DEVIATION AND VARIANCE --------------------------------------------------
2505:   For anIndex = LBound(anArray) To UBound(anArray)
        
2507:     psbar.StepProgressBar
    
2509:     theVal = anArray(anIndex)
2510:     theSize = dblSizeArray(anIndex)
2511:     theRunningCount = theRunningCount + theSize
2512:     If Not booFoundMedian Then
2513:       If theRunningCount >= lngMiddleIndex Then
2514:         theMedian = theVal
2515:         booFoundMedian = True
2516:       End If
2517:     End If
2518:     theSqDev = theSize * ((theVal - theMean) * (theVal - theMean))
2519:     theSumSqDev = theSqDev + theSumSqDev
    
2521:   Next anIndex
  
  Dim theVariance As Double
  Dim theStDev As Double
  Dim theStErrMean As Double
  
2527:   If theCount > 0 Then
    
2529:     theVariance = theSumSqDev / (theCount - 1)
2530:     theStDev = Sqr(theVariance)
2531:     theStErrMean = theStDev / (Sqr(theCount))
    
2533:   Else
2534:     theMedian = -9999
2535:     theVariance = 0
2536:     theStDev = 0
2537:     theStErrMean = 0
2538:   End If

  Dim theRange As Double
2541:   theRange = theMaximum - theMinimum

  ' OUTPUT ARRAY; VARIANT BECAUSE OF MODE STRING
  '(0) = SUM
  '(1) = MEAN
  '(2) = MINIMUM
  '(3) = MAXIMUM
  '(4) = RANGE
  '(5) = COUNT
  '(6) = STANDARD DEVIATION
  '(7) = VARIANCE
  '(8) = MEDIAN
  '(9) = STANDARD ERROR OF MEAN
  '(10) = MODE STRING
  '(11) = DOUBLE ARRAY OF MODE VALUES
  '(12) = BOOLEAN INDICATING WHETHER MODE WAS FOUND
  '(13) = ARRAY OF HISTOGRAM BIN COUNTS
  
2559:   pResponse.Add theSum
2560:   pResponse.Add theMean
2561:   pResponse.Add theMinimum
2562:   pResponse.Add theMaximum
2563:   pResponse.Add theRange
2564:   pResponse.Add theCount
2565:   pResponse.Add theStDev
2566:   pResponse.Add theVariance
2567:   pResponse.Add theMedian
2568:   pResponse.Add theStErrMean
2569:   pResponse.Add theModeString
2570:   pResponse.Add theFinalModes
2571:   pResponse.Add FoundMode
2572:   pResponse.Add lngHistCountArray  ' WILL BE EMPTY ARRAY IF NO HISTOGRAM WAS REQUESTED
  
2574:   psbar.HideProgressBar
2575:   Screen.MousePointer = vbDefault
  
2577:   Set BasicStatsFromVAT = pResponse


  Exit Function
ErrorHandler:
  HandleError True, "BasicStatsFromVAT " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function BasicStatsFromArray_Weighted(anArray() As Double, theFieldName As String, theTableName As String, _
      m_App As Application) As esriSystem.IDoubleArray
  On Error GoTo ErrorHandler

  
  
  ' REQUIRES 2-DIMENSIONAL INPUT ARRAY, WHERE 1ST VALUE = VALUE AND SECOND VALUE = SIZE
  
  Dim pResponse As esriSystem.IDoubleArray
2594:   Set pResponse = New esriSystem.DoubleArray
  
    ' PROGRESS BAR STUFF
  Dim psbar As IStatusBar
2598:   Set psbar = m_App.StatusBar
  Dim pPro As IStepProgressor
2600:   Set pPro = psbar.ProgressBar
    
2602:   Screen.MousePointer = vbHourglass
  
2604:   psbar.ShowProgressBar "Calculating Statistics on field [" & theFieldName & "] in " & theTableName, 1, _
        2 * (UBound(anArray) - 1), 1, True
  
  Dim anIndex As Long
  Dim theVal As Double
  Dim theWeight As Double
  Dim theWeightedVal As Double
  
2612:   anIndex = 0
2613:   psbar.StepProgressBar
    
  Dim theSum As Double
  Dim theCount As Double
  Dim theMinimum As Double
  Dim theMaximum As Double
  
2620:   theCount = 0
  
  '  MINIMUM, MAXIMUM AND SUM --------------------------------------------------
2623:   For anIndex = LBound(anArray) To UBound(anArray)
        
2625:     psbar.StepProgressBar
    
2627:     theVal = anArray(anIndex, 0)
2628:     theWeight = anArray(anIndex, 1)
    
2630:     theCount = theCount + theWeight
2631:     theWeightedVal = theVal * theWeight
2632:     theSum = theSum + theWeightedVal
    
2634:   Next anIndex
  
  Dim theMean As Double
2637:   theMean = theSum / theCount
  
  Dim theSumSqDev As Double
2640:   theSumSqDev = 0
  Dim theSqDev As Double
  
  '  PASS 2:  STANDARD DEVIATION AND VARIANCE --------------------------------------------------
2644:   For anIndex = LBound(anArray) To UBound(anArray)
        
2646:     psbar.StepProgressBar
    
2648:     theVal = anArray(anIndex, 0)
2649:     theWeight = anArray(anIndex, 1)
2650:     theSqDev = theWeight * ((theVal - theMean) * (theVal - theMean))
2651:     theSumSqDev = theSqDev + theSumSqDev
    
2653:   Next anIndex
  
  Dim theVariance As Double
  Dim theStDev As Double
  
2658:   theVariance = theSumSqDev / theCount
2659:   theStDev = Sqr(theVariance)
  
2661:   pResponse.Add theMean
2662:   pResponse.Add theStDev
2663:   pResponse.Add theVariance
  
2665:   psbar.HideProgressBar
    
2667:   Screen.MousePointer = vbDefault
  
2669:   Set BasicStatsFromArray_Weighted = pResponse


  Exit Function
ErrorHandler:
  HandleError True, "BasicStatsFromArray_Weighted " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function BasicStatsFromArraySimple(anArray() As Double, Optional booVariance As Boolean = False) As esriSystem.IDoubleArray
  On Error GoTo ErrorHandler
  
  ' ASSUMES ARRAY IS SORTED!!!! --------------------------------------
  
  Dim pResponse As esriSystem.IDoubleArray
2683:   Set pResponse = New esriSystem.DoubleArray
  
  Dim anIndex As Long
  Dim theVal As Double

  Dim theSum As Double
  Dim theCount As Double
  Dim theMinimum As Double
  Dim theMaximum As Double
  
2693:   theSum = 0
2694:   theCount = UBound(anArray) + 1         ' ARRAY INDEX STARTS AT 0
2695:   theMinimum = anArray(0)
2696:   theMaximum = anArray(0)
  
  '  PASS 1:  MINIMUM, MAXIMUM AND SUM --------------------------------------------------
2699:   For anIndex = LBound(anArray) To UBound(anArray)
    
2701:     theVal = anArray(anIndex)
    
2703:     If theVal < theMinimum Then
2704:       theMinimum = theVal
2705:     End If
2706:     If theVal > theMaximum Then
2707:       theMaximum = theVal
2708:     End If
2709:     theSum = theSum + theVal
    
2711:   Next anIndex
  
  Dim theMean As Double
2714:   theMean = theSum / theCount
  
  Dim theSumSqDev As Double
  Dim theSqDev As Double
  
  '  PASS 2:  STANDARD DEVIATION AND VARIANCE --------------------------------------------------
2720:   If booVariance Then
2721:     For anIndex = LBound(anArray) To UBound(anArray)
                
2723:       theVal = anArray(anIndex)
2724:       theSqDev = (theVal - theMean) * (theVal - theMean)
2725:       theSumSqDev = theSqDev + theSumSqDev
      
2727:     Next anIndex
2728:   Else
2729:     theSqDev = 0
2730:     theSumSqDev = 0
2731:   End If
  
  Dim theMedian As Double
  Dim theVariance As Double
  Dim theStDev As Double
  Dim theStErrMean As Double
  
2738:   If theCount > 1 Then
2739:     If theCount Mod 2 = 0 Then      ' EVEN NUMBER
2740:       theMedian = (anArray((theCount / 2) - 1) + anArray(theCount / 2)) / 2
2741:     Else
2742:       theMedian = anArray((theCount - 1) / 2)
2743:     End If
    
2745:     theVariance = theSumSqDev / (theCount - 1)
2746:     theStDev = Sqr(theVariance)
2747:     theStErrMean = theStDev / (Sqr(theCount))
    
2749:   Else
2750:     theMedian = -9999
2751:     theVariance = 0
2752:     theStDev = 0
2753:     theStErrMean = 0
2754:   End If

  Dim theRange As Double
2757:   theRange = theMaximum - theMinimum

  ' OUTPUT ARRAY; VARIANT BECAUSE OF MODE STRING
  '(0) = SUM
  '(1) = MEAN
  '(2) = MINIMUM
  '(3) = MAXIMUM
  '(4) = RANGE
  '(5) = COUNT
  '(6) = STANDARD DEVIATION
  '(7) = VARIANCE
  '(8) = MEDIAN
  '(9) = STANDARD ERROR OF MEAN
  
2771:   pResponse.Add theSum
2772:   pResponse.Add theMean
2773:   pResponse.Add theMinimum
2774:   pResponse.Add theMaximum
2775:   pResponse.Add theRange
2776:   pResponse.Add theCount
2777:   pResponse.Add theStDev
2778:   pResponse.Add theVariance
2779:   pResponse.Add theMedian
2780:   pResponse.Add theStErrMean
  
2782:   Set BasicStatsFromArraySimple = pResponse

  Exit Function
ErrorHandler:
  HandleError True, "BasicStatsFromArraySimple " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function BasicStatsFromArray(anArray() As Double, theFieldName As String, theTableName As String, _
      m_App As Application, Optional lngNumberHistBins As Long = -9999) As esriSystem.IVariantArray
  On Error GoTo ErrorHandler

  
  
  ' ASSUMES ARRAY IS SORTED!!!! --------------------------------------
  
  Dim pResponse As esriSystem.IVariantArray
2798:   Set pResponse = New esriSystem.VarArray
  
    ' PROGRESS BAR STUFF
  Dim psbar As IStatusBar
2802:   Set psbar = m_App.StatusBar
  Dim pPro As IStepProgressor
2804:   Set pPro = psbar.ProgressBar
  
  ' IF MAKING A HISTOGRAM
  Dim booMakeHistogram As Boolean
2808:   booMakeHistogram = (lngNumberHistBins > 0)
  Dim lngHistCountArray() As Long            ' WILL CONTAIN COUNTS OF VALUES LYING IN EACH HISTOGRAM BIN
2810:   If booMakeHistogram Then
    Dim dblHistLow As Double
    Dim dblHistHigh As Double
2813:     dblHistLow = anArray(0)
2814:     dblHistHigh = anArray(UBound(anArray))
    Dim dblInterval As Double
2816:     dblInterval = (dblHistHigh - dblHistLow) / lngNumberHistBins
    
    ReDim lngHistCountArray(lngNumberHistBins)
    Dim lngHistBinIndex As Long
2820:     lngHistBinIndex = 0
    Dim dblCurrentBinThreshold As Double
2822:     dblCurrentBinThreshold = dblHistLow + dblInterval
2823:   End If
  
2825:   Screen.MousePointer = vbHourglass
  
2827:   If booMakeHistogram Then
2828:     psbar.ShowProgressBar "Calculating Statistics on field [" & theFieldName & "] in " & theTableName, 1, _
          4 * (UBound(anArray) - 1), 1, True
2830:   Else
2831:     psbar.ShowProgressBar "Calculating Statistics on field [" & theFieldName & "] in " & theTableName, 1, _
          3 * (UBound(anArray) - 1), 1, True
2833:   End If
  
  Dim FoundMode As Boolean
2836:   FoundMode = False
  
  Dim theModeValList() As Double
  ReDim theModeValList(1, UBound(anArray))
  
  Dim theHighModeCount As Long
2842:   theHighModeCount = 0
  
  Dim anIndex As Long
  Dim theVal As Double
  Dim theModeCounter As Long
  Dim theModeIndex As Long
2848:   theModeIndex = -1
  
2850:   anIndex = 0
2851:   psbar.StepProgressBar
  
  ' IF MAKING HISTOGRAM
2854:   If booMakeHistogram Then
2855:     Do While anIndex <= UBound(anArray)
2856:       theVal = anArray(anIndex)
2857:       If theVal <= dblCurrentBinThreshold Then
2858:         lngHistCountArray(lngHistBinIndex) = lngHistCountArray(lngHistBinIndex) + 1
2859:       Else
2860:         Do While dblCurrentBinThreshold < theVal
2861:           dblCurrentBinThreshold = dblCurrentBinThreshold + dblInterval
2862:           lngHistBinIndex = lngHistBinIndex + 1
2863:         Loop
2864:         lngHistCountArray(lngHistBinIndex) = 1
2865:       End If
2866:       anIndex = anIndex + 1
2867:       psbar.StepProgressBar
2868:     Loop
2869:   End If
  
  '  PASS 1:  MODE --------------------------------------------------
2872:   anIndex = 0
  
2874:   Do While anIndex < UBound(anArray)
    
2876:     theModeCounter = 1
2877:     theVal = anArray(anIndex)
    
2879:     Do While (anIndex < UBound(anArray))
2880:       If Not (anArray(anIndex + 1) = theVal) Then
2881:         Exit Do
2882:       End If
2883:       anIndex = anIndex + 1
2884:       psbar.StepProgressBar
2885:       theModeCounter = theModeCounter + 1
2886:     Loop
    
2888:     If theModeCounter > 1 Then
2889:       FoundMode = True
2890:       theModeIndex = theModeIndex + 1
2891:       theModeValList(0, theModeIndex) = theModeCounter
2892:       theModeValList(1, theModeIndex) = theVal
      
'      Debug.Print "Value = " & theModeValList(1, theModeIndex) & "[" & theModeValList(0, theModeIndex) & " cases]"
      
2896:     End If
    
2898:     anIndex = anIndex + 1
2899:     psbar.StepProgressBar
2900:   Loop
  
  Dim theModeString As String
  
  ' IF ANY VALUE OCCURED > 1 TIME
  Dim theFinalModes() As Double
2906:   If FoundMode Then
    ReDim Preserve theModeValList(1, theModeIndex)
    
    Dim theFinalModeCount As Long
2910:     theFinalModeCount = 0
    Dim theTempCount As Long
2912:     theTempCount = 0
        
    Dim theFinalModeIndex As Long
        
2916:     For anIndex = 0 To theModeIndex
2917:       theTempCount = theModeValList(0, anIndex)
2918:       If theTempCount > theFinalModeCount Then
2919:         theFinalModeCount = theTempCount
        ReDim theFinalModes(0)
2921:         theFinalModes(0) = theModeValList(1, anIndex)
2922:       ElseIf theTempCount = theFinalModeCount Then
2923:         theFinalModeIndex = UBound(theFinalModes) + 1
        ReDim Preserve theFinalModes(theFinalModeIndex)
2925:         theFinalModes(theFinalModeIndex) = theModeValList(1, anIndex)
2926:       End If
2927:     Next anIndex
    
2929:     If UBound(theFinalModes) > 0 Then
2930:       theModeString = UBound(theFinalModes) + 1 & " modes found [" & Brad_Convert.aml_func_mod.InsertCommas(theFinalModeCount) & " cases each]: Values = "
2931:       For anIndex = 0 To UBound(theFinalModes)
2932:         theModeString = theModeString & theFinalModes(anIndex) & ", "
2933:       Next anIndex
      
2935:       theModeString = Brad_Convert.aml_func_mod.BasicTrimAvenue(theModeString, "", ", ")
      
2937:     Else
2938:       theModeString = "1 mode found [" & Brad_Convert.aml_func_mod.InsertCommas(theFinalModeCount) & " cases]: Value = " & theFinalModes(0)
2939:     End If
    
2941:   Else
2942:     theModeString = " < No Mode Found >"
2943:   End If
  
  Dim theSum As Double
  Dim theCount As Double
  Dim theMinimum As Double
  Dim theMaximum As Double
  
2950:   theSum = 0
2951:   theCount = UBound(anArray) + 1         ' ARRAY INDEX STARTS AT 0
2952:   theMinimum = anArray(0)
2953:   theMaximum = anArray(0)
  
  '  PASS 2:  MINIMUM, MAXIMUM AND SUM --------------------------------------------------
2956:   For anIndex = LBound(anArray) To UBound(anArray)
        
2958:     psbar.StepProgressBar
    
2960:     theVal = anArray(anIndex)
    
2962:     If theVal < theMinimum Then
2963:       theMinimum = theVal
2964:     End If
2965:     If theVal > theMaximum Then
2966:       theMaximum = theVal
2967:     End If
2968:     theSum = theSum + theVal
    
2970:   Next anIndex
  
  Dim theMean As Double
2973:   theMean = theSum / theCount
  
  Dim theSumSqDev As Double
  Dim theSqDev As Double
  
  '  PASS 2:  STANDARD DEVIATION AND VARIANCE --------------------------------------------------
2979:   For anIndex = LBound(anArray) To UBound(anArray)
        
2981:     psbar.StepProgressBar
    
2983:     theVal = anArray(anIndex)
2984:     theSqDev = (theVal - theMean) * (theVal - theMean)
2985:     theSumSqDev = theSqDev + theSumSqDev
    
2987:   Next anIndex
  
  Dim theMedian As Double
  Dim theVariance As Double
  Dim theStDev As Double
  Dim theStErrMean As Double
  
2994:   If theCount > 1 Then
2995:     If theCount Mod 2 = 0 Then      ' EVEN NUMBER
2996:       theMedian = (anArray((theCount / 2) - 1) + anArray(theCount / 2)) / 2
2997:     Else
2998:       theMedian = anArray((theCount - 1) / 2)
2999:     End If
    
3001:     theVariance = theSumSqDev / (theCount - 1)
3002:     theStDev = Sqr(theVariance)
3003:     theStErrMean = theStDev / (Sqr(theCount))
    
3005:   Else
3006:     theMedian = -9999
3007:     theVariance = 0
3008:     theStDev = 0
3009:     theStErrMean = 0
3010:   End If

  Dim theRange As Double
3013:   theRange = theMaximum - theMinimum

  ' OUTPUT ARRAY; VARIANT BECAUSE OF MODE STRING
  '(0) = SUM
  '(1) = MEAN
  '(2) = MINIMUM
  '(3) = MAXIMUM
  '(4) = RANGE
  '(5) = COUNT
  '(6) = STANDARD DEVIATION
  '(7) = VARIANCE
  '(8) = MEDIAN
  '(9) = STANDARD ERROR OF MEAN
  '(10) = MODE STRING
  '(11) = DOUBLE ARRAY OF MODE VALUES
  '(12) = BOOLEAN INDICATING WHETHER MODE WAS FOUND
  '(13) = ARRAY OF HISTOGRAM BIN COUNTS
  
3031:   pResponse.Add theSum
3032:   pResponse.Add theMean
3033:   pResponse.Add theMinimum
3034:   pResponse.Add theMaximum
3035:   pResponse.Add theRange
3036:   pResponse.Add theCount
3037:   pResponse.Add theStDev
3038:   pResponse.Add theVariance
3039:   pResponse.Add theMedian
3040:   pResponse.Add theStErrMean
3041:   pResponse.Add theModeString
3042:   pResponse.Add theFinalModes
3043:   pResponse.Add FoundMode
3044:   pResponse.Add lngHistCountArray  ' WILL BE EMPTY ARRAY IF NO HISTOGRAM WAS REQUESTED
  
3046:   psbar.HideProgressBar
3047:   Screen.MousePointer = vbDefault
  
3049:   Set BasicStatsFromArray = pResponse


  Exit Function
ErrorHandler:
  HandleError True, "BasicStatsFromArray " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function


Public Function CalcStatistics(dblSortedNumbers() As Double, pStatOptions As esriSystem.IVariantArray, _
      Optional booReportProgress As Boolean, Optional pApp As IApplication) As esriSystem.IVariantArray
  On Error GoTo ErrorHandler


  ' FAO_WRD.Stat_CalcFieldStats
'
'Dim chkMean As Boolean
'Set chkMean = pStatOptions.Element(0)
'Dim chkSEMean As Boolean
'Set chkSEMean = pStatOptions.Element(1)
'Dim chkCIMean As Boolean
'Set chkCIMean = pStatOptions.Element(2)
'Dim ConLevel As Double
'Set ConLevel = pStatOptions.Element(3)
'Dim chkMinimum As Boolean
'Set chkMinimum = pStatOptions.Element(4)
'Dim chkQ1 As Boolean
'Set chkQ1 = pStatOptions.Element(5)
'Dim chkMedian As Boolean
'Set chkMedian = pStatOptions.Element(6)
'Dim chkQ3 As Boolean
'Set chkQ3 = pStatOptions.Element.Item(7)
'Dim chkMaximum As Boolean
'Set chkMaximum = pStatOptions.Element(8)
'Dim chkVariance As Boolean
'Set chkVariance = pStatOptions.Element(9)
'Dim chkStDev As Boolean
'Set chkStDev = pStatOptions.Element(10)
'Dim chkAvgDev As Boolean
'Set chkAvgDev = pStatOptions.Element(11)
'Dim chkSkewness As Boolean
'Set chkSkewness = pStatOptions.Element(12)
'Dim chkSkewnessFish As Boolean
'Set chkSkewnessFish = pStatOptions.Element(13)
'Dim chkKurtosis As Boolean
'Set chkKurtosis = pStatOptions.Element(14)
'Dim chkKurtosisFish As Boolean
'Set chkKurtosisFish = pStatOptions.Element(15)
'Dim chkCount As Boolean
'Set chkCount = pStatOptions.Element(16)
'Dim chkNumberNull As Boolean
'Set chkNumberNull = pStatOptions.Element(17)
'Dim chkSum As Boolean
'Set chkSum = pStatOptions.Element(18)
'Dim chkRange As Boolean
'Set chkRange = pStatOptions.Element(19)
'Dim chkMode As Boolean
'Set chkMode = pStatOptions.Element(20)
'
'' MakeHistogram = theResults.Get(21)
'
'Dim pResponse As esriSystem.IVariantArray
'Dim anIndex As Long
'For anIndex = 0 To 20
'  pResponse.Add Nothing
'Next anIndex
'
''' UNFORTUNATELY, THE HISTOGRAM FUNCTION WAS WRITTEN SEPARATELY AND THE STATS ARE IN A DIFFERENT ORDER
''theResponse = {nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil}
''theStatsForHistogramScript = {nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil}
''
''If (MakeHistogram) Then
''  chkMean = True
''  chkStDev = True
''  chkCount = True
''  chkMinimum = True
''  chkMaximum = True
''  theResults.Set(0,True)
''  theResults.Set(4,True)
''  theResults.Set(8,True)
''  theResults.Set(10,True)
''  theResults.Set(16,True)
''End
'
''' HELP IT RUN FASTER IF ONLY A FEW OPTIONS ARE CHECKED
'Dim DoQuantiles As Boolean
'Dim DoSkewKurt As Boolean
'Dim MoreThanBasic As Boolean
'Dim lngMultiplier As Long
'lngMultiplier = 1   ' FOR BASIC STATS
'
'' DIMENSION STATISTIC VARIABLES
'Dim theMean As Double
'Dim theSEMean As Double
'Dim LowerCI As Double
'Dim UpperCI As Double
'Dim theMinimum As Double
'Dim theQ1 As Double
'Dim theMedian As Double
'Dim theQ3 As Double
'Dim theMaximum As Double
'Dim theVar As Double
'Dim theStdDev As Double
'Dim theAvgDev As Double
'Dim theSkew As Double
'Dim theFisherSkew As Double
'Dim theKurt As Double
'Dim theFisherKurt As Double
'Dim theCount As Double
'Dim theNumberNull As Double
'Dim theSum As Double
'Dim theRange As Double
'Dim theModeString As String
'
'' BASIC STATS ARE Count, Minimum, Maximum, Mean, Sum
'DoQuantiles = (chkQ1 Or chkMedian Or chkQ3)
'DoSkewKurt = (chkSkewness Or chkSkewnessFish Or chkKurtosis Or chkKurtosisFish)
''MoreThanBasic = (DoQuantiles Or DoSkewKurt Or chkSEMean Or chkCIMean Or chkVariance Or chkStDev Or chkAvgDev Or MakeHistogram)
'MoreThanBasic = (DoQuantiles Or DoSkewKurt Or chkSEMean Or chkCIMean Or chkVariance Or chkStDev Or chkAvgDev)
'
'If chkVariance Or chkStDev Or chkAvgDev Then lngMultiplier = lngMultiplier + 1
'
'If DoQuantiles Then lngMultiplier = lngMultiplier + 1
'If DoSkewKurt Then lngMultiplier = lngMultiplier + 1
'If MoreThanBasic Then lngMultiplier = lngMultiplier + 1
'If chkMode Then lngMultiplier = lngMultiplier + 1
'
'If booReportProgress Then
'    ' PROGRESS BAR STUFF
'  Dim psbar As IStatusBar
'  Set psbar = pApp.StatusBar
'  Dim pPro As IStepProgressor
'  Set pPro = psbar.ProgressBar
'
'  Screen.MousePointer = vbHourglass
'
'  psbar.ShowProgressBar "Calculating Statistics on field [" & theFieldName & "] in " & theTableName, 1, _
'        lngMultiplier * (UBound(dblSortedNumbers) - 1), 1, True
'End If
'
'Dim theCount As Long
'theCount = UBound(dblSortedNumbers) - 1
'
'If chkMode Then  ' ASSUMES NUMBER ARRAY IS SORTED!
'
'  Dim pFoundMode As Boolean
'  Dim theModeValList() As Double
'  ReDim theModeValList(1, UBound(dblSortedNumbers))
'
'  Dim theHighModeCount As Long
'  theHighModeCount = 0
'
'  Dim theVal As Double
'  Dim theModeCounter As Long
'  Dim theModeIndex As Long
'  theModeIndex = -1
'
'  anIndex = 0
'
'  Do While anIndex < UBound(dblSortedNumbers)
'
'    theModeCounter = 1
'    theVal = dblSortedNumbers(anIndex)
'
'    Do While (anIndex < UBound(dblSortedNumbers))
'      If Not (dblSortedNumbers(anIndex + 1) = theVal) Then
'        Exit Do
'      End If
'      anIndex = anIndex + 1
'      If booReportProgress Then psbar.StepProgressBar
'      theModeCounter = theModeCounter + 1
'    Loop
'
'    If theModeCounter > 1 Then
'      FoundMode = True
'      theModeIndex = theModeIndex + 1
'      theModeValList(0, theModeIndex) = theModeCounter
'      theModeValList(1, theModeIndex) = theVal
'
''      Debug.Print "Value = " & theModeValList(1, theModeIndex) & "[" & theModeValList(0, theModeIndex) & " cases]"
'
'    End If
'
'    anIndex = anIndex + 1
'    If booReportProgress Then psbar.StepProgressBar
'  Loop
'
'  Dim theModeString As String
'
'  ' IF ANY VALUE OCCURED > 1 TIME
'  If FoundMode Then
'    ReDim Preserve theModeValList(1, theModeIndex)
'    Dim theFinalModes() As Double
'    Dim theFinalModeCount As Long
'    theFinalModeCount = 0
'    Dim theTempCount As Long
'    theTempCount = 0
'
'    Dim theFinalModeIndex As Long
'
'    For anIndex = 0 To theModeIndex
'      theTempCount = theModeValList(0, anIndex)
'      If theTempCount > theFinalModeCount Then
'        theFinalModeCount = theTempCount
'        ReDim theFinalModes(0)
'        theFinalModes(0) = theModeValList(1, anIndex)
'      ElseIf theTempCount = theFinalModeCount Then
'        theFinalModeIndex = UBound(theFinalModes) + 1
'        ReDim Preserve theFinalModes(theFinalModeIndex)
'        theFinalModes(theFinalModeIndex) = theModeValList(1, anIndex)
'      End If
'    Next anIndex
'
'    If UBound(theFinalModes) > 0 Then
'      theModeString = UBound(theFinalModes) + 1 & " modes found [" & Brad_Convert.aml_func_mod.InsertCommas(theFinalModeCount) & " cases each]: Values = "
'      For anIndex = 0 To UBound(theFinalModes)
'        theModeString = theModeString & theFinalModes(anIndex) & ", "
'      Next anIndex
'
'      theModeString = Brad_Convert.aml_func_mod.BasicTrimAvenue(theModeString, "", ", ")
'
'    Else
'      theModeString = "1 mode found [" & Brad_Convert.aml_func_mod.InsertCommas(theFinalModeCount) & " cases]: Value = " & theFinalModes(0)
'    End If
'
'  Else
'    theModeString = " < No Mode Found >"
'  End If
'End If
'
'theSum = 0
'theCount = UBound(dblSortedNumbers) + 1         ' ARRAY INDEX STARTS AT 0
'theMinimum = dblSortedNumbers(0)
'theMaximum = dblSortedNumbers(0)
'
''  PASS 2:  MINIMUM, MAXIMUM AND SUM --------------------------------------------------
'For anIndex = LBound(dblSortedNumbers) To UBound(dblSortedNumbers)
'
'  If booReportProgress Then psbar.StepProgressBar
'
'  theVal = dblSortedNumbers(anIndex)
'
'  If theVal < theMinimum Then
'    theMinimum = theVal
'  End If
'  If theVal > theMaximum Then
'    theMaximum = theVal
'  End If
'  theSum = theSum + theVal
'
'Next anIndex
'
'Dim theMean As Double
'theMean = theSum / theCount
'
'Dim theSumSqDev As Double
'Dim theSqDev As Double
'
''  PASS 2:  STANDARD DEVIATION AND VARIANCE --------------------------------------------------
'For anIndex = LBound(dblSortedNumbers) To UBound(dblSortedNumbers)
'
'  If booReportProgress Then psbar.StepProgressBar
'
'  theVal = dblSortedNumbers(anIndex)
'  theSqDev = (theVal - theMean) * (theVal - theMean)
'  theSumSqDev = theSqDev + theSumSqDev
'
'Next anIndex
'
'Dim theMedian As Double
'Dim theVariance As Double
'Dim theStDev As Double
'Dim theStErrMean As Double
'
'If theCount > 1 Then
'  If theCount Mod 2 = 0 Then      ' EVEN NUMBER
'    theMedian = (dblSortedNumbers((theCount / 2) - 1) + dblSortedNumbers(theCount / 2)) / 2
'  Else
'    theMedian = dblSortedNumbers((theCount - 1) / 2)
'  End If
'
'  theVariance = theSumSqDev / (theCount - 1)
'  theStDev = Sqr(theVariance)
'  theStErrMean = theStDev / (Sqr(theCount))
'
'Else
'  theMedian = -9999
'  theVariance = 0
'  theStDev = 0
'  theStErrMean = 0
'End If
'
'Dim theRange As Double
'theRange = theMaximum - theMinimum
'
'' OUTPUT ARRAY; VARIANT BECAUSE OF MODE STRING
''(0) = SUM
''(1) = MEAN
''(2) = MINIMUM
''(3) = MAXIMUM
''(4) = RANGE
''(5) = COUNT
''(6) = STANDARD DEVIATION
''(7) = VARIANCE
''(8) = MEDIAN
''(9) = STANDARD ERROR OF MEAN
''(10) = MODE STRING
'
'theStatsArray(0) = theSum
'theStatsArray(1) = theMean
'theStatsArray(2) = theMinimum
'theStatsArray(3) = theMaximum
'theStatsArray(4) = theRange
'theStatsArray(5) = theCount
'theStatsArray(6) = theStDev
'theStatsArray(7) = theVariance
'theStatsArray(8) = theMedian
'theStatsArray(9) = theStErrMean
'theStatsArray(10) = theModeString
'
''If (chkMode) Then
''  FoundMode = False
''  theModeValList = {}
''  theHighModeCount = 0
''  theDictionaryOfValues = Dictionary.Make(theCount)
''End
''
''theList = {}
''theNumberNull = 0
''theSum = 0
''theCounter = 0
''av.ClearStatus
''
''av.ShowMsg ("Calculating Pass 1")
''For Each aRecord In theSelection
''  theCounter = theCounter + 1
''  av.SetStatus ((theCounter / theCount) * 100)
''  theX = theVTab.ReturnValue(theField, aRecord)
''  If (theX.IsNull) Then
''    theNumberNull = theNumberNull + 1
''  Else
''    theList.Add (theX)
''    theSum = theSum + theX
''
''    ' CALCULATE MODE
''    If (chkMode) Then
''      theModeCount = theDictionaryOfValues.Get(theX)
''      If (theModeCount = nil) Then
''        theModeCount = 1
''      Else
''        theModeCount = theModeCount + 1
''        FoundMode = True
''      End
''      theDictionaryOfValues.Set(theX, theModeCount)
''
''      If (theModeCount > theHighModeCount) Then
''        theModeValList = {theX}
''        theHighModeCount = theModeCount
''      ElseIf (theModeCount = theHighModeCount) Then
''        theModeValList.Add (theX)
''      End
''    End
''  End
''End
''av.ClearStatus
''
''If (theList.Count = 0) Then
''  msgBox.Info("No data available to calculate!  Bailing out...", "")
''  return nil
''End
''
''If (chkMode) Then
''  If (FoundMode) Then
''    theModeValList.RemoveDuplicates
''    theModeValList.Sort (True)
''    theModeString = ""
''    For Each aModeVal In theModeValList
''      theModeString = theModeString + aModeVal.AsString + ", "
''    End
''    theModeString = theModeString.Left(theModeString.Count - 2)
''  Else
''    theModeString = " < No Mode Found >"
''  End
''End
''
''theTotalCount = theCount - theNumberNull
''
''theMean = theSum / theTotalCount
''
''If (MoreThanBasic) Then
''  av.ShowMsg ("Second Pass")
''  theCounter = 0
''
''  theAvgDev = 0
''  theMoment2 = 0
''  theMoment3 = 0
''  theMoment4 = 0
''  For Each anX In theList
''    theCounter = theCounter + 1
''    av.SetStatus ((theCounter / theTotalCount) * 100)
''    theDev = anX - theMean
''    theAvgDev = theAvgDev + (theDev.Abs)
''    theMoment2 = theMoment2 + (theDev ^ 2)
''    If (DoSkewKurt) Then
''      theMoment3 = theMoment3 + (theDev ^ 3)
''      theMoment4 = theMoment4 + (theDev ^ 4)
''    End
''  End
''  av.ClearStatus
''
''  ' MEAN, STANDARD DEVIATION, SKEWNESS, KURTOSIS --------------------------------
''  theVar = theMoment2 / (theTotalCount - 1)
''  theStdDev = theVar.Sqrt
''  theAvgDev = theAvgDev / theTotalCount
''
''  theMoment2 = theMoment2 / theTotalCount
''
''  If (DoSkewKurt) Then
''    theMoment3 = theMoment3 / theTotalCount
''    theMoment4 = theMoment4 / theTotalCount
''
''    theSkew = theMoment3 / (theMoment2 ^ (3 / 2))
''    theFisherSkew  = (theSkew*((theTotalCount*(theTotalCount-1)).sqrt))/(theTotalCount-2)
''
''    theKurt = theMoment4 / (theMoment2 ^ 2)
''    theFisherKurt = ((theTotalCount + 1) * (theTotalCount - 1)) / ((theTotalCount - 2) * (theTotalCount - 3))
''    theFisherKurt = theFisherKurt * (theKurt - (3 * (theTotalCount - 1) / (theTotalCount + 1)))
''
''    If (theVar <> 0) Then
''      theSkew = theMoment3 / (theMoment2 ^ (3 / 2))
''      theFisherSkew  = (theSkew*((theTotalCount*(theTotalCount-1)).sqrt))/(theTotalCount-2)
''
''      theKurt = theMoment4 / (theMoment2 ^ 2)
''      theFisherKurt = ((theTotalCount + 1) * (theTotalCount - 1)) / ((theTotalCount - 2) * (theTotalCount - 3))
''      theFisherKurt = theFisherKurt * (theKurt - (3 * (theTotalCount - 1) / (theTotalCount + 1)))
''    Else
''      theSkew = Number.MakeNull
''      theKurt = Number.MakeNull
''    End
''  End
''
''  ' STANDARD ERROR OF MEAN, CONFIDENCE INTERVALS
''  theSEMean = theStdDev / (theTotalCount.Sqrt)
''  If (chkCIMean) Then
''    theAlphaOver2 = 1 - ((1 - ConLevel) / 2)
''    theT = av.Run("FAO_WRD.Stat_IDF_StudentsT", {theAlphaOver2, (theTotalCount-1)})
''    theFactor = theSEMean * theT
''    LowerCI = theMean - theFactor
''    UpperCI = theMean + theFactor
''  End
''
''  ' QUANTILE DATA -----------------------------------------------------------------
''  If (DoQuantiles) Then
''
''    av.ShowMsg ("Calculating Quantile Data...")
''
''    theList.Sort (True)
''    theMinimum = theList.Get(0)
''    theMaximum = theList.Get(theList.Count - 1)
''    theRange = theMaximum - theMinimum
''
''    theListCount = theList.Count
''    theQ1Index = (theListCount + 1) * 0.25
''    theQ2Index = (theListCount + 1) * 0.5
''    theQ3Index = (theListCount + 1) * 0.75
''
''    If (theQ1Index.Round = theQ1Index) Then
''      theQ1 = theList.Get(theQ1Index - 1)
''    Else
''      theFloor = theList.Get((theQ1Index-1).Floor.Max(0))    ' POSSIBLE THAT IT COULD TRY TO GET INDEX -1, SO MAX IT WITH 0
''      theCeiling = theList.Get((theQ1Index-1).Ceiling)
''      theQ1 = (theFloor + theCeiling) / 2
''    End
''
''    If (theQ2Index.Round = theQ2Index) Then
''      theMedian = theList.Get(theQ2Index - 1)
''    Else
''      theFloor = theList.Get((theQ2Index-1).Floor)
''      theCeiling = theList.Get((theQ2Index-1).Ceiling)
''      theMedian = (theFloor + theCeiling) / 2
''    End
''
''    If (theQ3Index.Round = theQ3Index) Then
''      theQ3 = theList.Get(theQ3Index - 1)
''    Else
''      theFloor = theList.Get((theQ3Index-1).Floor)
''      theCeiling = theList.Get((theQ3Index-1).Ceiling.Min(theListCount-1))  ' POSSIBLE THAT IT COULD TRY TO GET INDEX (COUNT+1), SO MIN IT WITH COUNT
''
''      theQ3 = (theFloor + theCeiling) / 2
''    End
''  End
''End   ' END MORE THAN BASIC
''
'
'
'
'If booReportProgress Then
'  psbar.HideProgressBar
'  Screen.MousePointer = vbDefault
'End If
'
'If chkMean Then pResponse.Element(0) = theMean
'If chkSEMean Then pResponse.Element(1) = theSEMean
'If chkCIMean Then pResponse.Element(2) = LowerCI
'If chkCIMean Then pResponse.Element(3) = UpperCI
'If chkMinimum Then pResponse.Element(4) = theMinimum
'If chkQ1 Then pResponse.Element(5) = theQ1
'If chkMedian Then pResponse.Element(6) = theMedian
'If chkQ3 Then pResponse.Element(7) = theQ3
'If chkMaximum Then pResponse.Element(8) = theMaximum
'If chkVariance Then pResponse.Element(9) = theVar
'If chkStDev Then pResponse.Element(10) = theStdDev
'If chkAvgDev Then pResponse.Element(11) = theAvgDev
'If chkSkewness Then pResponse.Element(12) = theSkew
'If chkSkewnessFish Then pResponse.Element(13) = theFisherSkew
'If chkKurtosis Then pResponse.Element(14) = theKurt
'If chkKurtosisFish Then pResponse.Element(15) = theFisherKurt
'If chkCount Then pResponse.Element(16) = theCount
'If chkNumberNull Then pResponse.Element(17) = theNumberNull
'If chkSum Then pResponse.Element(18) = theSum
'If chkRange Then pResponse.Element(19) = theRange
'If chkMode Then pResponse.Element(20) = theModeString
'
'
'


  Exit Function
ErrorHandler:
  HandleError True, "CalcStatistics " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function Graphic_ReturnElementFromGeometry(ByRef pMxDoc As IMxDocument, ByRef pGeometry As IGeometry, _
    Optional strName As String, Optional AddToView As Boolean) As IElement
  On Error GoTo ErrorHandler

  
  Dim pMxDocument As esriArcMapUI.IMxDocument
  Dim pActiveView As esriCarto.IActiveView
  
  Dim pGContainer As IGraphicsContainer
3590:   Set pGContainer = pMxDoc.FocusMap
  
  Dim pElement As IElement
  Dim pPolygonElement As IPolygonElement
  Dim pSpatialReference As ISpatialReference
  Dim pGraphicElement As IGraphicElement
  Dim pElementProperties As IElementProperties
  
  Dim pClone As IClone
3599:   Set pClone = pGeometry
  Dim pNewGeometry As IGeometry
3601:   Set pNewGeometry = pClone.Clone
  
  Dim pGeometryType As esriGeometryType
3604:   pGeometryType = pNewGeometry.GeometryType
  
  'ADD GEOMETRY, NAME AND SPATIAL REFERENCE TO GRAPHIC ELEMENT
  Select Case pGeometryType
    Case 0:
3609:       MsgBox "Null Geometry!  No graphic added..."
    Case 1, 2:
3611:       Set pElement = New MarkerElement
    Case 3, 6, 13, 14, 15, 16:
3613:       Set pElement = New LineElement
    Case 4, 11:
3615:       Set pElement = New PolygonElement
    Case 5:
3617:       Set pElement = New RectangleElement
    Case Else:
3619:       MsgBox "Unexpected Shape Type:  Unable to add graphic..."
      Exit Function
3621:   End Select
  
  
3624:   If pGeometryType = 2 Then
    Dim pGroupElement As IGroupElement2
3626:     Set pGroupElement = New GroupElement
    Dim pSubElement As IElement
3628:     Set pSubElement = New MarkerElement
    Dim lngIndex As Long
    Dim pPtColl As IPointCollection
3631:     Set pPtColl = pNewGeometry
    Dim pPt As IPoint
3633:     For lngIndex = 0 To pPtColl.PointCount - 1
3634:       Set pPt = pPtColl.Point(lngIndex)
3635:       Set pSubElement = New MarkerElement
3636:       pSubElement.Geometry = pPt
3637:       pGroupElement.AddElement pSubElement
3638:     Next lngIndex
3639:     Set pGraphicElement = pGroupElement
3640:     Set pSpatialReference = pGeometry.SpatialReference
3641:     Set pGraphicElement.SpatialReference = pSpatialReference
3642:     Set pElementProperties = pGroupElement
3643:     pElementProperties.Name = strName
3644:     If AddToView Then
      ' ADD GRAPHIC TO GRAPHICS CONTAINER
3646:       pGContainer.AddElement pGroupElement, 0
      'Draw
3648:       pMxDoc.ActiveView.PartialRefresh esriViewGraphics, Nothing, Nothing
3649:     End If

3651:   Else
3652:     pElement.Geometry = pNewGeometry
3653:     Set pGraphicElement = pElement
3654:     Set pSpatialReference = pGeometry.SpatialReference
3655:     Set pGraphicElement.SpatialReference = pSpatialReference
3656:     Set pElementProperties = pElement
3657:     pElementProperties.Name = strName
  
3659:     If AddToView Then
      ' ADD GRAPHIC TO GRAPHICS CONTAINER
3661:       pGContainer.AddElement pElement, 0
      'Draw
3663:       pMxDoc.ActiveView.PartialRefresh esriViewGraphics, Nothing, Nothing
3664:     End If

3666:   End If
  
  
3669:   Set Graphic_ReturnElementFromGeometry = pElement


  Exit Function
ErrorHandler:
  HandleError True, "Graphic_ReturnElementFromGeometry " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
Public Sub Graphic_MakeFromGeometry(ByRef pMxDoc As IMxDocument, ByRef pGeometry As IGeometry, Optional strName As String)
  On Error GoTo ErrorHandler

  
  Dim pMxDocument As esriArcMapUI.IMxDocument
  Dim pActiveView As esriCarto.IActiveView
  
  Dim pGContainer As IGraphicsContainer
3684:   Set pGContainer = pMxDoc.FocusMap
  
  Dim pElement As IElement
  Dim pPolygonElement As IPolygonElement
  Dim pSpatialReference As ISpatialReference
  Dim pGraphicElement As IGraphicElement
  Dim pElementProperties As IElementProperties
  
  Dim pClone As IClone
3693:   Set pClone = pGeometry
  Dim pNewGeometry As IGeometry
3695:   Set pNewGeometry = pClone.Clone
  
  Dim pGeometryType As esriGeometryType
3698:   pGeometryType = pNewGeometry.GeometryType
  
  'ADD GEOMETRY, NAME AND SPATIAL REFERENCE TO GRAPHIC ELEMENT
  Select Case pGeometryType
    Case 0:
3703:       MsgBox "Null Geometry!  No graphic added..."
    Case 1:
3705:       Set pElement = New MarkerElement
    Case 2:
3707:       Set pElement = New GroupElement
    Case 3, 6, 13, 14, 15, 16:
3709:       Set pElement = New LineElement
    Case 4, 11:
3711:       Set pElement = New PolygonElement
    Case 5:
3713:       Set pElement = New RectangleElement
    Case Else:
3715:       MsgBox "Unexpected Shape Type:  Unable to add graphic..."
3716:   End Select
  
3718:   If pGeometryType = 2 Then
    Dim pGroupElement As IGroupElement2
3720:     Set pGroupElement = New GroupElement
    Dim pSubElement As IElement
3722:     Set pSubElement = New MarkerElement
    Dim lngIndex As Long
    Dim pPtColl As IPointCollection
3725:     Set pPtColl = pNewGeometry
    Dim pPt As IPoint
3727:     For lngIndex = 0 To pPtColl.PointCount - 1
3728:       Set pPt = pPtColl.Point(lngIndex)
3729:       Set pSubElement = New MarkerElement
3730:       pSubElement.Geometry = pPt
3731:       pGroupElement.AddElement pSubElement
3732:     Next lngIndex
3733:     Set pGraphicElement = pGroupElement
3734:     Set pSpatialReference = pGeometry.SpatialReference
3735:     Set pGraphicElement.SpatialReference = pSpatialReference
3736:     Set pElementProperties = pGroupElement
3737:     pElementProperties.Name = strName
    ' ADD GRAPHIC TO GRAPHICS CONTAINER
3739:     pGContainer.AddElement pGroupElement, 0
3740:   Else
3741:     pElement.Geometry = pNewGeometry
3742:     Set pGraphicElement = pElement
3743:     Set pSpatialReference = pGeometry.SpatialReference
3744:     Set pGraphicElement.SpatialReference = pSpatialReference
3745:     Set pElementProperties = pElement
3746:     pElementProperties.Name = strName
  
    ' ADD GRAPHIC TO GRAPHICS CONTAINER
3749:     pGContainer.AddElement pElement, 0
3750:   End If

  'Draw
3753:   pMxDoc.ActiveView.PartialRefresh esriViewGraphics, Nothing, Nothing


  Exit Sub
ErrorHandler:
  HandleError True, "Graphic_MakeFromGeometry " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
Public Sub OpenDoc(theDocFilename As String, theDocPath As String)
  On Error GoTo ErrorHandler


    ' CHECK IF FILE EXISTS
    Dim booFileExists As Boolean
    Dim theCheckFilename As String
3767:     If Right(theDocPath, 1) = "\" Or Right(theDocPath, 1) = "/" Then
3768:       theCheckFilename = theDocPath & theDocFilename
3769:     Else
3770:       theCheckFilename = theDocPath & "\" & theDocFilename
3771:     End If
    
3773:     booFileExists = Dir(theCheckFilename) <> ""
    
3775:     If booFileExists Then
3776:       Call ShellExecute(0, vbNullString, theDocFilename, vbNullString, theDocPath, 1)
3777:     Else
3778:       MsgBox "Unable to find the following file:" & vbCrLf & vbCrLf & theCheckFilename & vbCrLf & _
            vbCrLf & "Bailing out...", , "Missing File:"
3780:     End If


  Exit Sub
ErrorHandler:
  HandleError True, "OpenDoc " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Public Function MakeColorRGB(pRed As Integer, pGreen As Integer, pBlue As Integer) As IColor
  On Error GoTo ErrorHandler


  Dim pColor As IRgbColor
3793:   Set pColor = New RgbColor
3794:   pColor.Red = pRed
3795:   pColor.Blue = pBlue
3796:   pColor.Green = pGreen
3797:   pColor.UseWindowsDithering = True
  
3799:   Set MakeColorRGB = pColor


  Exit Function
ErrorHandler:
  HandleError True, "MakeColorRGB " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
Public Function MakeColorHSV(pHue As Integer, pSaturation As Integer, pValue As Integer) As IColor
  On Error GoTo ErrorHandler


  Dim pColor As IHsvColor
3811:   Set pColor = New HsvColor
3812:   pColor.Hue = pHue
3813:   pColor.Saturation = pSaturation
3814:   pColor.Value = pValue
3815:   pColor.UseWindowsDithering = True
  
3817:   Set MakeColorHSV = pColor


  Exit Function
ErrorHandler:
  HandleError True, "MakeColorHSV " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
Public Sub GraphicsSetNameSelected(ByRef pMxDoc As IMxDocument, strName As String)
  On Error GoTo ErrorHandler


  Dim pGraphicsContainerSelect As IGraphicsContainerSelect
  
3830:   Set pGraphicsContainerSelect = pMxDoc.FocusMap
  Dim pEnumElement As IEnumElement
3832:   Set pEnumElement = pGraphicsContainerSelect.SelectedElements
3833:   pEnumElement.Reset
  
  Dim pElement As IElement
  Dim pElementProperties As IElementProperties
  
3838:   Set pElement = pEnumElement.Next
  
3840:   While Not pElement Is Nothing
3841:     Set pElementProperties = pElement
3842:     pElementProperties.Name = strName
3843:     Set pElement = pEnumElement.Next
3844:   Wend

  Exit Sub


  Exit Sub
ErrorHandler:
  HandleError True, "GraphicsSetNameSelected " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Public Function ReturnGraphicsByName(ByRef pMxDoc As IMxDocument, strName As String, _
      Optional AsElements As Boolean) As IArray
  On Error GoTo ErrorHandler


  Dim pGraphicsContainer As IGraphicsContainer
  
3861:   Set pGraphicsContainer = pMxDoc.FocusMap
  
3863:   pGraphicsContainer.Reset
  
  Dim pElement As IElement
  Dim pElementProperties As IElementProperties
  
3868:   Set pElement = pGraphicsContainer.Next
  
  Dim pArray As IArray
3871:   Set pArray = New esriSystem.Array
  Dim pGeometry As IGeometry
  Dim pClone As IClone
  
3875:   While Not pElement Is Nothing
3876:     Set pElementProperties = pElement
3877:     If pElementProperties.Name = strName Then
3878:       If AsElements Then
3879:         pArray.Add pElement
3880:       Else
3881:         Set pGeometry = pElement.Geometry
3882:         Set pClone = pGeometry
3883:         pArray.Add pClone.Clone     ' ONLY RETURN A COPY OF THE GEOMETRY; DON'T WANT TO MODIFY ACTUAL GRAPHIC HERE
3884:       End If
3885:     End If
3886:     Set pElement = pGraphicsContainer.Next
    
3888:   Wend
3889:   Set ReturnGraphicsByName = pArray


  Exit Function
ErrorHandler:
  HandleError True, "ReturnGraphicsByName " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function ReturnGraphicsByType(ByRef pMxDoc As IMxDocument, intGeometryType As esriGeometryType, _
      Optional AsElements As Boolean) As IArray
  On Error GoTo ErrorHandler


  Dim pGraphicsContainer As IGraphicsContainer
  
3904:   Set pGraphicsContainer = pMxDoc.FocusMap
  
3906:   pGraphicsContainer.Reset
  
  Dim pElement As IElement
  Dim pElementProperties As IElementProperties
  
3911:   Set pElement = pGraphicsContainer.Next
  
  Dim pArray As IArray
3914:   Set pArray = New esriSystem.Array
  Dim pGeometry As IGeometry
  Dim pClone As IClone
  
  Dim pGeometryType As esriGeometryType
  
3920:   While Not pElement Is Nothing
3921:     Set pElementProperties = pElement
3922:     Set pGeometry = pElement.Geometry
3923:     pGeometryType = pGeometry.GeometryType
    
3925:     If pGeometryType = intGeometryType Then
3926:       If AsElements Then            ' IN THIS CASE RETURN THE ACTUAL GRAPHIC ELEMENT
3927:         pArray.Add pElement
3928:       Else
3929:         Set pClone = pGeometry
3930:         pArray.Add pClone.Clone     ' ONLY RETURN A COPY OF THE GEOMETRY; DON'T WANT TO MODIFY ACTUAL GRAPHIC HERE
3931:       End If
3932:     End If
3933:     Set pElement = pGraphicsContainer.Next
    
3935:   Wend
3936:   Set ReturnGraphicsByType = pArray


  Exit Function
ErrorHandler:
  HandleError True, "ReturnGraphicsByType " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Sub DeleteGraphicsByName(ByRef pMxDoc As IMxDocument, strName As String)
  On Error GoTo ErrorHandler


  Dim pGraphicsContainer As IGraphicsContainer
  Dim pActiveView As IActiveView
  
3951:   Set pGraphicsContainer = pMxDoc.FocusMap
3952:   Set pActiveView = pMxDoc.ActiveView
  
3954:   pGraphicsContainer.Reset
  
  Dim pElement As IElement
  Dim pElementProperties As IElementProperties
  
3959:   Set pElement = pGraphicsContainer.Next
  
  Dim pEnvelope As IEnvelope
  
3963:   While Not pElement Is Nothing
3964:     Set pElementProperties = pElement
    
3966:     If pElementProperties.Name = strName Then
3967:       pGraphicsContainer.DeleteElement pElement
3968:       If (pEnvelope Is Nothing) Then
3969:         Set pEnvelope = pElement.Geometry.Envelope
3970:       Else
3971:         pEnvelope.Union pElement.Geometry.Envelope
3972:       End If
3973:     End If
3974:     Set pElement = pGraphicsContainer.Next
    
3976:   Wend
  
3978:   If (Not pEnvelope Is Nothing) Then
3979:     pActiveView.PartialRefresh esriViewGraphics + esriViewGraphicSelection + esriViewGeography, Nothing, pEnvelope
3980:   End If


  Exit Sub
ErrorHandler:
  HandleError True, "DeleteGraphicsByName " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub


Public Sub DoSpatialQuery(pSourceFeatureLayer As IFeatureLayer, pTargetFeatureLayer As IFeatureLayer, DoAll As Boolean, _
    pSelRelationship As esriSpatialRelEnum)
  On Error GoTo ErrorHandler


  Dim pFLayer As IFeatureLayer
  Dim pFc As IFeatureClass
   
  ' Specify the polygon layer with currently selected features
3998:   Set pFLayer = pSourceFeatureLayer

  Dim pFeatSel As IFeatureSelection
4001:   Set pFeatSel = pFLayer
  
  Dim pSelSet As ISelectionSet
  
4005:   If DoAll Then
4006:     pFeatSel.SelectFeatures Nothing, esriSelectionResultNew, False
4007:   End If
  
4009:   Set pSelSet = pFeatSel.SelectionSet

  Dim pEnumGeom As IEnumGeometry
  Dim pEnumGeomBind As IEnumGeometryBind

4014:   Set pEnumGeom = New EnumFeatureGeometry
4015:   Set pEnumGeomBind = pEnumGeom
4016:   pEnumGeomBind.BindGeometrySource Nothing, pSelSet

  Dim pGeomFactory As IGeometryFactory
4019:   Set pGeomFactory = New GeometryEnvironment

  Dim pGeom As IGeometry
4022:   Set pGeom = pGeomFactory.CreateGeometryFromEnumerator(pEnumGeom)

  Dim pSpFilter As ISpatialFilter
4025:   Set pSpFilter = New SpatialFilter
4026:   With pSpFilter
4027:     Set .Geometry = pGeom
4028:     .GeometryField = "SHAPE"
4029:     .SpatialRel = pSelRelationship
4030:   End With
  
4032:   Set pFLayer = pTargetFeatureLayer
4033:   Set pFeatSel = pFLayer
  
4035:   pFeatSel.SelectFeatures pSpFilter, esriSelectionResultNew, False


  Exit Sub
ErrorHandler:
  HandleError True, "DoSpatialQuery " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub


Public Function ReturnCurrentMapUnits(pMap As IMap) As String
  On Error GoTo ErrorHandler


  Dim intEsriUnits As Integer
4049:   intEsriUnits = pMap.MapUnits
  
  Select Case intEsriUnits
    Case 0
4053:       ReturnCurrentMapUnits = "Unknown"
    Case 1
4055:       ReturnCurrentMapUnits = "Inches"
    Case 2
4057:       ReturnCurrentMapUnits = "Points"
    Case 3
4059:       ReturnCurrentMapUnits = "Feet"
    Case 4
4061:       ReturnCurrentMapUnits = "Yards"
    Case 5
4063:       ReturnCurrentMapUnits = "Miles"
    Case 6
4065:       ReturnCurrentMapUnits = "Nautical Miles"
    Case 7
4067:       ReturnCurrentMapUnits = "Millimeters"
    Case 8
4069:       ReturnCurrentMapUnits = "Centimeters"
    Case 9
4071:       ReturnCurrentMapUnits = "Meters"
    Case 10
4073:       ReturnCurrentMapUnits = "Kilometers"
    Case 11
4075:       ReturnCurrentMapUnits = "Decimal Degrees"
    Case 12
4077:       ReturnCurrentMapUnits = "Decimeters"
4078:   End Select


  Exit Function
ErrorHandler:
  HandleError True, "ReturnCurrentMapUnits " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function


Public Sub ForceUppercase(KeyAscii As Integer, txtTextBox As TextBox)
  On Error GoTo ErrorHandler

  
4091:   KeyAscii = Asc(UCase(Chr(KeyAscii)))


  Exit Sub
ErrorHandler:
  HandleError True, "ForceUppercase " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Public Sub CheckNumericReal(KeyAscii As Integer, txtTextBox As TextBox)
  On Error GoTo ErrorHandler


Select Case KeyAscii
  Case Is < 8
4105:     KeyAscii = 0
'  Case 8            ' BACKSPACE
  Case 9 To 43
4108:     KeyAscii = 0
  Case 45            ' "-" CHARACTER; INSERT AT BEGINNING OR REMOVE FROM BEGINNING
                     ' RESET CURSOR POSITION TO ORIGINAL CHARACTER LOCATION
4111:     KeyAscii = 0
    Dim strText As String
    Dim lngpos As Long
4114:     strText = txtTextBox.Text
4115:     lngpos = txtTextBox.SelStart
4116:     If Left(strText, 1) = "-" Then
4117:       txtTextBox.Text = Right(strText, Len(strText) - 1)
4118:       If lngpos > 0 Then
4119:         txtTextBox.SelStart = lngpos - 1
4120:       End If
4121:     Else
4122:       txtTextBox.Text = "-" & strText
4123:       txtTextBox.SelStart = lngpos + 1
4124:     End If
  Case 44 Or 46          ' DECIMAL CHARACTER; ONLY ALLOW ONE PERIOD OR COMMA
    Dim strText2 As String
4127:     strText2 = txtTextBox.Text
    Dim lngPos2 As Long
4129:     lngPos2 = txtTextBox.SelStart
4130:     If Not IsNumeric(Left(strText2, lngPos2) & Chr(KeyAscii) & Right(strText2, Len(strText2) - lngPos2)) Then
4131:       KeyAscii = 0
4132:     End If
  Case 47          ' "/" CHARACTER
4134:     KeyAscii = 0
  Case Is > 57
4136:     KeyAscii = 0
4137: End Select


  Exit Sub
ErrorHandler:
  HandleError True, "CheckNumericReal " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub


Public Sub CheckNumericRealPositive(KeyAscii As Integer, txtTextBox As TextBox)
  On Error GoTo ErrorHandler


Select Case KeyAscii
  Case Is < 8
4152:     KeyAscii = 0
'  Case 8            ' BACKSPACE
  Case 9 To 43
4155:     KeyAscii = 0
  Case 45            ' "-" CHARACTER
4157:     KeyAscii = 0

  Case 44 Or 46          ' DECIMAL CHARACTER; ONLY ALLOW ONE PERIOD OR COMMA
    Dim strText2 As String
4161:     strText2 = txtTextBox.Text
    Dim lngPos2 As Long
4163:     lngPos2 = txtTextBox.SelStart
4164:     If Not IsNumeric(Left(strText2, lngPos2) & Chr(KeyAscii) & Right(strText2, Len(strText2) - lngPos2)) Then
4165:       KeyAscii = 0
4166:     End If
  Case 47          ' "/" CHARACTER
4168:     KeyAscii = 0
  Case Is > 57
4170:     KeyAscii = 0
4171: End Select


  Exit Sub
ErrorHandler:
  HandleError True, "CheckNumericRealPositive " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
Public Sub CheckNumericInteger(KeyAscii As Integer, txtTextBox As TextBox)
  On Error GoTo ErrorHandler


Select Case KeyAscii
  Case Is < 8
4184:     KeyAscii = 0
'  Case 8            ' BACKSPACE
  Case 9 To 43
4187:     KeyAscii = 0
  Case 45            ' "-" CHARACTER; INSERT AT BEGINNING OR REMOVE FROM BEGINNING
                     ' RESET CURSOR POSITION TO ORIGINAL CHARACTER LOCATION
4190:     KeyAscii = 0
    Dim strText As String
    Dim lngpos As Long
4193:     strText = txtTextBox.Text
4194:     lngpos = txtTextBox.SelStart
4195:     If Left(strText, 1) = "-" Then
4196:       txtTextBox.Text = Right(strText, Len(strText) - 1)
4197:       If lngpos > 0 Then
4198:         txtTextBox.SelStart = lngpos - 1
4199:       End If
4200:     Else
4201:       txtTextBox.Text = "-" & strText
4202:       txtTextBox.SelStart = lngpos + 1
4203:     End If
  Case 44, 46, 47         ' PREVENT PERIOD OR COMMA DECIMAL CHARACTER
4205:     KeyAscii = 0
  Case Is > 57
4207:     KeyAscii = 0
4208: End Select


  Exit Sub
ErrorHandler:
  HandleError True, "CheckNumericInteger " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Public Sub CheckNumericIntegerPositive(KeyAscii As Integer, txtTextBox As TextBox)
  On Error GoTo ErrorHandler


' ONLY ALLOW NUMBERS AND BACKSPACE
Select Case KeyAscii
  Case Is < 8
4223:     KeyAscii = 0
'  Case 8            ' BACKSPACE
  Case 9 To 47
4226:     KeyAscii = 0
  Case Is > 57
4228:     KeyAscii = 0
4229: End Select


  Exit Sub
ErrorHandler:
  HandleError True, "CheckNumericIntegerPositive " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub
Public Function CompareSpatialReferences(ByVal pSourceSR As ISpatialReference, ByVal pTargetSR As ISpatialReference) As Boolean
  On Error GoTo ErrorHandler

  
  Dim pSourceClone As IClone
  Dim pTargetClone As IClone
  Dim bSREqual As Boolean
  
4244:   Set pSourceClone = pSourceSR
4245:   Set pTargetClone = pTargetSR
  
  'MsgBox "pSourceClone is nothing = " & CStr(pSourceClone Is Nothing) & vbCrLf & _
        "pTargetClone is nothing = " & CStr(pTargetClone Is Nothing)
  
4250:   If pSourceClone Is Nothing And pTargetClone Is Nothing Then
4251:     CompareSpatialReferences = True
4252:   ElseIf pSourceClone Is Nothing Or pTargetClone Is Nothing Then
4253:     CompareSpatialReferences = False
4254:   Else
    
    'Compare the coordinate system component of the spatial reference
4257:     bSREqual = pSourceClone.IsEqual(pTargetClone)
    
    'If the comparison failed, return false and exit
4260:     If Not bSREqual Then
4261:       CompareSpatialReferences = False
      Exit Function
4263:     End If
    
    'We can also compare the XY precision to ensure the spatial references are equal
    Dim pSourceSR2 As ISpatialReference2
    Dim bXYIsEqual As Boolean
    
4269:     Set pSourceSR2 = pSourceSR
4270:     bXYIsEqual = pSourceSR2.IsXYPrecisionEqual(pTargetSR)
    
    'If the comparison failed, return false and exit
4273:     If Not bXYIsEqual Then
4274:       CompareSpatialReferences = False
      Exit Function
4276:     End If
    
4278:     CompareSpatialReferences = True
4279:   End If


  Exit Function
ErrorHandler:
  HandleError True, "CompareSpatialReferences " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function ReturnTimeElapsedFromMilliseconds(lngMilliseconds As Long) As String
  On Error GoTo ErrorHandler

  
  Dim theElapsedTime As Double
  Dim theNumDays As Double
  Dim theNumHours As Double
  Dim theNumMinutes As Double
  Dim theNumSeconds As Double
  
4297:   theElapsedTime = lngMilliseconds / 1000
  
4299:   theNumDays = Int(theElapsedTime / 86400)
4300:   theNumHours = Int((theElapsedTime Mod 86400) / 3600)
4301:   theNumMinutes = Int((theElapsedTime Mod 3600) / 60)
4302:   theNumSeconds = theElapsedTime Mod 60
  
  Dim theDayString As String
  Dim theHourString As String
  Dim theMinString As String
  Dim theSecString As String
  
4309:   If theNumDays = 1 Then
4310:     theDayString = " day"
4311:   Else
4312:     theDayString = " days"
4313:   End If
  
4315:   If theNumHours = 1 Then
4316:     theHourString = " hour"
4317:   Else
4318:     theHourString = " hours"
4319:   End If
  
4321:   If theNumMinutes = 1 Then
4322:     theMinString = " minute"
4323:   Else
4324:     theMinString = " minutes"
4325:   End If
  
4327:   If theNumSeconds = 1 Then
4328:     theSecString = " second..."
4329:   Else
4330:     theSecString = " seconds..."
4331:   End If
  
  Dim theElapsedTimeString As String
4334:   theElapsedTimeString = ""
4335:   If theNumDays > 0 Then
4336:     theElapsedTimeString = theElapsedTimeString & theNumDays & theDayString & ", " & theNumHours & theHourString & ", " & _
    theNumMinutes & theMinString & ", " & theNumSeconds & theSecString
4338:   ElseIf theNumHours > 0 Then
4339:     theElapsedTimeString = theElapsedTimeString & theNumHours & theHourString & ", " & _
    theNumMinutes & theMinString & ", " & theNumSeconds & theSecString
4341:   ElseIf theNumMinutes > 0 Then
4342:     theElapsedTimeString = theElapsedTimeString & _
    theNumMinutes & theMinString & ", " & theNumSeconds & theSecString
4344:   Else
4345:     theElapsedTimeString = theElapsedTimeString & theNumSeconds & theSecString
4346:   End If
  
4348:   ReturnTimeElapsedFromMilliseconds = theElapsedTimeString


  Exit Function
ErrorHandler:
  HandleError True, "ReturnTimeElapsedFromMilliseconds " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function
Public Function ReturnTimeElapsed(theTimeBegan As Date, theTimeEnd As Date) As String
  On Error GoTo ErrorHandler

  
  Dim theElapsedTime As Double
  Dim theNumDays As Double
  Dim theNumHours As Double
  Dim theNumMinutes As Double
  Dim theNumSeconds As Double
  
4365:   theElapsedTime = DateDiff("s", theTimeBegan, theTimeEnd)
  
4367:   theNumDays = Int(theElapsedTime / 86400)
4368:   theNumHours = Int((theElapsedTime Mod 86400) / 3600)
4369:   theNumMinutes = Int((theElapsedTime Mod 3600) / 60)
4370:   theNumSeconds = theElapsedTime Mod 60
  
  Dim theDayString As String
  Dim theHourString As String
  Dim theMinString As String
  Dim theSecString As String
  
4377:   If theNumDays = 1 Then
4378:     theDayString = " day"
4379:   Else
4380:     theDayString = " days"
4381:   End If
  
4383:   If theNumHours = 1 Then
4384:     theHourString = " hour"
4385:   Else
4386:     theHourString = " hours"
4387:   End If
  
4389:   If theNumMinutes = 1 Then
4390:     theMinString = " minute"
4391:   Else
4392:     theMinString = " minutes"
4393:   End If
  
4395:   If theNumSeconds = 1 Then
4396:     theSecString = " second..."
4397:   Else
4398:     theSecString = " seconds..."
4399:   End If
  
  Dim theElapsedTimeString As String
4402:   theElapsedTimeString = "Time Elapsed: "
4403:   If theNumDays > 0 Then
4404:     theElapsedTimeString = theElapsedTimeString & theNumDays & theDayString & ", " & theNumHours & theHourString & ", " & _
    theNumMinutes & theMinString & ", " & theNumSeconds & theSecString
4406:   ElseIf theNumHours > 0 Then
4407:     theElapsedTimeString = theElapsedTimeString & theNumHours & theHourString & ", " & _
    theNumMinutes & theMinString & ", " & theNumSeconds & theSecString
4409:   ElseIf theNumMinutes > 0 Then
4410:     theElapsedTimeString = theElapsedTimeString & _
    theNumMinutes & theMinString & ", " & theNumSeconds & theSecString
4412:   Else
4413:     theElapsedTimeString = theElapsedTimeString & theNumSeconds & theSecString
4414:   End If
  
4416:   ReturnTimeElapsed = "Analysis Began: " & Format(theTimeBegan, "long date") & ";  " & Format(theTimeBegan, "long time") & vbCrLf & _
                      "Analysis Complete: " & Format(theTimeEnd, "long date") & ";  " & Format(theTimeEnd, "long time") & vbCrLf & _
                      theElapsedTimeString & vbCrLf & vbCrLf


  Exit Function
ErrorHandler:
  HandleError True, "ReturnTimeElapsed " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function


Public Function ReturnTimeElapsedRTF(theTimeBegan As Date, theTimeEnd As Date, lngFontSize As Long) As String
  On Error GoTo ErrorHandler


  Dim theElapsedTime As Double
  Dim theNumDays As Double
  Dim theNumHours As Double
  Dim theNumMinutes As Double
  Dim theNumSeconds As Double
  
4437:   theElapsedTime = CDbl(DateDiff("s", theTimeBegan, theTimeEnd))
'  MsgBox "theElapsedTime = " & CStr(theElapsedTime)
4439:   theNumDays = Int(CDbl(theElapsedTime / 86400#))
4440:   theNumHours = Int(CDbl(theElapsedTime Mod 86400#) / 3600#)
4441:   theNumMinutes = Int(CDbl(theElapsedTime Mod 3600#) / 60)
4442:   theNumSeconds = theElapsedTime Mod 60
  
  Dim theDayString As String
  Dim theHourString As String
  Dim theMinString As String
  Dim theSecString As String
  
4449:   If theNumDays = 1 Then
4450:     theDayString = " day"
4451:   Else
4452:     theDayString = " days"
4453:   End If
  
4455:   If theNumHours = 1 Then
4456:     theHourString = " hour"
4457:   Else
4458:     theHourString = " hours"
4459:   End If
  
4461:   If theNumMinutes = 1 Then
4462:     theMinString = " minute"
4463:   Else
4464:     theMinString = " minutes"
4465:   End If
  
4467:   If theNumSeconds = 1 Then
4468:     theSecString = " second..."
4469:   Else
4470:     theSecString = " seconds..."
4471:   End If
  
  Dim theElapsedTimeString As String
4474:   theElapsedTimeString = "Time Elapsed: "
4475:   If theNumDays > 0 Then
4476:     theElapsedTimeString = theElapsedTimeString & theNumDays & theDayString & ", " & theNumHours & theHourString & ", " & _
    theNumMinutes & theMinString & ", " & theNumSeconds & theSecString
4478:   ElseIf theNumHours > 0 Then
4479:     theElapsedTimeString = theElapsedTimeString & theNumHours & theHourString & ", " & _
    theNumMinutes & theMinString & ", " & theNumSeconds & theSecString
4481:   ElseIf theNumMinutes > 0 Then
4482:     theElapsedTimeString = theElapsedTimeString & _
    theNumMinutes & theMinString & ", " & theNumSeconds & theSecString
4484:   Else
4485:     theElapsedTimeString = theElapsedTimeString & theNumSeconds & theSecString
4486:   End If
  
4488:   ReturnTimeElapsedRTF = _
    "\b\fszzzFontSizezzz Analysis Began:\b0\i    zzzTimeBeganzzz\par" & vbCrLf & _
    "\b\i0 Analysis Complete:\b0\i    zzzTimeEndzzz\par" & vbCrLf & _
    "\b\i0 Time Elapsed:\b0\i    zzzTimeElapsedzzz\par" & vbCrLf
  
'  ReturnTimeElapsedRTF = "{\rtf1\ansi\ansicpg1252\deff0\deflang1033{\fonttbl{\f0\fswiss\fcharset0 Arial;}}" & vbCrLf & _
      "{\*\generator Msftedit 5.41.15.1507;}\viewkind4\uc1\pard\b\f0\fszzzFontSizezzz Analysis Began:\b0\i    zzzTimeBeganzzz\par" & vbCrLf & _
      "\b\i0 Analysis Complete:\b0\i    zzzTimeEndzzz\par" & vbCrLf & _
      "\b\i0 Time Elapsed:\b0\i    zzzTimeElapsedzzz\par" & vbCrLf & _
      "}"
  Dim strTimeBegan As String
4499:   strTimeBegan = CStr(Format(theTimeBegan, "long date")) & " at " & CStr(Format(theTimeBegan, "long time"))
  Dim strTimeEnd As String
4501:   strTimeEnd = CStr(Format(theTimeEnd, "long date")) & " at " & CStr(Format(theTimeEnd, "long time"))
  
4503:   ReturnTimeElapsedRTF = Replace(ReturnTimeElapsedRTF, "zzzFontSizezzz", CStr(lngFontSize * 2))
4504:   ReturnTimeElapsedRTF = Replace(ReturnTimeElapsedRTF, "zzzTimeBeganzzz", strTimeBegan)
4505:   ReturnTimeElapsedRTF = Replace(ReturnTimeElapsedRTF, "zzzTimeEndzzz", strTimeEnd)
4506:   ReturnTimeElapsedRTF = Replace(ReturnTimeElapsedRTF, "zzzTimeElapsedzzz", theElapsedTimeString)
  
'  ReturnTimeElapsedRTF = "Analysis Began: " & Format(theTimeBegan, "long date") & ";  " & Format(theTimeBegan, "long time") & vbCrLf & _
                      "Analysis Complete: " & Format(theTimeEnd, "long date") & ";  " & Format(theTimeEnd, "long time") & vbCrLf & _
                      theElapsedTimeString & vbCrLf & vbCrLf


  Exit Function
ErrorHandler:
  HandleError True, "ReturnTimeElapsedRTF " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Sub RemoveKeyFromCollection(colCollection As Collection, strKey As String)
  On Error GoTo ErrorHandler


  On Error Resume Next
  
4524:   colCollection.Remove strKey


  Exit Sub
ErrorHandler:
  HandleError True, "RemoveKeyFromCollection " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Public Function CheckCollectionForKey(colCollection As Collection, strKey As String) As Boolean
  On Error GoTo errHandler
  
4535:   CheckCollectionForKey = True
  Dim lngVarType As Long
4537:   lngVarType = VarType(colCollection.Item(strKey))
  
  Exit Function
errHandler:
4541:   CheckCollectionForKey = False

End Function

Public Sub EnableSelectTool(pApp As IApplication)
  On Error GoTo ErrorHandler


    Dim pUID As New UID
    Dim pCmdItem As ICommandItem
    ' Use the GUID of the Select Elements command
4552:     pUID.Value = "{C22579D1-BC17-11D0-8667-0000F8751720}"
4553:     Set pCmdItem = pApp.Document.CommandBars.Find(pUID)
4554:     pCmdItem.Execute


  Exit Sub
ErrorHandler:
  HandleError True, "EnableSelectTool " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Public Function CreateNestedFoldersByPath(ByVal completeDirectory As String) As Long
  On Error GoTo ErrorHandler


  'ADAPTED FROM http://vbnet.mvps.org/index.html?code/file/nested.htm
  'Visual Basic File Routines
  'CreateDirectory: Creating Nested Folders
  '
  'Posted:     Saturday September 19, 1998
  'Updated:    Wednesday December 05, 2007
  '
  'Applies to:     VB4-32, VB5, VB6
  'Developed with:     VB5, Windows 98
  'OS restrictions:    None
  'Author:     VBnet - Randy Birch

  'creates nested directories on the drive
  'included in the path by parsing the final
  'directory string into a directory array,
  'and looping through each to create the final path.
  
  'The path could be passed to this method as a
  'pre-filled array, reducing the code.
  
   Dim r As Long
   Dim SA As SECURITY_ATTRIBUTES
   Dim drivePart As String
   Dim newDirectory  As String
   Dim Item As String
   Dim sfolders() As String
   Dim pos As Long
   Dim X As Long
      
  'must have a trailing slash for
  'the GetPart routine below
4597:    If Right$(completeDirectory, 1) <> "\" Then
4598:       completeDirectory = completeDirectory & "\"
4599:    End If
  
  'if there is a drive in the string, get it
  'else, just use nothing - assumes current drive
4603:    pos = InStr(completeDirectory, ":")

4605:    If pos Then
4606:       drivePart = GetPart(completeDirectory, "\")
4607:    Else: drivePart = ""
4608:    End If

  'now get the rest of the items that
  'make up the string
4612:    Do Until completeDirectory = ""

    'strip off one item (i.e. "Files\")
4615:      Item = GetPart(completeDirectory, "\")

    'add it to an array for later use, and
    'if this is the first item (x=0),
    'append the drivepart
     ReDim Preserve sfolders(0 To X) As String

4622:      If X = 0 Then Item = drivePart & Item
4623:      sfolders(X) = Item
     
    'increment the array counter
4626:      X = X + 1

4628:    Loop

  'Now create the directories.
  'Because the first directory is
  '0 in the array, reinitialize x to -1
4633:    X = -1
   
4635:    Do
   
4637:       X = X + 1
     'just keep appending the folders in the
     'array to newDirectory.  When x=0 ,
     'newDirectory is "", so the
     'newDirectory gets assigned drive:\firstfolder.
     
     'Subsequent loops adds the next member of the
     'array to the path, forming a fully qualified
     'path to the new directory.
4646:       newDirectory = newDirectory & sfolders(X)
      
     'the only member of the SA type needed (on
     'a win95/98 system at least)
4650:       SA.nLength = LenB(SA)
      
4652:       Call CreateDirectory(newDirectory, SA)
       
4654:    Loop Until X = UBound(sfolders)
   
  'done. Return x, but add 1 for the 0-based array.
4657:    CreateNestedFoldersByPath = X + 1


  Exit Function
ErrorHandler:
  HandleError True, "CreateNestedFoldersByPath " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function GetPart(startStrg As String, delimiter As String) As String
  On Error GoTo ErrorHandler


'takes a string separated by "delimiter",
'splits off 1 item, and shortens the string
'so that the next item is ready for removal.

  Dim C As Integer
  Dim Item As String
  
4676:   C = 1
  
4678:   Do

4680:     If Mid$(startStrg, C, 1) = delimiter Then
      
4682:       Item = Mid$(startStrg, 1, C)
4683:       startStrg = Mid$(startStrg, C + 1, Len(startStrg))
4684:       GetPart = Item
      Exit Function
    
4687:     End If

4689:     C = C + 1

4691:   Loop


  Exit Function
ErrorHandler:
  HandleError True, "GetPart " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function ReturnTimeStamp() As String
  On Error GoTo ErrorHandler


4703:   ReturnTimeStamp = CStr(Format(Now, "yyyymmdd_HhNnSs"))


  Exit Function
ErrorHandler:
  HandleError True, "ReturnTimeStamp " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function


Private Function IsNaN(expression As Variant) As Boolean
  On Error GoTo ErrorHandler

  On Error Resume Next
4716:   If Not IsNumeric(expression) Then
4717:     IsNaN = False
    Exit Function
4719:   End If
4720:   If (CStr(expression) = "-1.#QNAN") Or (CStr(expression) = "1,#QNAN") Then ' can vary by locale
4721:     IsNaN = True
4722:   Else
4723:     IsNaN = False
4724:   End If

  Exit Function
ErrorHandler:
  HandleError False, "IsNaN " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function


Public Function MakeUniqueRasterName(pRasterType As JenDatasetTypes, strWSPath As String, strRasterName As String, _
      Optional booTrimForGRID As Boolean) As String
  On Error GoTo ErrorHandler
  
  ' ONLY RETURNS ACTUAL RASTER NAME
  
  Dim pWSFact As IWorkspaceFactory
  
  Dim pWorkspace As IWorkspace
  Dim pWorkspace2 As IWorkspace2
  Dim pWsEx As IRasterWorkspaceEx
  Dim pWS As IRasterWorkspace
  
  Dim lngIndex As Long
4746:   lngIndex = 1
  
  Dim strNewName As String
  Dim strBaseName As String
4750:   strNewName = strRasterName
4751:   strBaseName = strRasterName
  
  Dim strIndex As String
  
  Select Case pRasterType
    Case ENUM_FileGDB
4757:       Set pWSFact = New FileGDBWorkspaceFactory
4758:       Set pWsEx = pWSFact.OpenFromFile(strWSPath, 0)
4759:       Set pWorkspace2 = pWsEx
4760:       Do Until Not pWorkspace2.NameExists(esriDTRasterDataset, strNewName)
4761:         lngIndex = lngIndex + 1
4762:         strNewName = strBaseName & "_" & CStr(lngIndex)
4763:       Loop
4764:       MakeUniqueRasterName = strNewName
    Case ENUM_PersonalGDB
4766:       Set pWSFact = New AccessWorkspaceFactory
4767:       Set pWsEx = pWSFact.OpenFromFile(strWSPath, 0)
4768:       Set pWorkspace2 = pWsEx
4769:       Do Until Not pWorkspace2.NameExists(esriDTRasterDataset, strNewName)
4770:         lngIndex = lngIndex + 1
4771:         strNewName = strBaseName & "_" & CStr(lngIndex)
4772:       Loop
4773:       MakeUniqueRasterName = strNewName
    Case ENUM_File_Raster
      
4776:       If booTrimForGRID Then
        ' FOLLOW GRID RESTRICTIONS
4778:         strNewName = Left(ReplaceBadChars(strNewName, True, True, True, False), 13)
4779:         strBaseName = strNewName
4780:       End If
      
4782:       Set pWSFact = New RasterWorkspaceFactory
4783:       Set pWS = pWSFact.OpenFromFile(strWSPath, 0)
4784:       Set pWorkspace = pWS
      
      Dim pEnumDatasetName As IEnumDatasetName
4787:       Set pEnumDatasetName = pWorkspace.DatasetNames(esriDTRasterDataset)
      Dim pDatasetName As IDatasetName
      
      Dim booNameExists As Boolean
4791:       booNameExists = True
      
4793:       Do Until booNameExists = False
4794:         booNameExists = False
                    
4796:         pEnumDatasetName.Reset
4797:         Set pDatasetName = pEnumDatasetName.Next
        
4799:         Do Until pDatasetName Is Nothing
4800:           If pDatasetName.Name = strNewName Then
4801:             booNameExists = True
4802:             Set pDatasetName = Nothing
4803:           Else
4804:             Set pDatasetName = pEnumDatasetName.Next
4805:           End If
4806:         Loop
        
4808:         If booNameExists Then
4809:           lngIndex = lngIndex + 1
4810:           strIndex = "_" & CStr(lngIndex)
4811:           If booTrimForGRID Then
4812:             strNewName = Left(strBaseName, 13 - Len(strIndex)) & strIndex
4813:           Else
4814:             strNewName = strBaseName & strIndex
4815:           End If
4816:         End If
4817:       Loop
      
4819:       MakeUniqueRasterName = strNewName
4820:   End Select
      

  Exit Function
ErrorHandler:
  HandleError True, "MakeUniqueRasterName " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function CursorToSet_Features(pFCursor As IFeatureCursor) As esriSystem.ISet
  On Error GoTo ErrorHandler

  'http://forums.esri.com/Thread.asp?c=93&f=992&t=79743&mc=16.
  Dim pFeature As IFeature
4833:   Set CursorToSet_Features = New esriSystem.Set
4834:   Set pFeature = pFCursor.NextFeature
4835:   Do While Not pFeature Is Nothing
4836:     CursorToSet_Features.Add pFeature
4837:     Set pFeature = pFCursor.NextFeature
4838:   Loop
  
4840:   CursorToSet_Features.Reset
  
  Exit Function
ErrorHandler:
  HandleError True, "CursorToSet_Features " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function CursorToSet_TableRow(ByVal pCursor As ICursor) As esriSystem.ISet
  On Error GoTo ErrorHandler

' adapted from VB.NET
' http://forums.esri.com/Thread.asp?c=93&f=992&t=79743&mc=19

  Dim pSSet As esriSystem.ISet
  Dim pRow As IRow

  'populate the set with the cursor
4857:   Set pSSet = New esriSystem.Set
4858:   Set pRow = pCursor.NextRow
4859:   Do Until pRow Is Nothing
4860:     Do Until pRow Is Nothing
4861:       pSSet.Add pRow
4862:       Set pRow = pCursor.NextRow
4863:     Loop
4864:     pSSet.Reset
4865:   Loop

4867:   Set CursorToSet_TableRow = pSSet


  Exit Function
ErrorHandler:
  HandleError True, "CursorToSet_TableRow " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Sub MakeRandomNormalPolar(dblMean As Double, dblSD As Double, ByRef dblRand1 As Double, Optional ByRef dblRand2 As Double = -999)
  On Error GoTo ErrorHandler

'  Static dblSeed
' Based on Marsaglia's variation of the Box-Muller Transformation (http://en.wikipedia.org/wiki/Box-Muller_transform):
'        z1 = u * sqrt((-2 ln(s))/s)
'        z2 = v * sqrt((-2 ln(s))/s)
'      where:
'         s = u^2 + v^2, and is not equal to 0 or > 1
'        x1 = first uniform random number (between -1 and 1)
'        x2 = second uniform random number (between -1 and 1)
'        z1 = first normally distributed random number
'        z2 = second normally distributed random number.

' RANDOMIZE FIRST!
'  If dblSeed = 0 Then
'    Randomize            ' USE SYSTEM TIMER
'  Else
'    Randomize dblSeed
'  End If
  
  Dim dblX1 As Double
  Dim dblX2 As Double
  Dim S As Double
4899:   S = 5
4900:   Do Until S <= 1 And S <> 0
4901:     dblX1 = (Rnd * 2) - 1
4902:     dblX2 = (Rnd * 2) - 1
4903:     S = dblX2 ^ 2 + dblX1 ^ 2
4904:   Loop
  
4906:   dblRand1 = (dblX1 * Sqr(-2 * Log(S) / S) * dblSD#) + dblMean#
4907:   dblRand2 = (dblX2 * Sqr(-2 * Log(S) / S) * dblSD#) + dblMean#
  
'  dblSeed = dblRand2
  

  Exit Sub
ErrorHandler:
  HandleError True, "MakeRandomNormalPolar " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Sub

Public Function CreateInMemoryFeatureClass(pGeometryArray As esriSystem.IArray, _
    Optional pValueArray As esriSystem.IVariantArray, Optional pTemplateField As IField) As IFeatureClass
  On Error GoTo ErrorHandler

    ' create an inmemory featureclass
    ' ADAPTED FROM KIRK KUYKENDALL
    ' http://forums.esri.com/Thread.asp?c=93&f=993&t=210767
    
    ' ASSUMES ONE OR MORE GEOMETRIES, ALL OF WHICH ARE IN THE SAME PROJECTION
    Dim pGeom As IGeometry
4927:     Set pGeom = pGeometryArray.Element(0)
    
    Dim pWSF As IWorkspaceFactory
4930:     Set pWSF = New InMemoryWorkspaceFactory
    
    Dim pName As IName
4933:     Set pName = pWSF.Create("", "inmemory", Nothing, 0)
    Dim pFWS As IFeatureWorkspace
4935:     Set pFWS = pName.Open
    
    Dim pFlds As IFields
        
    Dim pFields As IFields
    Dim pFieldsEdit As IFieldsEdit
    Dim pField As IField
    Dim pFieldEdit As IFieldEdit
   
4944:     Set pFields = New Fields
4945:     Set pFieldsEdit = pFields
      
    '' create the geometry field
    
    Dim pGeomDef As IGeometryDef
    Dim pGeomDefEdit As IGeometryDefEdit
4951:     Set pGeomDef = New GeometryDef
4952:     Set pGeomDefEdit = pGeomDef
    
    '' assign the geometry definiton properties.
4955:     With pGeomDefEdit
4956:       .GeometryType = pGeom.GeometryType
4957:       .GridCount = 1
4958:       .GridSize(0) = 10
4959:       .AvgNumPoints = 2
4960:       .HasM = False
4961:       .HasZ = False
4962:       Set .SpatialReference = pGeom.SpatialReference
4963:     End With
    
4965:     Set pField = New Field
4966:     Set pFieldEdit = pField
    
4968:     pFieldEdit.Name = "Shape"
4969:     pFieldEdit.AliasName = "geometry"
4970:     pFieldEdit.Type = esriFieldTypeGeometry
4971:     Set pFieldEdit.GeometryDef = pGeomDef
4972:     pFieldsEdit.AddField pField
    
    Dim pClone As IClone
    Dim booAddAttribute As Boolean
4976:     booAddAttribute = Not pValueArray Is Nothing And Not pTemplateField Is Nothing
    Dim varVal As Variant
    
4979:     If booAddAttribute Then
4980:       Set pClone = pTemplateField
4981:       Set pField = pClone.Clone
4982:       pFieldsEdit.AddField pField
4983:     Else
4984:       Set pField = New Field
4985:       Set pFieldEdit = pField
4986:       With pFieldEdit
4987:         .Name = "Unique_ID"
4988:         .Type = esriFieldTypeInteger
4989:       End With
4990:       pFieldsEdit.AddField pField
4991:     End If
    
    Dim pCLSID As UID
4994:     Set pCLSID = New UID
4995:     pCLSID.Value = "esriGeoDatabase.Feature"
  
    Dim pInMemFC As IFeatureClass
4998:     Set pInMemFC = pFWS.CreateFeatureClass("In_Memory", pFields, _
                             pCLSID, Nothing, esriFTSimple, _
                             "Shape", "")
    
    Dim lngIDIndex As Long
    
    Dim lngAttIndex As Long
5005:     If booAddAttribute Then
5006:       lngAttIndex = pInMemFC.FindField(pTemplateField.Name)
5007:     Else
5008:       lngIDIndex = pInMemFC.FindField("Unique_ID")
5009:     End If
    
    Dim lngIndex As Long
    Dim pOutFeat As IFeature
5013:     For lngIndex = 0 To pGeometryArray.Count - 1
5014:       Set pGeom = pGeometryArray.Element(lngIndex)
5015:       Set pOutFeat = pInMemFC.CreateFeature
5016:       Set pOutFeat.Shape = pGeom
5017:       If booAddAttribute Then
5018:         varVal = pValueArray.Element(lngIndex)
5019:         pOutFeat.Value(lngAttIndex) = varVal
5020:       Else
5021:         pOutFeat.Value(lngIDIndex) = lngIndex + 1
5022:       End If
5023:       pOutFeat.Store
5024:     Next lngIndex
    
5026:     Set CreateInMemoryFeatureClass = pInMemFC
      
5028:     Set pGeom = Nothing
5029:     Set pWSF = Nothing
5030:     Set pName = Nothing
5031:     Set pFWS = Nothing
5032:     Set pFlds = Nothing
5033:     Set pFields = Nothing
5034:     Set pFieldsEdit = Nothing
5035:     Set pField = Nothing
5036:     Set pFieldEdit = Nothing
5037:     Set pGeomDef = Nothing
5038:     Set pGeomDefEdit = Nothing
5039:     Set pCLSID = Nothing
5040:     Set pInMemFC = Nothing
5041:     Set pOutFeat = Nothing
5042:     Set pClone = Nothing
    
  Exit Function
ErrorHandler:
  HandleError True, "CreateInMemoryFeatureClass " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function

Public Function ReturnTempRasterWorkspace() As IWorkspace
    ' ADAPTED FROM ESRI SAMPLE http://edndoc.esri.com/arcobjects/9.2/CPP_VB6_VBA_VCPP_Doc/COM_Samples_Docs/SpatialAnalyst/ImageUpdate/Visual_Basic/ImageUpdate.frm.htm
    ' Given a pathname, returns the raster workspace object for that path
    On Error GoTo ERH
    
    ' Create a Rasterworkspace
    Dim sPath As String
5056:     sPath = Environ("TEMP") ' Get temp directory
    
    Dim pWSF As IWorkspaceFactory
5059:     Set pWSF = New RasterWorkspaceFactory
    Dim pWS As IWorkspace
5061:     Set pWS = pWSF.OpenFromFile(sPath, 0)
5062:     Set ReturnTempRasterWorkspace = pWS
    Exit Function
ERH:
5065:     Set ReturnTempRasterWorkspace = Nothing
End Function
Public Function MakeUniqueRasterName2(pWS As IWorkspace, strBaseName As String, booRestrictTo13CharForGrid As Boolean) As String
  On Error GoTo ErrorHandler

  
  Dim pNames As IEnumDatasetName
5072:   Set pNames = pWS.DatasetNames(esriDTAny)
  Dim pDatasetName As IDatasetName
  
  Dim booNameExists As Boolean
5076:   booNameExists = True
  
  Dim lngCounter As Long
5079:   lngCounter = 1
  Dim strCounter As String
  Dim strUniqueName As String
5082:   strUniqueName = strBaseName
  
5084:   Do Until booNameExists = False
5085:     booNameExists = False
5086:     pNames.Reset
5087:     Set pDatasetName = pNames.Next
5088:     Do Until pDatasetName Is Nothing
5089:       Debug.Print "Checking " & pDatasetName.Name
5090:       If pDatasetName.Name = strUniqueName Then
5091:         booNameExists = True
5092:         Exit Do
5093:       End If
5094:       Set pDatasetName = pNames.Next
5095:     Loop
5096:     If booNameExists = True Then
5097:       lngCounter = lngCounter + 1
5098:       strCounter = CStr(lngCounter)
5099:       If booRestrictTo13CharForGrid Then
5100:         strUniqueName = Left(strBaseName, 12 - Len(strCounter)) & "_" & strCounter
5101:       Else
5102:         strUniqueName = strBaseName & "_" & strCounter
5103:       End If
5104:     End If
5105:   Loop
5106:   MakeUniqueRasterName2 = strUniqueName
  

  Exit Function
ErrorHandler:
  HandleError True, "MakeUniqueRasterName2 " & c_sModuleFileName & " " & GetErrorLineNumberString(Erl), err.Number, err.Source, err.Description, 4
End Function



